unit ActivScp;

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  IID_IActiveScript: TGUID = '{BB1A2AE1-A4F9-11CF-8F20-00805F2CD064}';
  IID_IActiveScriptSite: TGUID = '{DB01A1E3-A42B-11CF-8F20-00805F2CD064}';
  IID_IActiveScriptError: TGUID = '{EAE1BA61-A4ED-11CF-8F20-00805F2CD064}';
  IID_IActiveScriptParse: TGUID = '{BB1A2AE2-A4F9-11CF-8F20-00805F2CD064}';
  IID_IActiveScriptSiteWindow: TGUID = '{D10F6761-83E9-11CF-8F20-00805F2CD064}';
  IID_IActiveScriptParseProcedure: TGUID = '{AA5B6A80-B834-11D0-932F-00A0C90DCAA9}';

  LIBID_Scripting: TGUID = '{420B2830-E718-11CF-893D-00A0C9054228}';
                           //420B2830-E718-11CF-893D-00A0C9054228
  Scripting_typelib_filename: string = 'scrrun.dll';
  IID_IDictionary: TGUID = '{42C642C1-97E1-11CF-978F-00A02463E06F}';
  ScriptingMajorVersion = 1;
  ScriptingMinorVersion = 0;

// IActiveScriptSite::GetItemInfo() input flags
const
  SCRIPTINFO_IUNKNOWN    = $00000001;
  SCRIPTINFO_ITYPEINFO	 = $00000002;
  SCRIPTINFO_ALL_FLAGS	 = $00000003; //(SCRIPTINFO_IUNKNOWN | SCRIPTINFO_ITYPEINFO)

// IActiveScript::AddNamedItem() input flags
const
  SCRIPTITEM_ISVISIBLE      = $00000002;
  SCRIPTITEM_ISSOURCE       = $00000004;
  SCRIPTITEM_GLOBALMEMBERS  = $00000008;
  SCRIPTITEM_ISPERSISTENT   = $00000040;
  SCRIPTITEM_CODEONLY       = $00000200;
  SCRIPTITEM_NOCODE         = $00000400;

// tagSCRIPTSTATE constants
type
  tagSCRIPTSTATE = TOleEnum;
const
  SCRIPTSTATE_UNINITIALIZED = $00000000;
  SCRIPTSTATE_INITIALIZED = $00000005;
  SCRIPTSTATE_STARTED = $00000001;
  SCRIPTSTATE_CONNECTED = $00000002;
  SCRIPTSTATE_DISCONNECTED = $00000003;
  SCRIPTSTATE_CLOSED = $00000004;

// tagSCRIPTTHREADSTATE constants
type
  tagSCRIPTTHREADSTATE = TOleEnum;
const
  SCRIPTTHREADSTATE_NOTINSCRIPT = $00000000;
  SCRIPTTHREADSTATE_RUNNING = $00000001;

type

  IActiveScript = interface;
  IActiveScriptSite = interface;
  IActiveScriptError = interface;
  IActiveScriptParse = interface;
  IActiveScriptSiteWindow = interface;
  IActiveScriptParseProcedure = interface;


// *********************************************************************//
// Interface: IActiveScript
// Flags:     (0)
// GUID:      {BB1A2AE1-A4F9-11CF-8F20-00805F2CD064}
// *********************************************************************//
  IActiveScript = interface(IUnknown)
    ['{BB1A2AE1-A4F9-11CF-8F20-00805F2CD064}']
    function SetScriptSite(const pass: IActiveScriptSite): HResult; stdcall;
    function GetScriptSite(var riid: TGUID; out ppvObject: Pointer): HResult; stdcall;
    function SetScriptState(ss: tagSCRIPTSTATE): HResult; stdcall;
    function GetScriptState(out pssState: tagSCRIPTSTATE): HResult; stdcall;
    function Close: HResult; stdcall;
    function AddNamedItem(pstrName: PWideChar; dwFlags: UINT): HResult; stdcall;
    function AddTypeLib(var rguidTypeLib: TGUID; dwMajor: UINT; dwMinor: UINT; dwFlags: UINT): HResult; stdcall;
    function GetScriptDispatch(pstrItemName: PWideChar; out ppdisp: IDispatch): HResult; stdcall;
    function GetCurrentScriptThreadID(out pstidThread: UINT): HResult; stdcall;
    function GetScriptThreadID(dwWin32ThreadId: UINT; out pstidThread: UINT): HResult; stdcall;
    function GetScriptThreadState(stidThread: UINT; out pstsState: tagSCRIPTTHREADSTATE): HResult; stdcall;
    function InterruptScriptThread(stidThread: UINT; var pexcepinfo: EXCEPINFO; dwFlags: UINT): HResult; stdcall;
    function Clone(out ppscript: IActiveScript): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IActiveScriptSite
// Flags:     (0)
// GUID:      {DB01A1E3-A42B-11CF-8F20-00805F2CD064}
// *********************************************************************//
  IActiveScriptSite = interface(IUnknown)
    ['{DB01A1E3-A42B-11CF-8F20-00805F2CD064}']
    function GetLCID(out plcid: UINT): HResult; stdcall;
    function GetItemInfo(pstrName: PWideChar; dwReturnMask: UINT; out ppiunkItem: IUnknown; 
                         out ppti: ITypeInfo): HResult; stdcall;
    function GetDocVersionString(out pbstrVersion: WideString): HResult; stdcall;
    function OnScriptTerminate(var pvarResult: OleVariant; var pexcepinfo: EXCEPINFO): HResult; stdcall;
    function OnStateChange(ssScriptState: tagSCRIPTSTATE): HResult; stdcall;
    function OnScriptError(const pscripterror: IActiveScriptError): HResult; stdcall;
    function OnEnterScript: HResult; stdcall;
    function OnLeaveScript: HResult; stdcall;
  end;


// *********************************************************************//
// Interface: IActiveScriptError
// Flags:     (0)
// GUID:      {EAE1BA61-A4ED-11CF-8F20-00805F2CD064}
// *********************************************************************//
  IActiveScriptError = interface(IUnknown)
    ['{EAE1BA61-A4ED-11CF-8F20-00805F2CD064}']
    function GetExceptionInfo(out pexcepinfo: EXCEPINFO): HResult; stdcall;
    function GetSourcePosition(out pdwSourceContext: UINT; out pulLineNumber: UINT; 
                               out plCharacterPosition: Integer): HResult; stdcall;
    function GetSourceLineText(out pbstrSourceLine: WideString): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IActiveScriptParse
// Flags:     (0)
// GUID:      {BB1A2AE2-A4F9-11CF-8F20-00805F2CD064}
// *********************************************************************//
  IActiveScriptParse = interface(IUnknown)
    ['{BB1A2AE2-A4F9-11CF-8F20-00805F2CD064}']
    function InitNew: HResult; stdcall;
    function AddScriptlet(pstrDefaultName: PWideChar; pstrCode: PWideChar; pstrItemName: PWideChar; 
                          pstrSubItemName: PWideChar; pstrEventName: PWideChar;
                          pstrDelimiter: PWideChar; dwSourceContextCookie: UINT;
                          ulStartingLineNumber: UINT; dwFlags: UINT; out pBstrName: WideString;
                          out pexcepinfo: EXCEPINFO): HResult; stdcall;
    function ParseScriptText(pstrCode: PWideChar; pstrItemName: PWideChar;
                             const punkContext: IUnknown; pstrDelimiter: PWideChar;
                             dwSourceContextCookie: UINT; ulStartingLineNumber: UINT;
                             dwFlags: UINT; out pvarResult: OleVariant; out pexcepinfo: EXCEPINFO): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IActiveScriptSiteWindow
// Flags:     (0)
// GUID:      {D10F6761-83E9-11CF-8F20-00805F2CD064}
// *********************************************************************//
  IActiveScriptSiteWindow = interface(IUnknown)
    ['{D10F6761-83E9-11CF-8F20-00805F2CD064}']
    function GetWindow(out wnd: HWnd): HResult; stdcall; //wireHWND
    function EnableModeless(fEnable: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// Interface: IActiveScriptParseProcedure
// Flags:     (0)
// GUID:      {AA5B6A80-B834-11D0-932F-00A0C90DCAA9}
// *********************************************************************//
  IActiveScriptParseProcedure = interface(IUnknown)
    ['{AA5B6A80-B834-11D0-932F-00A0C90DCAA9}']
    function ParseProcedureText(pstrCode: PWideChar; pstrFormalParams: PWideChar;
                                pstrProcedureName: PWideChar; pstrItemName: PWideChar;
                                const punkContext: IUnknown; pstrDelimiter: PWideChar;
                                dwSourceContextCookie: UINT; ulStartingLineNumber: UINT;
                                dwFlags: UINT; out ppdisp: IDispatch): HResult; stdcall;
  end;

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// Constants for enum CompareMethod
type
  CompareMethod = TOleEnum;
const
  BinaryCompare = $00000000;
  TextCompare = $00000001;
  DatabaseCompare = $00000002;

// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
type
  POleVariant1 = ^OleVariant; {*}

// *********************************************************************//
// Interface: IDictionary
// Flags:     (4432) Hidden Dual OleAutomation Dispatchable
// GUID:      {42C642C1-97E1-11CF-978F-00A02463E06F}
// *********************************************************************//
  IDictionary = interface(IDispatch)
    ['{42C642C1-97E1-11CF-978F-00A02463E06F}']
    procedure Set_Item(var Key: OleVariant; var pRetItem: OleVariant); safecall;
    procedure _Set_Item(var Key: OleVariant; var pRetItem: OleVariant); safecall;
    function  Get_Item(var Key: OleVariant): OleVariant; safecall;
    procedure Add(var Key: OleVariant; var Item: OleVariant); safecall;
    function  Get_Count: Integer; safecall;
    function  Exists(var Key: OleVariant): WordBool; safecall;
    function  Items: OleVariant; safecall;
    procedure Set_Key(var Key: OleVariant; Param2: POleVariant1); safecall;
    function  Keys: OleVariant; safecall;
    procedure Remove(var Key: OleVariant); safecall;
    procedure RemoveAll; safecall;
    procedure Set_CompareMode(pcomp: CompareMethod); safecall;
    function  Get_CompareMode: CompareMethod; safecall;
    function  _NewEnum: IUnknown; safecall;
    function  Get_HashVal(var Key: OleVariant): OleVariant; safecall;
    property Count: Integer read Get_Count;
    property Key[var Key: OleVariant]: POleVariant1 write Set_Key;
    property CompareMode: CompareMethod read Get_CompareMode write Set_CompareMode;
    property HashVal[var Key: OleVariant]: OleVariant read Get_HashVal;
  end;


//     
function GetIActiveScript(ScriptProgID: WideString;
                          out i_IActiveScript: IActiveScript): HResult;

implementation

// GetIActiveScript
function GetIActiveScript(ScriptProgID: WideString;
                          out i_IActiveScript: IActiveScript): HResult;
var
  clsid: TCLSID;
  hr: HResult;
begin
  i_IActiveScript := nil;
  hr := CLSIDFromProgID(PWideChar(ScriptProgID), clsid);
  if Succeeded(hr) then
    hr := CoCreateInstance(clsid, nil, CLSCTX_ALL, IID_IActiveScript, i_IActiveScript);
  result := hr;
end;

end.
