unit AppInfo;

interface

function GetCompName:string;
function GetProgName:string;
function GetShortPath:string;
function GetVersion:string;
function GetBuild:integer;
function GetReleaseVersion:integer;
function GetMinorVersion:integer;
function GetMajorVersion:integer;

implementation

uses QueryEx, SysUtils, Windows, {CmdPrms,} Dialogs,
     Controls, RXShell, Forms, Common,
     RXVerInf;

var
  FVerInfo: TVersionInfo;

function GetVersPart(num:integer):integer;
var ps,i:integer; str:string;
const EMSG='   ';
begin
  try
    try str:=FVerInfo.FileVersion;
    except raise Exception.Create(EMSG);
    end;
    if num>1 then
      for i:=1 to num-1 do
      begin
        ps:=pos('.',str);
        if ps=0 then raise Exception.Create(EMSG);
        str:=copy(str,ps+1,length(str)-ps);
      end;
    ps:=pos('.',str);
    if ps>0 then str:=copy(str,1, ps-1);
    try result:=StrToInt(str);
    except raise Exception.Create(EMSG);
    end;
  except on e:Exception do
   begin
     ErrorMsg(e.Message);
     result:=0;
   end;
  end;
end;

function GetVersion:string;
begin
   result:=copy(FVerInfo.FileVersion,1,Length(FVerInfo.FileVersion)-Length(IntToStr(GetBuild))-1);
end;

function GetBuild:integer;
begin
  result:=GetVersPart(4);
end;

function GetMajorVersion:integer;
begin
  result:=GetVersPart(1);
end;

function GetMinorVersion:integer;
begin
  result:=GetVersPart(2);
end;

function GetReleaseVersion:integer;
begin
  result:=GetVersPart(3);
end;


function GetProgName:string;
var i:integer; IsDebug:boolean;
begin
   result:=UpperCase(ExtractFileName(ParamStr(0)));
   IsDebug:=(result='DELPHI32.EXE');
   if IsDebug then
    for i:=1 to ParamCount do
     if pos('.EXE',ParamStr(i))>0 then
     begin
       result:=UpperCase(ExtractFileName(ParamStr(i)));
       break;
     end;
   if pos('.EXE',result)>0 then result:=copy(result,1,pos('.EXE',result)-1);
   if IsDebug then result:=result+'_DEBUG';
end;


function GetCompName:string;
var sz:Cardinal;
begin
   sz:=MAX_COMPUTERNAME_LENGTH + 1;
   SetLength(result,sz);
   GetComputerName(PChar(result),sz);
   SetLength(result,sz);
end;

function GetShortPath:string;
begin
   SetLength(result,MAX_PATH+1);
   SetLength(result, GetShortPathName(PChar(ParamStr(0)),PChar(result),MAX_PATH+1));
   result:=UpperCase(result);
end;


function FileDate(const FileName:string=''):TDateTime;
begin
  if FileName=''
    then result:=FileDateToDateTime(FileAge(GetShortPath))
    else result:=FileDateToDateTime(FileAge(FileName));
end;

{//  FSourceDir: string;
function IsNewVersionPresent:boolean;
var SourceName:string;
begin
  SourceName:=GetSourceDir+'\'+GetProgName+'.exe';
  result:=FileExists(SourceName) and (FileDate(SourceName)>FileDate);
end;
procedure UpdateVersion;
var i:integer; strpar, sFName:string;
begin
   if IsNewVersionPresent then
   begin
     if MessageDlg('  '#10#13' .'#10#13#10#13'?',mtInformation,[mbYes,mbNo],0)=mrYes then
     begin
        if ParamCount>0 then
          for i:=1 to ParamCount do strpar:=strpar+ParamStr(i)+' ';
        sFName := GetSourceDir+'\..\ChngVers\ChngVers.exe';
        if FileExecute(sFName, GetShortPath+' '+GetSourceDir+' '+strpar,'',esNormal)>32 then
        begin
           RaiseProjectCloseException;
        end;
     end;
   end;
end;}

initialization
  FVerInfo:=TVersionInfo.Create(Application.ExeName);

finalization
  FVerInfo.Free;

end.
