unit ClndrFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, Calendar, Mask, ToolEdit, Placemnt,
  CFClndr;

type

  TPickDate = class(TForm)
    Calendar: TStockCFCalendar;
    Panel1: TPanel;
    Panel2: TPanel;
    PlusYear: TSpeedButton;
    PlusMonth: TSpeedButton;
    MinusYear: TSpeedButton;
    MinusMonth: TSpeedButton;
    Panel3: TPanel;
    btOk: TBitBtn;
    btCancel: TBitBtn;
    DateEdit1: TDateEdit;
    FormPlacement1: TFormPlacement;
    BitBtn1: TSpeedButton;
    btOpening: TSpeedButton;
    btClosing: TSpeedButton;
    procedure PlusYearClick(Sender: TObject);
    procedure PlusMonthClick(Sender: TObject);
    procedure MinusMonthClick(Sender: TObject);
    procedure MinusYearClick(Sender: TObject);
    procedure CalendarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CalendarChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btOkClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CalendarGetDateStatus(aDate: TDateTime;
      var Status: TEnumStatus);
    procedure FormDeactivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PickDate: TPickDate;

implementation

{$R *.DFM}
uses
	Global,DataMdl, Main;

procedure TPickDate.PlusYearClick(Sender: TObject);
begin
 Calendar.NextYear;
end;

procedure TPickDate.PlusMonthClick(Sender: TObject);
begin
 Calendar.NextMonth;
end;

procedure TPickDate.MinusMonthClick(Sender: TObject);
begin
 Calendar.PrevMonth;
end;

procedure TPickDate.MinusYearClick(Sender: TObject);
begin
 Calendar.PrevYear;
end;

procedure TPickDate.CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case Key of
 VK_PRIOR : if ( ssCtrl in Shift ) then MinusYear.Click
                                   else MinusMonth.Click;
 VK_NEXT  : if ( ssCtrl in Shift ) then PlusYear.Click
                                   else PlusMonth.Click;
 end;
end;

procedure TPickDate.CalendarChange(Sender: TObject);
begin
 btCancel.Enabled:=true;
 Panel3.Caption := FormatDateTime( 'd mmmm yyyy',
   EncodeDate( Calendar.Year, Calendar.Month, Calendar.Day ) );
 Caption := '  - ' + FormatDateTime( 'c', Calendar.CalendarDate );
end;

procedure TPickDate.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_F2 then Calendar.CalendarDate := SysUtils.Date;
end;

procedure TPickDate.btOkClick(Sender: TObject);
begin
   Close;
end;

procedure TPickDate.btCancelClick(Sender: TObject);
begin
   Close;
end;

procedure TPickDate.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action:=caFree;
end;

procedure TPickDate.CalendarGetDateStatus(aDate: TDateTime;
  var Status: TEnumStatus); {IsOrdinary,IsClosed,IsOpened}
var
//   qstr:string;
	res:variant;
begin
   res:=null;
//   qstr:=FormatDateTime(frmtDataSQL1,aDate);
//   res:=dmMain.qStatusDay.Lookup('Data',aDate,'IdStatus');
   if res=null
      then Status:=IsOrdinary
      else if res=2
         then Status:=IsClosed
         else if res=1
            then Status:=IsOpened
            else Status:=IsOrdinary;
end;

procedure TPickDate.FormDeactivate(Sender: TObject);
begin
	Close;
end;

procedure TPickDate.BitBtn1Click(Sender: TObject);
begin
	Calendar.CalendarDate := SysUtils.Date;
end;

procedure TPickDate.FormCreate(Sender: TObject);
begin
    CalendarChange( Sender );
    Calendar.CalendarDate:=SysUtils.Date;
end;

end.
