unit Common;

interface

uses forms, comctrls, classes, sysutils;

var
// 
  stmp:string;
  itmp:integer;
  ctmp:currency;
  vtmp:variant;
  btmp:boolean;
  ptmp:pointer;


procedure gvbeep(Freq{},Duration:word{});
procedure GoMessage(Msg:Cardinal);
function IncStrNumber(const StrNumber:string): string;
//function ParentProcessName : String;
function RoundMoney(Value:Currency):Currency;
function iif(comparison:boolean;expr1:variant;expr2:variant):variant;
function IsNull(Expr,ReplExpr:Variant):Variant;
function GetOneForm(FormClass:TFormClass):TForm;
function GetOneFormExt(FormClass:TFormClass; Owner: TForm =nil ):TForm;

procedure ErrorMsg(const txt:string);
procedure WarningMsg(const txt:string);
function Confirmation(const txt:string):boolean;

function WinToDos(const src:string):string;
procedure Win2Dos(var str:string);

procedure SmartStatusBarPanelText(StatusBar: TStatusBar; PanelNum: integer; Text: string);

Procedure SQLStrOrderBy(var sSQL:String; sOrderBy: string);

const
  cnstOrderBy = 'ORDER BY ';

implementation

uses Windows, Dialogs, Controls;


Procedure SQLStrOrderBy(var sSQL:String; sOrderBy: string);
begin
  sSQL := sSQL + ' ' + cnstOrderBy + sOrderBy;
end;

{Procedure DrawOnDesktop;
Var DC:HDC;
    DesktopCanvas:TCanvas;
begin
  DC:=GetDC(0);   //  DC  
  try
     DesktopCanvas:=TCanvas.Create;
     try
       DesktopCanvas.Handle:=DC;
     //     ..................
     //    Canvas  
     //     ..................
     finally
       DesktopCanvas.Free;
     end;
  finally
    ReleaseDC(0,DC);
  end;
end;}


function WinToDos(const src:string):string;
begin
  SetLength(result,Length(src));
  CharToOEM(Pchar(src),Pchar(result));
end;

procedure Win2Dos(var str:string);
var str2:string;
begin
  SetLength(str2,Length(str));
  CharToOEM(Pchar(str),Pchar(str2));
  str:=str2;
end;


{x$O-} // Optimization OFF
{function ParentProcessName : String;
var
 SnapShot : THandle;
 ProcessFound : BOOL;
 ParentProcessId : DWORD;
 lppe: TProcessEntry32;
 MyName : String;
begin
// ParentProcessId := 0;
 Result := ''; }
{ MyName := ParamStr( 0 );
 SnapShot := CreateToolhelp32Snapshot( TH32CS_SNAPALL, 0 );
 try
  ProcessFound := Process32First( Snapshot,  lppe );
  while ProcessFound do begin
   if AnsiCompareText( StrPas( lppe.szExeFile ), MyName ) = 0 then
    ParentProcessId := lppe.th32ParentProcessId;
   ProcessFound := Process32Next( Snapshot, lppe );
  end;
  ProcessFound := Process32First( Snapshot,  lppe );
  while ProcessFound do begin
   if lppe.th32ProcessId = ParentProcessId then
    Result := AnsiUpperCase( ExtractFileName( StrPas( lppe.szExeFile ) ) );
   ProcessFound := Process32Next( Snapshot, lppe );
  end;
 finally
  CloseHandle( SnapShot );
 end;
end;  }
{x$O+}


function IncStrNumber(const StrNumber:string): string;
var part_b,part_e:string; num,i:Integer;
label BEGINS_WITH_NUMERIC;
begin
  if (trim(StrNumber)='') then
  begin
    result:='1';
    Exit;
  end;
  for i:=length(StrNumber) downto 1 do
  begin
    if (StrNumber[i] in ['0'..'9']) then
    begin
      part_e:=copy(StrNumber,i+1,length(StrNumber)-i);
      part_b:=copy(StrNumber,1,i);
      break;
    end;
  end;
  if (part_e='') and (part_b='') then
  begin
    result:=StrNumber+'-1';
    Exit;
  end;
  for i:=length(part_b)-1 downto 1 do
  begin
    if not (part_b[i] in ['0'..'9']) then
    begin
      num:=StrToInt(copy(part_b,i+1,length(part_b)-i));
      part_b:=copy(part_b,1,i);
      goto BEGINS_WITH_NUMERIC;
    end;
  end;
  num:=StrToInt(part_b);
  part_b:='';

BEGINS_WITH_NUMERIC:
  result:=part_b+IntToStr(num+1)+part_e;
end;


function GetOneFormExt(FormClass:TFormClass; Owner: TForm =nil ):TForm;
var i:integer; Instance: TComponent;
label FORM_FOUND;
begin

  for I := 0 to Screen.CustomFormCount-1 do
    If Screen.CustomForms[i] is FormClass Then
      begin
        result:=(Screen.CustomForms[i] as FormClass);
        goto FORM_FOUND;
      end;

  If Owner=nil Then
    Application.CreateForm(FormClass,result)
  else begin
    Instance := TComponent(FormClass.NewInstance);
    TComponent(result) := Instance;
    try
      Instance.Create(Owner);
    except
      TComponent(result) := nil;
      raise;
    end;
  end;
FORM_FOUND:
  result.Show;
  //SaveFormClass(result.ClassName);
end;

function GetOneForm(FormClass:TFormClass):TForm;
var i:integer;
label FORM_FOUND;
begin
  with Application do
    for i:=0 to ComponentCount-1 do
      if Components[i] is FormClass then
      begin
        result:=(Components[i] as FormClass);
        goto FORM_FOUND;
      end;
  Application.CreateForm(FormClass,result);
FORM_FOUND:
  result.Show;
  //SaveFormClass(result.ClassName);
end;

procedure gvbeep(Freq{},Duration:word{});
begin
  if Win32Platform=VER_PLATFORM_WIN32_NT
    then Windows.Beep(Freq,Duration)
    else begin
           asm
             movzx ecx,Freq
             mov eax,1193180
             sub edx,edx
             div ecx
             mov ecx,eax
        //set timer #3
             mov al,182
             out 43h,al
             mov al,cl
             out 42h,al
             mov al,ch
             out 42h,al
        //enable speaker
             in al,61h
             or al,3
             out 61h,al
           end;
           sleep(Duration);
           asm
             in al,61h
             and al,0fch
             out 61h,al
           end;
         end;
end;

function IsNull(Expr,ReplExpr:Variant):Variant;
begin if Expr=Null then result:=ReplExpr else result:=Expr; end;

function RoundMoney(Value:Currency):Currency;
var  IntPart,FractPart:Currency; IsNegative:boolean;
begin
   if Value<0 then IsNegative:=true else IsNegative:=false;
   IntPart:=Int(Abs(Value));
   FractPart:=Abs(Value)-IntPart;
   FractPart:=Round(FractPart*100)/100;
   result:=IntPart+FractPart;
   if IsNegative then result:=-result;
end;

function iif(comparison:boolean;expr1:variant;expr2:variant):variant;
begin if comparison then result:=expr1 else result:=expr2; end;


procedure ErrorMsg(const txt:string);
begin
	MessageDlg(txt,mtError,[mbAbort],0);
end;

procedure WarningMsg(const txt:string);
begin
	MessageDlg(txt,mtWarning,[mbOK],0);
end;

function Confirmation(const txt:string):boolean;
begin
  result:=false;
  if MessageDlg(txt,mtConfirmation,[mbYes,mbNo],0)=mrYes then
    result:=true;
end;


procedure GoMessage(Msg:Cardinal);
var i:integer;
begin
 PostMessage(Forms.Application.MainForm.Handle,Msg,0,0);
 for i:=0 to Forms.Application.MainForm.MDIChildCount-1 do
   if (Forms.Application.MainForm.MDIChildren[i] is TForm) then
     PostMessage((Forms.Application.MainForm.MDIChildren[i] as TForm).Handle,Msg,0,0);
end;

procedure SmartStatusBarPanelText(StatusBar: TStatusBar; PanelNum: integer; Text: string);
var
  StatusPanel: TStatusPanel;
  iWidth : integer;
begin
  StatusPanel := StatusBar.Panels[PanelNum];
  iWidth:= StatusBar.Canvas.TextWidth(Text);
  if StatusPanel.Width < (iWidth+6) then
    StatusPanel.Width := iWidth+6;
  StatusPanel.Text := Text;
end;

end.
