unit CommonVV;

interface
uses SysUtils, Classes, Windows, Dialogs, Graphics, Forms, controls, DB, DBTables, dbctrls,
     DBGrids, Menus, rxDBCtrl, Placemnt, AppUtils, VCLUtils, registry, UpdQuery;

type
  TIntegerObj = class
  public
    I: integer;
    constructor Create(ii: integer);
  end;


function ReplaceString( NewStr, ReplaceStr, Data : string ) : string;
function ReplaceChars( S : string; OldCh, NewCh : Char ) : string;
function ReplaceDateFmt( S : string; Date : TDateTime ) : string; //  %dd%  %mm%  %yyyy%'
function ReplicateChr( Ch : Char; Cnt : integer ) : string;
function Padr( Str : string; StrLen : integer ) : string;
function Padl( Str : string; StrLen : integer ) : string;
function SetSMacrosByName(SQL: string; MacroName, MacroValue : string ) : string;


procedure FindRecord(WinControl: TWinControl);
procedure SortQuery(WinControl: TWinControl);
procedure FilterDataSet(Grid: TDBGrid);

procedure ChangeSortOrder( aDataSet : TDataSet );
procedure myFindDialog( dataSet : TDataSet; aGrid : TDBGrid; sDefFldNm : string );
procedure myFilterDialog( dataSet : TDataSet; fltDBGrid: TDBGrid );


procedure ResortDataSetByField( aDataSet : TDataSet; aFld : TField);
procedure myInformationDialog( dataSet : TDataSet; ShowSort: Boolean );
{procedure mySetFixColl( aGrid : TrxDBGrid );}
procedure ExecSP(spName: string; spParams: TParams);


function GetSQLWithoutOrderBy(aQuery : TQuery) : string;
function getOrderBy( aDataSet : TDataSet ) : string;
procedure setOrderBy( aDataSet : TDataSet; sOrderBy : string );
procedure SetMacrosByName(aDataSet : TDataSet; MacroName, MacroValue : string );

procedure SaveOrderBy( frmPlc : TFormPlacement; aDataSet : TDataSet );
procedure RestoreRegIniOrderBy( aDataSet : TDataSet);
function isNotFixCol( aDBGrid : TrxDBGrid; Field : TField ) : Boolean;
procedure setMyDeffaultColl( aDataSet : TDataSet );
procedure setMyDeffCollWidth( aDataSet : TDataSet );
//function strBindParams( sin : string; aParAskList : TList ) : string;

function FloatToSQLStr(fValue: Extended): String;
function SQLstrToFloat(sValue: String): Double;



const
   SelectColor = $00D0FFFF;
   //SelectForegrHighlightColor = $00D0FFFF;
   SelectBackgrHighlightColor = clActiveCaption;
   myVeryLiteGreen  = $00D8FFD8;  // //$00B3FDAC
   myVeryLiteYellow = $00D8FFFF;  //  //$00ACF9FD
   myVeryLiteRed    = $00D8D8FF;  // //$00B0B0F9

   frmtCurr = '#,##0.00';
   frmtDataSQL = 'mm.dd.yyyy';


implementation

uses QueryEx, dlgOrd, NFindDlg, dlgFilt, Common;

function FloatToSQLStr(fValue: Extended): String;
begin
  result := FormatFloat('#0.00', fValue);
  result := ReplaceChars(result, DecimalSeparator, '.');
end;

function SQLstrToFloat(sValue: String): Double;
begin
  sValue := ReplaceChars(sValue, '.', DecimalSeparator);
  result := StrToFloat(sValue);
end;

constructor TIntegerObj.Create(ii: integer);
begin
  i := ii;
end;


procedure ChangeSortOrder( aDataSet : TDataSet );
begin
   with TdlgOrder.CreateDlg( Application, aDataSet ) do
   begin
     ShowModal;
     Release;
   end;
end;

procedure RefreshQuery( aQuery : TQuery );
var
   SavedParams : TParams;
begin
   SavedParams := TParams.Create;
   try
      begin
         SavedParams.Assign( aQuery.Params );
         aQuery.DisableControls;
         aQuery.Close;
         aQuery.Prepare;
         aQuery.Params.Assign( SavedParams );
         aQuery.Open;
         aQuery.FetchAll;
         aQuery.First;
         aQuery.EnableControls;
      end;
   finally
      SavedParams.Free;
   end;
end;


procedure FindRecord(WinControl:TWinControl);
var
 dbGrid: TDBGrid;
 dbEdit: TDBEdit;
begin
  if WinControl is TDBGrid then
    begin
    dbGrid := WinControl as TDBGrid;
    myFindDialog(dbGrid.DataSource.DataSet, dbGrid, dbGrid.SelectedField.FieldName);
    end;
  if WinControl is TDBEdit then
    begin
    dbEdit := WinControl as TDBEdit;
    myFindDialog(dbEdit.DataSource.DataSet, nil, dbEdit.DataField);
    end;
end;

procedure SortQuery(WinControl:TWinControl);
var
 dbGrid: TDBGrid;
 dbEdit: TDBEdit;
begin
  if WinControl is TDBGrid then
    begin
      dbGrid := TDBGrid(WinControl);
      ChangeSortOrder(dbGrid.DataSource.DataSet);
    end;
  if WinControl is TDBEdit then
    begin
      dbEdit := TDBEdit(WinControl);
      ChangeSortOrder(dbEdit.DataSource.DataSet);
    end;
end;

procedure FilterDataSet(Grid:TDBGrid);
begin
  myFilterDialog(Grid.DataSource.DataSet, Grid);
end;

{procedure RefreshSP( aSP : TStoredProc );
var
   SavedParams : TParams;
begin
   SavedParams := TParams.Create;
   try
      begin
         SavedParams.Assign( aSP.Params );
         aSP.DisableControls;
         aSP.Close;
         aSP.Prepare;
         aSP.Params.Assign( SavedParams );
         aSP.Open;
         aSP.FetchAll;
         aSP.First;
         aSP.EnableControls;
      end;
   finally
      SavedParams.Free;
   end;
end;


procedure ReopenQuery( aQuery : TQuery; sSQL : string );
var
  SavedParams : TParams;
begin
   SavedParams := TParams.Create;
   SavedParams.Assign( aQuery.Params );
   aQuery.DisableControls;
   try
     aQuery.Close;
     aQuery.SQL.Clear;
     aQuery.SQL.Add( sSQL );
     aQuery.Prepare;
     aQuery.Params.Assign( SavedParams );
     aQuery.Open;
    finally
     aQuery.EnableControls;
     SavedParams.Free;
   end;
end;
}



procedure myFindDialog( dataSet : TDataSet; aGrid : TDBGrid; sDefFldNm : string );
var
   dlgnFind : TdlgnFind;
begin
   dlgnFind := TdlgnFind.MyCreate( Application, dataSet, aGrid, sDefFldNm );
   dlgnFind.ShowModal;
   dlgnFind.Release;
end;

procedure myFilterDialog( dataSet: TDataSet; fltDBGrid: TDBGrid );
var
   dlgFilter : TdlgFilter;
begin
   dlgFilter := TdlgFilter.MyCreate( Application, dataSet, fltDBGrid);
   dlgFilter.ShowModal;
   dlgFilter.Release;
end;


procedure myInformationDialog( dataSet : TDataSet;  ShowSort: Boolean );
var
   sMsg, ss : string;
begin
   if dataSet = nil then exit;
   sMsg := '  : ';
   sMsg := sMsg + IntToStr( dataSet.RecordCount );

   if ( dataSet is TQuery ) and ShowSort then
      begin
         sMsg := sMsg + Chr( 13 ) + Chr( 10 ) + ' : ';
         ss := getOrderBy( dataSet as TQuery );
         sMsg := sMsg + Copy( ss, Pos( 'ORDER BY', UpperCase( ss ) ) + 9, length( ss ) );
      end;

   if dataSet.Filtered = True then
      begin
         sMsg := sMsg + Chr( 13 ) + Chr( 10 ) + ' : ';
         sMsg := sMsg + dataSet.Filter;
      end;

   MsgBox( '   ', sMsg, MB_OK );
end;


{
procedure mySetFixColl( aGrid : TrxDBGrid );
var
   paramAskMe : TParamAskMe;
   aParAskList : TParamAskMeList;
begin
   paramAskMe := TParamAskMe.Create( '  :', prmInteger, 'FIXCOL' );
   paramAskMe.Width := 100;
   paramAskMe.Value := aGrid.FixedCols;
   aParAskList := TParamAskMeList.Create;
   aParAskList.Add( paramAskMe );
   if AskMeParams( '  ', aParAskList ) then
      begin
         aGrid.FixedCols := paramAskMe.Value;
      end;
  aParAskList.Free;
end;
}


procedure ResortDataSetByField( aDataSet : TDataSet; aFld : TField);
var
   aLeftList, aRightList, sortFieldList : TMyFieldList;
   aFldRec, newFldRec : TMyFieldRec;
begin
 aLeftList := TMyFieldList.Create;
 aRightList := TMyFieldList.Create;
 sortFieldList:= TMyFieldList.Create;
 try
  readFieldsOrdList(aLeftList, aRightList, aDataSet);
  aFldRec := aRightList.getFieldByName(aFld.FieldName);
  if Assigned(aFldRec)
    then aFldRec.Desc := not aFldRec.Desc
    else aFldRec := aLeftList.getFieldByName(aFld.FieldName);
  if assigned(aFldRec) then
    begin
      newFldRec := TMyFieldRec.Create(aFldRec.num, aFldRec.FieldName,
                                    aFldRec.DisplayLabel, aFldRec.DataType,
                                    aFldRec.FieldKind, aFldRec.KeyFields);
    //  newFldRec .  sortFieldList
      newFldRec.Desc := aFldRec.Desc;
      sortFieldList.Add(newFldRec);
      ResortDataSet(aDataSet, sortFieldList);
    end;
 finally
   FreeAndNil(sortFieldList);
   FreeAndNil(aRightList);
   FreeAndNil(aLeftList);
 end;
end;



function ReplaceString( NewStr, ReplaceStr, Data : string ) : string;
var
   OffSet : Integer;
begin
   OffSet := Pos( ReplaceStr, Data );
   if OffSet > 0 then
      begin
         Delete( Data, OffSet, Length( ReplaceStr ) );
         Insert( NewStr, Data, OffSet );
      end;
   Result := Data;
end;

function ReplaceChars( S : string; OldCh, NewCh : Char ) : string;
var
   Len : Integer;
   i : Integer;
begin
   Len := Length( S );
   for i := 1 to Len do
      if S[i] = OldCh then
         S[i] := NewCh;
   Result := S;
end;

function ReplicateChr( Ch : Char; Cnt : integer ) : string;
var
   sss : string;
   i : Integer;
begin
   sss := '';
   for i := 1 to Cnt do
      sss := sss + Ch;
   Result := sss;
end;

function Padr( Str : string; StrLen : integer ) : string;
begin
   if Length( Str ) > StrLen then
      Result := Copy( Str, 1, StrLen )
   else
      Result := Str + ReplicateChr( ' ', StrLen - Length( Str ) );
end;

function Padl( Str : string; StrLen : integer ) : string;
begin
   if Length( Str ) > StrLen then
      Result := Copy( Str, 1, StrLen )
   else
      Result := ReplicateChr( ' ', StrLen - Length( Str ) ) + Str ;
end;


function GetSQLWithoutOrderBy(aQuery : TQuery) : string;
var
  jj : integer;
begin
  result := trim( aQuery.SQL.Text );
  jj := Pos( 'ORDER BY', UpperCase( result ) );
  if jj > 0 then result := Trim( Copy( result, 1, jj - 1 ) );
end;

function getOrderBy( aDataSet : TDataSet ) : string;
var
   sSQL : string;
   jj : integer;
   aQuery : TQuery;
begin
   if ( aDataSet is TQuery ) then
      begin
         aQuery := TQuery( aDataSet );
         sSQL := trim( aQuery.SQL.Text );

         jj := Pos( 'ORDER BY', UpperCase( sSQL ) );
         if jj > 0 then
            result := Trim( Copy( sSQL, jj, length( sSQL ) ) )
         else
            result := '';
      end;

   if ( aDataSet is TStoredProc ) and
      (isResortedSP(aDataSet as TStoredProc)) then
      begin
      result := (aDataSet as TStoredProc).ParamByName(cnstSPparSortPart).AsString;
      end;
end;

//  %dd%  %mm%  %yyyy% %yy%'

function ReplaceDateFmt( S : string; Date : TDateTime ) : string;
var
   Year, Month, Day : Word;
   ss : string;
begin
   result := S;
   DecodeDate( Date, Year, Month, Day );
   ss := Format( '%2d', [Day] );
   result := ReplaceString( ReplaceChars( ss, ' ', '0' ), '%dd%', result );
   ss := Format( '%2d', [Month] );
   result := ReplaceString( ReplaceChars( ss, ' ', '0' ), '%mm%', result );
   ss := Format( '%4d', [Year] );
   result := ReplaceString( ReplaceChars( ss, ' ', '0' ), '%yyyy%', result );

   ss := Format( '%4d', [Year] );
   result := ReplaceString( Copy( ReplaceChars( ss, ' ', '0' ), 3, 2 ), '%yy%', result );
end;

procedure setOrderBy( aDataSet : TDataSet; sOrderBy : string );
var
   sSQL : string;
   aQuery : TQuery;
begin
   if ( aDataSet is TQuery ) then
      begin
         aQuery := TQuery( aDataSet );
         if length( sOrderBy ) > 1 then
            begin
               sSQL := GetSQLWithoutOrderBy(aQuery);
               sSQL := sSQL + ' ' + sOrderBy;
               aQuery.SQL.Text := sSQL ;
            end;
      end;
   if ( aDataSet is TStoredProc ) and
      (isResortedSP(aDataSet as TStoredProc)) then
      begin
      (aDataSet as TStoredProc).ParamByName(cnstSPparSortPart).AsString := sOrderBy;
      end;
end;

procedure SaveOrderBy( frmPlc : TFormPlacement; aDataSet : TDataSet );
var
   regIniFile : TRegIniFile;
begin
   if not assigned(frmPlc.RegIniFile) then Exit;
   regIniFile := frmPlc.RegIniFile;
   regIniFile.WriteString(aDataSet.Owner.ClassName + aDataSet.Name,
                       'OrderBy', getOrderBy( aDataSet ) );
end;


procedure RestoreRegIniOrderBy( aDataSet : TDataSet);
var
   regIniFile : TRegIniFile;
   sOrderBy : string;
begin
   regIniFile := TRegIniFile.Create(GetDefaultIniRegKey);
   try
      sOrderBy := regIniFile.ReadString( aDataSet.Owner.ClassName + aDataSet.Name, 'OrderBy', '' );
      setOrderBy(aDataSet, sOrderBy);
   finally
      regIniFile.Free;
   end;
end;


function isNotFixCol( aDBGrid : TrxDBGrid; Field : TField ) : Boolean;
var
   i : integer;
begin
   result := True;
   for i := 0 to aDBGrid.FixedCols - 1 do
      if aDBGrid.Columns.Items[i].Field = Field then result := False;
end;


procedure setMyDeffaultColl( aDataSet : TDataSet );
var
   i : integer;
begin
   for i := 0 to aDataSet.FieldCount - 1 do
      begin
         if aDataSet.Fields[i].DataType = ftFloat then
            with TFloatField( aDataSet.Fields[i] ) do
               if ( Currency = False ) and ( length( DisplayFormat ) < 1 ) then
                  DisplayFormat := '0.00########';
      end;
end;


procedure setMyDeffCollWidth( aDataSet : TDataSet );
var
   i : integer;
begin
   for i := 0 to aDataSet.FieldCount - 1 do
      begin
         if aDataSet.Fields[i].DataType = ftFloat then
            with TFloatField( aDataSet.Fields[i] ) do
               if ( Currency = False ) and ( length( DisplayFormat ) < 1 ) then
                  DisplayFormat := '0.00########';
         if aDataSet.Fields[i].DataType = ftCurrency then
            aDataSet.Fields[i].DisplayWidth := 20;
      end;
end;


{function strBindParams( sin : string; aParAskList : TList ) : string;
var
   i, nPar, nEndPar : integer;
   bFind : Boolean;
   sOut, sEnd, sParNm, sParVal, ss : string;
   aParamAskMe : TParamAskMe;
begin
   result := '';
   sOut := '';
   sEnd := sin;

   while length( sEnd ) > 0 do
      begin
         nPar := Pos( 'PARAMS.', UpperCase( sEnd ) );
         if nPar = 0 then
            begin
               sOut := sOut + Copy( sEnd, 1, length( sEnd ) );
               break;
            end
         else
            begin
               ss := Copy( sEnd, nPar, length( sEnd ) );
               if Pos( ' ', ss ) > 0 then
                  nEndPar := nPar + Pos( ' ', ss ) - 1
               else
                  nEndPar := nPar + length( ss );

               sParNm := Copy( sEnd, nPar + 7, nEndPar - ( nPar + 7 ) );

               bFind := False;
               for i := 0 to aParAskList.Count - 1 do
                  begin
                     aParamAskMe := TParamAskMe( aParAskList.Items[i] );
                     if UpperCase( aParamAskMe.parName ) = UpperCase( sParNm ) then
                        begin
                           bFind := True;
                           case aParamAskMe.Typ of
                              prmString :
                                 sParVal := aParamAskMe.sValue;
                              prmDate :
                                 sParVal := DateToStr( aParamAskMe.dValue );
                              prmMoney :
                                 sParVal := FormatFloat( frmtCurr, aParamAskMe.fValue );
                              prmDouble :
                                 sParVal := FloatTostr( aParamAskMe.fValue );
                              prmInteger :
                                 sParVal := IntToStr( aParamAskMe.iValue );
                              prmDBLookup :
                                 sParVal := aParamAskMe.sValue;
                           end;
                           break;
                        end;
                  end;

               if bFind then
                  begin
                     sOut := sOut + Copy( sEnd, 1, nPar - 1 ) + sParVal; //+ ' ';
                     sEnd := Copy( sEnd, nEndPar, length( sEnd ) );
                  end
               else
                  begin
                     sOut := sOut + Copy( sEnd, 1, nEndPar );
                     sEnd := Copy( sEnd, nEndPar, length( sEnd ) );
                  end;
            end;
      end;
   result := sOut;
end;}



function SetSMacrosByName(SQL: string; MacroName, MacroValue : string ) : string;
var
  sEnd: string;
  nMacrPos, nMacrLen: integer;
  Found: Boolean;
const
  sMacrosPre = '%%';
  function NameDelimiter(C: Char): Boolean;
  begin
    Result := C in [' ', ',', ';', ')', '.', #13, #10];
  end;
begin
  nMacrLen := Length(MacroName) + Length(sMacrosPre);
  sEnd := SQL;
  repeat
    nMacrPos := Pos( sMacrosPre+MacroName, sEnd  );
    Found := (nMacrPos > 0) and
             ((Length(sEnd) = nMacrPos + nMacrLen) or
               NameDelimiter(sEnd[nMacrPos + nMacrLen]));
    if Found then
    begin
      Delete(sEnd, nMacrPos, nMacrLen);
      Insert(MacroValue, sEnd, nMacrPos);
    end;
  until not Found;
  result := sEnd;
end;

procedure SetMacrosByName(aDataSet : TDataSet; MacroName, MacroValue : string );
var
  aQuery : TQuery;
  aUpdQuery : TUpdQuery;
begin
  if ( aDataSet is TQuery ) then
  begin
    aQuery := TQuery( aDataSet);
    aQuery.SQL.Text := SetSMacrosByName(aQuery.SQL.Text, MacroName, MacroValue);
  end;
  if ( aDataSet is TUpdQuery ) then
  begin
    aUpdQuery := TUpdQuery( aDataSet);
    aUpdQuery.ModifySQL.Text := SetSMacrosByName(aUpdQuery.ModifySQL.Text, MacroName, MacroValue);
    aUpdQuery.InsertSQL.Text := SetSMacrosByName(aUpdQuery.InsertSQL.Text, MacroName, MacroValue);
    aUpdQuery.DeleteSQL.Text := SetSMacrosByName(aUpdQuery.DeleteSQL.Text, MacroName, MacroValue);
  end;
end;

procedure ExecSP(spName: string; spParams: TParams);
var
  aStoredProc : TStoredProc;
begin
  aStoredProc := TStoredProc.Create(Application);
  try
    with aStoredProc do
    begin
      DatabaseName := GetDBName;//glDatabaseName;
      StoredProcName := spName;
      Params.Assign(spParams);
      Prepare;
      ExecProc;
      spParams.AssignValues(Params);
      Close;
    end;
  finally
    if assigned(aStoredProc) then aStoredProc.Free;
  end;
end;



end.

