unit DataSet2Excel;

interface

uses Forms, Dialogs, DB, ComObj, SysUtils;

const
  xlMaximized = $FFFFEFD7;
  xlWorkbookNormal = $FFFFEFD1;
  xlNoChange = $00000001;
  xlLocalSessionChanges = $00000002;

procedure DataSetToExcelSheet(DataSet: TDataSet; xlSheet: OleVariant);

function DataSetToExcelExt(DataSet: TDataSet; fName: string;
                        bCreateNewExcel, bShowExcel: Boolean): boolean;

implementation


procedure DataSetToExcelSheet(DataSet: TDataSet; xlSheet: OleVariant);
var
  CellFrom, CellTo : string;
  fvalue, varArrVals, varCurRow : variant;
  i,j:integer;
  bkmark :TBookmarkStr;
begin
  DataSet.DisableControls;
  bkmark:=DataSet.Bookmark;
  try
    varArrVals := VarArrayCreate([1, DataSet.RecordCount+1], varVariant);
    varCurRow := VarArrayCreate([1, DataSet.FieldCount], varVariant);
    for j:=0 to DataSet.FieldCount-1 do
      begin
      fvalue := DataSet.Fields[j].FieldName;
      varCurRow[j+1] := fvalue;
      end;
    varArrVals[1] := varCurRow;

    DataSet.First;
    i:=2;
    while not DataSet.EOF do
    begin
      for j:=0 to DataSet.FieldCount-1 do
      begin
        fvalue:= DataSet.Fields[j].AsString; //DataSet.Fields[j].Value;
        varCurRow[j+1] := fvalue;
      end;
      varArrVals[i] := varCurRow;
      DataSet.Next;
      Inc(i);
    end;

    CellFrom := 'A1';
    CellTo   := Char(Word('A')+DataSet.FieldCount-1)+IntToStr(i-1);
    xlSheet.Range[CellFrom, CellTo].FormulaArray  := varArrVals;

    xlSheet.Cells[1,1].Select;
    xlSheet.Rows[1].Font.Bold:=true;
    xlSheet.Columns.AutoFit;

  finally
    DataSet.Bookmark := bkmark;
    DataSet.EnableControls;
  end;
end;



function DataSetToExcelExt(DataSet: TDataSet; fName: string;
                        bCreateNewExcel, bShowExcel: Boolean): boolean;
var
  xlApplication, xlWorkbooks, xlWorkbook, xlSheet : OleVariant;
begin
  result := false;

  // 1. open Excel
  if bCreateNewExcel then
    begin
    xlApplication := CreateOLEObject('Excel.Application');
    end
  else
    begin
    try
      xlApplication := GetActiveOLEObject('Excel.Application');
    except
      xlApplication := CreateOLEObject('Excel.Application');
      end;
    end;
  if VarType(xlApplication) <> VarDispatch then
    begin
    MessageDlg('Excel  !',mtError,[mbAbort],0);
    Exit;
    end;


  try
    // 2. Create workbook and sheet
    xlWorkbooks := xlApplication.WorkBooks;
    //if bShowExcel then
    //  begin
    //  xlApplication.Visible:=true;
    //  xlApplication.WindowState:= xlMaximized;
    //  end;
    xlWorkbook := xlWorkbooks.Add;
    xlSheet := xlWorkbook.WorkSheets.Add;
    xlSheet.Name := DataSet.Name;

    // 3. Copy data
    DataSetToExcelSheet(DataSet, xlSheet);
    if fName<>'' then
      begin
      try
        xlWorkbook.SaveAs(fName,xlWorkbookNormal, EmptyParam, EmptyParam, False,False,
                          xlNoChange, xlLocalSessionChanges,true,0,0)
      except
      end;
      xlWorkbook.Saved := True;

      if bShowExcel then
        begin
        xlApplication.Visible:=true;
        xlApplication.ActiveWindow.WindowState:= xlMaximized;
        xlApplication.WindowState:= xlMaximized;
        end;
        end;
    result := True;
  finally
    if not bShowExcel then
      xlApplication.Quit;
  end;
end;


end.
