unit HistLog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Mask, ToolEdit, RxLookup, RXSplit, Grids, DBGrids,
  RXDBCtrl, Db, DBTables, ActnList, UpdStoredProc, DBCtrls, Placemnt,
  ScrlQuery, RXSpin, CurrEdit, Buttons, ComCtrls, math, NWApp;

type
  TfrmHistoryLogView = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    dblookupTable: TRxDBLookupCombo;
    cbTable: TCheckBox;
    dblookupUser: TRxDBLookupCombo;
    cbUser: TCheckBox;
    cbPeriod: TCheckBox;
    DateBeg: TDateEdit;
    lblFrom: TLabel;
    DateEnd: TDateEdit;
    lblTo: TLabel;
    qTables: TQuery;
    qTablesId: TIntegerField;
    qTablesTableName: TStringField;
    qUsers: TQuery;
    qUsersLogin: TStringField;
    qUsersFIO: TStringField;
    GroupBox1: TGroupBox;
    cbOperAdd: TCheckBox;
    cbOperEdt: TCheckBox;
    cbOperDel: TCheckBox;
    dsTables: TDataSource;
    dsUsers: TDataSource;
    spHistLog: TStoredProc;
    dsHistLog: TDataSource;
    spHistLogId: TIntegerField;
    spHistLogIdOperation: TIntegerField;
    spHistLogValueId: TIntegerField;
    spHistLogData: TDateTimeField;
    spHistLogTableName: TStringField;
    spHistLogUserName: TStringField;
    Panel3: TPanel;
    RxSplitter1: TRxSplitter;
    Panel4: TPanel;
    RxDBGrid1: TRxDBGrid;
    DBNavigator1: TNavigatorWAppend;
    RxDBGrid2: TRxDBGrid;
    DBNavigator2: TNavigatorWAppend;
    FormStorage1: TFormStorage;
    qHisLogValues: TScrollQuery;
    qHisLogValuesColumnName: TStringField;
    qHisLogValuesOldValue: TStringField;
    qHisLogValuesNewValue: TStringField;
    dsHisLogValues: TDataSource;
    RxSpinButtonPeriod: TRxSpinButton;
    RxSpinButtonBegDate: TRxSpinButton;
    RxSpinButtonEndDate: TRxSpinButton;
    cbIdRec: TCheckBox;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    EditID: TCurrencyEdit;
    btUndo: TBitBtn;
    spHistLogBatchMarker: TStringField;
    spHistLogLogin: TStringField;
    tbTOP: TTrackBar;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure cbTableClick(Sender: TObject);
    procedure cbUserClick(Sender: TObject);
    procedure cbPeriodClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure spHistLogBeforeOpen(DataSet: TDataSet);
    procedure DateChange(Sender: TObject);
    procedure cbOperClick(Sender: TObject);
    procedure RxDBGrid1TitleBtnClick(Sender: TObject; ACol: Integer;
      Field: TField);
    procedure RxDBGrid2TitleBtnClick(Sender: TObject; ACol: Integer;
      Field: TField);
    procedure cbIdRecClick(Sender: TObject);
    procedure RxSpinButtonPeriodTopClick(Sender: TObject);
    procedure RxSpinButtonPeriodBottomClick(Sender: TObject);
    procedure RxSpinButtonBegDateTopClick(Sender: TObject);
    procedure RxSpinButtonBegDateBottomClick(Sender: TObject);
    procedure RxSpinButtonEndDateTopClick(Sender: TObject);
    procedure RxSpinButtonEndDateBottomClick(Sender: TObject);
    procedure RxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure EditIDExit(Sender: TObject);
    procedure btUndoClick(Sender: TObject);
    procedure tbTOPChange(Sender: TObject);
    procedure DBNavigatorBeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure qHisLogValuesBeforeOpen(DataSet: TDataSet);
    procedure spHistLogAfterScroll(DataSet: TDataSet);
  private
    { Private declarations }
    bStarted: Boolean;
    function IsMultiple: boolean;
  public
    { Public declarations }
  end;

var
  frmHistoryLogView: TfrmHistoryLogView;
//  defDBName: String;

implementation

{$R *.DFM}

uses Common, QueryEx, CommonVV, DataMdl, GridEx, Global,
     AppInfo, DBenv;

procedure TfrmHistoryLogView.FormCreate(Sender: TObject);
begin
 bStarted := False;
 dmMain.ImageListMain.GetBitmap(11, Image1.Picture.Bitmap);
 dmMain.ImageListMain.GetBitmap(12, Image2.Picture.Bitmap);
 dmMain.ImageListMain.GetBitmap(13, Image3.Picture.Bitmap);
 DateEnd.Date := Date+1;
 DateBeg.Date := Date;
 ReQueryAll(Self);

 dblookupTable.Value := qTablesId.asString;

 qUsers.Locate('Login', Login, []);
 dblookupUser.Value := qUsersLogin.asString;

 if not IsAdmin then
   begin
    dblookupUser.Enabled := False;
    cbUser.Enabled := False;
   end;
 bStarted := True;
 ReQueryOne(spHistLog);
 ReQueryOne(qHisLogValues);
end;

procedure TfrmHistoryLogView.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmHistoryLogView.cbTableClick(Sender: TObject);
begin
  dblookupTable.Enabled := cbTable.Checked;
  if bStarted then ReQueryOne(spHistLog);
end;

procedure TfrmHistoryLogView.cbUserClick(Sender: TObject);
begin
  dblookupUser.Enabled :=  cbUser.Checked;
  if bStarted then ReQueryOne(spHistLog);
end;

procedure TfrmHistoryLogView.cbPeriodClick(Sender: TObject);
var
  bChecked : Boolean;
begin
  bChecked := cbPeriod.Checked;
  DateBeg.Enabled := bChecked;
  DateEnd.Enabled := bChecked;
  RxSpinButtonPeriod.Visible := bChecked;
  RxSpinButtonBegDate.Visible := bChecked;
  RxSpinButtonEndDate.Visible := bChecked;
  if bStarted then ReQueryOne(spHistLog);
end;


procedure TfrmHistoryLogView.spHistLogBeforeOpen(DataSet: TDataSet);
begin
  with spHistLog do
  begin
    if cbTable.Checked then
      ParamByName('@IdTable').asInteger :=
        StrToIntDef(dblookupTable.Value, 0)
    else
      ParamByName('@IdTable').asInteger := 0;

    if cbUser.Checked then
      begin
      ParamByName('@Login').asString := dblookupUser.Value;
      end
    else
      begin
      ParamByName('@Login').Clear;
      end;

    ParamByName('@PowOperation').asInteger :=
      (Ord(cbOperAdd.Checked))*2 +
      (Ord(cbOperEdt.Checked))*4 +
      (Ord(cbOperDel.Checked))*8 ;

    if cbPeriod.Checked then
      ParamByName('@isData').asInteger := 1
    else
      ParamByName('@isData').asInteger := 0;
    ParamByName('@BegData').asDate := DateBeg.Date;
    ParamByName('@EndData').asDate := DateEnd.Date;

    if cbIdRec.Checked then
      ParamByName('@ValueId').asInteger :=
        Round(EditID.Value)
    else
      ParamByName('@ValueId').asInteger := 0;

    ParamByName('@top').asInteger:=round(power(10,tbTOP.Position));
  end;
end;

procedure TfrmHistoryLogView.DateChange(Sender: TObject);
begin
  if bStarted then ReQueryOne(spHistLog);
end;

procedure TfrmHistoryLogView.cbOperClick(Sender: TObject);
begin
  if bStarted then ReQueryOne(spHistLog);
end;

procedure TfrmHistoryLogView.RxDBGrid1TitleBtnClick(Sender: TObject;
  ACol: Integer; Field: TField);
begin
  ResortDataSetByField(spHistLog, Field);
end;

procedure TfrmHistoryLogView.RxDBGrid2TitleBtnClick(Sender: TObject;
  ACol: Integer; Field: TField);
begin
  ResortDataSetByField(qHisLogValues, Field);
end;

procedure TfrmHistoryLogView.cbIdRecClick(Sender: TObject);
begin
  EditID.Enabled := cbIdRec.Checked;
  if bStarted then ReQueryOne(spHistLog);
end;

procedure TfrmHistoryLogView.RxSpinButtonPeriodTopClick(Sender: TObject);
begin
  bStarted := False;
  try
    DateBeg.Date := DateBeg.Date + 1;
    DateEnd.Date := DateEnd.Date + 1;
    ReQueryOne(spHistLog);
  finally
    bStarted := True;
  end;
end;

procedure TfrmHistoryLogView.RxSpinButtonPeriodBottomClick(
  Sender: TObject);
begin
  bStarted := False;
  try
    DateBeg.Date := DateBeg.Date - 1;
    DateEnd.Date := DateEnd.Date - 1;
    ReQueryOne(spHistLog);
  finally
    bStarted := True;
  end;
end;

procedure TfrmHistoryLogView.RxSpinButtonBegDateTopClick(Sender: TObject);
begin
  DateBeg.Date := DateBeg.Date + 1;
end;

procedure TfrmHistoryLogView.RxSpinButtonBegDateBottomClick(
  Sender: TObject);
begin
  DateBeg.Date := DateBeg.Date - 1;
end;

procedure TfrmHistoryLogView.RxSpinButtonEndDateTopClick(Sender: TObject);
begin
  DateEnd.Date := DateEnd.Date + 1;
end;

procedure TfrmHistoryLogView.RxSpinButtonEndDateBottomClick(
  Sender: TObject);
begin
  DateEnd.Date := DateEnd.Date - 1;
end;

var arOpBitmap : array [1..3] of TBitmap;
//const  arOpStr : array [1..3] of string = ('', '.', '.');

procedure TfrmHistoryLogView.RxDBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;  State: TGridDrawState);
var iOper: integer;

      procedure InitBitmap(Index:integer);
      begin
        if arOpBitmap[Index]=nil then
        begin
          arOpBitmap[Index] := TBitmap.Create;
          dmMain.ImageListMain.GetBitmap(10+Index, arOpBitmap[Index]);
        end;
      end;

begin
  if (Column.Field=spHistLogIdOperation) then
  begin
    iOper := Column.Field.AsInteger;
    if iOper>0 then
    begin
      InitBitmap(iOper);
      RxDBGrid1.Canvas.FillRect(Rect);
      RxDBGrid1.Canvas.Draw((Rect.Left+Rect.Right-arOpBitmap[iOper].Width) div 2,
                            (Rect.Top+Rect.Bottom-arOpBitmap[iOper].Height) div 2,
                              arOpBitmap[iOper]);
      Exit;
    end;
  end;
  RxDBGrid1.DefaultDrawColumnCell(Rect,DataCol,Column,State);
end;


procedure FinalFreeBitmaps;
var i: integer;
begin
  for i:=1 to 3 do FreeAndNil(arOpBitmap[i]);
end;

procedure TfrmHistoryLogView.EditIDExit(Sender: TObject);
begin
  if bStarted then ReQueryOne(spHistLog);
end;

procedure TfrmHistoryLogView.btUndoClick(Sender: TObject);
begin
  if not Confirmation('  '#10#13' ?') then Exit;
  UndoOperation(spHistLogId.AsInteger,IsMultiple);
  ReQueryOne(spHistLog);
end;

function TfrmHistoryLogView.IsMultiple:boolean;
begin
//******************   !
  result:=false;
end;

procedure TfrmHistoryLogView.tbTOPChange(Sender: TObject);
begin
  if bStarted and (spHistLog.ParamByName('@top').AsInteger<>Round(power(10,tbTOP.Position)))
       then ReQueryOne(spHistLog);
end;

procedure TfrmHistoryLogView.DBNavigatorBeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
  if Button=nbRefresh then
  begin
     ReQueryOne(TDBNavigator(Sender).DataSource.DataSet);
     Abort;
  end;
end;

procedure TfrmHistoryLogView.qHisLogValuesBeforeOpen(DataSet: TDataSet);
begin
  qHisLogValues.ParamByName('IdHistory').AsInteger:=spHistLogId.AsInteger;
end;

procedure TfrmHistoryLogView.spHistLogAfterScroll(DataSet: TDataSet);
begin
  ReQueryOne(qHisLogValues)
end;

initialization

finalization
  FinalFreeBitmaps;

end.
