{*******************************************************}
{           NOS VCL Extensions (NOS)                    }
{                                                       }
{          Copyright (c) 1995 No$ $oft                  }
{                  2:4635/41.5                          }
{*******************************************************}

unit NFindDlg;      

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,DB,Buttons,VCLUtils,Placemnt,DBTables, StdCtrls,
  ExtCtrls, Mask, ToolEdit, CurrEdit, DBGrids, dlgOrd, Nfindlg2;

type
  TdlgnFind = class(TForm)
    txtSearch: TEdit;
    Label1: TLabel;
    rgFindKind: TRadioGroup;
    Label2: TLabel;
    cbFieldChange: TComboEdit;
    btFind: TBitBtn;
    btNext: TBitBtn;
    btClose: TBitBtn;
    rgFindDirection: TRadioGroup;
    dateSearch: TDateEdit;
    fltSearch: TCurrencyEdit;
    lblField: TLabel;
    procedure btNextClick(Sender: TObject);
    procedure btFindClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure cbFieldChangeButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    aFieldList : TMyFieldList;
    nSelField : integer;
    dsToFind: TDataSet;
    aGrid : TDBGrid;
    procedure SetInput;
  public
    ind: longint;
    inFind: boolean;
    constructor MyCreate(AOwner: TComponent; dsFind: TDataSet; aaGrid : TDBGrid; sDefFldNm : string);
    procedure ButtonClick(direct: Boolean);
    function CompareField(exact: Boolean) : Boolean;
    function FindMatch(exact: Boolean; direct: Boolean) : boolean;
    { Public declarations }
  end;

implementation
{$R *.DFM}




{**************************** TfmnnFind ***********************}

constructor TdlgnFind.MyCreate(AOwner: TComponent; dsFind: TDataSet; aaGrid : TDBGrid; sDefFldNm : string);
var
  i : integer;
  fldn : string;
begin
  inherited Create(AOwner);
  dsToFind := dsFind;
  aGrid := aaGrid;
  aFieldList := TMyFieldList.Create;
  aFieldList.readFields(dsToFind);

  nSelField := -1;
  fldn := '';

  if length(sDefFldNm)>1 then
    begin
    fldn := sDefFldNm;
    end
  else
    if aGrid<>nil then
      begin
      if aGrid.SelectedField<>nil then
        begin
        if aGrid.SelectedField.Lookup=True then
          fldn := aGrid.SelectedField.KeyFields
        else
          fldn := aGrid.SelectedField.FieldName;
        end;
      end;

for i:=0 to aFieldList.Count-1 do
   begin
   if fldn=aFieldList.Field[i].FieldName then
     begin
     nSelField := i;
     cbFieldChange.Text:=aFieldList.Field[i].FieldName;
     lblField.Caption:=aFieldList.Field[i].DisplayLabel;
     SetInput;
     break;
     end;
   end;

end;

procedure TdlgnFind.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  aFieldList.Free;
end;

procedure TdlgnFind.ButtonClick;
var b:TBookMark;
    R:boolean;
begin
 R:=false;
 inFind:=True;
 {Disable all}
 rgFindKind.Enabled:=False;
 rgFindDirection.Enabled:=False;
 txtSearch.Enabled:=False;
 fltSearch.Enabled:=False;
 dateSearch.Enabled:=False;
 cbFieldChange.Enabled:=False;
 btFind.Enabled:=False;
 btNext.Enabled:=False;
 btClose.Caption:='';
 Caption:=' ...';
 {End Disable}
 dsToFind.DisableControls;

 b:=dsToFind.GetBookMark;
 try
  case rgFindKind.ItemIndex of
    0: R:=FindMatch(True, direct);
    1: R:=FindMatch(False, direct);
  end;
 finally
  if not R then begin
    dsToFind.GoToBookMark(b);
    if inFind then MessageDlg('  .',mtError,[mbOk],0)
    else MessageDlg(' .',mtError,[mbOk],0)
  end;

   {Enable all}
   rgFindKind.Enabled:=True;
   rgFindDirection.Enabled:=True;
   txtSearch.Enabled:=True;
   fltSearch.Enabled:=True;
   dateSearch.Enabled:=True;
   cbFieldChange.Enabled:=True;
   btFind.Enabled:=True;
   btNext.Enabled:=True;
   btClose.Caption:='';
   Caption:='';
   {End Enable}
   inFind:=False;
   dsToFind.FreeBookMark(b);
   dsToFind.EnableControls;
 end;
end;


procedure TdlgnFind.btNextClick(Sender: TObject);
begin
 if not inFind then ButtonClick(False);
end;

function TdlgnFind.CompareField(exact : Boolean) : Boolean;
var
  cFldName : string;
begin
  Result:=false;
  cFldName := aFieldList.Field[nSelField].FieldName;
  case aFieldList.Field[nSelField].DataType of
    ftString : begin
      if exact then
        if AnsiUpperCase(dsToFind.FieldByName(cFldName).AsString)=AnsiUpperCase(txtSearch.Text) then
          result:=True
        else
          result:=False
      else
        if Pos(AnsiUpperCase(txtSearch.Text), AnsiUpperCase(dsToFind.FieldByName(cFldName).AsString))>0 then
          result:=True
        else
          result:=False;
      end;
    ftSmallint, ftInteger : begin
      if dsToFind.FieldByName(cFldName).AsInteger=fltSearch.Value then
        result:=True
      else
        result:=False;
      end;
    ftFloat, ftCurrency : begin
      if dsToFind.FieldByName(cFldName).AsFloat=fltSearch.Value then
        result:=True
      else
        result:=False;
      end;
    ftDate, ftDateTime : begin
      if dsToFind.FieldByName(cFldName).AsDateTime=dateSearch.Date then
        result:=True
      else
        result:=False;
      end;
  end;
end;


function TdlgnFind.FindMatch(exact: Boolean; direct: Boolean) : Boolean;
begin
 Result:=false;
 with dsToFind do begin
  case rgFindDirection.ItemIndex of
   0:if direct then First
     else           Next;
   1:if direct then Last
     else           Prior;
  end;

  case rgFindDirection.ItemIndex of
   0:begin
       while (not eof) and
             (not CompareField(exact)) and
            (inFind) do begin
        Next;
        Application.ProcessMessages;
      end;
      if Eof then result:=False else result:=inFind;
      exit;
     end;
   1:begin
      while (not bof) and
            (not CompareField(exact)) and
            (inFind) do begin
        Prior;
        Application.ProcessMessages;
      end;
      if bof then result:=False else result:=inFind;
      exit;
     end;
  end;
 end;
end;


procedure TdlgnFind.btFindClick(Sender: TObject);
begin
if not inFind then ButtonClick(True);
end;

//procedure TfmnnFind.FormStorage1SavePlacement(Sender: TObject);
//begin
// FormStorage1.IniFile.WriteInteger('Find','NumField'+dsToFind.DataSet.Name,cbFieldChange.ItemIndex);
//end;

//procedure TfmnnFind.FormStorage1RestorePlacement(Sender: TObject);
//begin
//  ind:=FormStorage1.IniFile.ReadInteger('Find','NumField'+dsToFind.DataSet.Name,0);
//   if ind <= dsToFind.dataSet.FieldCount-1 then
//      cbFieldChange.ItemIndex:=ind
//   else
//      cbFieldChange.ItemIndex:=0;
//end;

procedure TdlgnFind.btCloseClick(Sender: TObject);
begin
 if inFind then inFind:=False else Close;
end;


procedure TdlgnFind.SetInput;
var
  ft : TFieldType;
begin
    lblField.Caption:= aFieldList.Field[nSelField].DisplayLabel;
    cbFieldChange.Text:=aFieldList.Field[nSelField].FieldName;
    ft := aFieldList.Field[nSelField].DataType;
    // 
    case ft of
        ftString : begin
          txtSearch.Text:='';
          txtSearch.Visible  := True;
          dateSearch.Visible := False;
          fltSearch.Visible  := False;
          if Visible=true then txtSearch.setFocus
          else  ActiveControl := txtSearch;
          rgFindKind.ItemIndex := 1;
          end;
        ftSmallint, ftInteger, ftFloat, ftCurrency : begin
          fltSearch.Value := 0;
          txtSearch.Visible  := False;
          dateSearch.Visible := False;
          fltSearch.Visible  := True;
          if Visible=true then fltSearch.setFocus
          else  ActiveControl := fltSearch;
          rgFindKind.ItemIndex := 0;
          if ft=ftFloat then
            begin
            fltSearch.DisplayFormat:=',0.#######';
            fltSearch.DecimalPlaces:=7;
            end;
          if ft=ftCurrency then
            begin
            fltSearch.DisplayFormat:=',0.00;-,0.00';
            fltSearch.DecimalPlaces:=2;
            end;
          if ft=ftInteger then
            begin
            fltSearch.DisplayFormat:='#0';
            fltSearch.DecimalPlaces:=0;
            end;
          end;
        ftDate, ftDateTime : begin
          dateSearch.Date := Now;
          txtSearch.Visible  := False;
          dateSearch.Visible := True;
          fltSearch.Visible  := False;
          if Visible=true then dateSearch.setFocus
          else  ActiveControl := dateSearch;
          rgFindKind.ItemIndex := 0;
          end;
      end;
end;



procedure TdlgnFind.cbFieldChangeButtonClick(Sender: TObject);
var
  dlgNFields : TdlgNFields;
 // ft : TFieldType;
begin
  dlgNFields := TdlgNFields.MyCreate(Self, aFieldList);
  dlgNFields.Left:= Self.Left+cbFieldChange.Left+10;
  dlgNFields.Top:= Self.Top+cbFieldChange.Top+cbFieldChange.Height+10;
  if dlgNFields.ShowModal=mrOK then
  begin
    nSelField:= dlgNFields.grid.Row -1;
    SetInput;
  end;
end;


end.
