unit QueryEx;

interface

uses classes, dbtables, db, forms, dialogs, dbgrids,
     dbctrls, Controls;  //, gvDACmn

procedure ReQueryAll(Sender:TComponent);
procedure ReQueryTotal(Sender:TComponent=nil);
procedure ReQueryOne(DataSet:TDataSet; const NewSQL:string='');

//nction exists(SQLstring:String):boolean;
function GetTableName(DataSet:TDataSet; const Id:Integer=0):String;
function DateForQuery(cdate:TDateTime):string;
procedure DoSQL(const SQLstring:String; const IsAsync:boolean=false);
function Str2SQLstr(sInput:string):string;


function GetDBObject:TCustomConnection;
function GetDBName:string;
function DLookup(const SQLstring:String):Variant;
function DLookupArray(const SQLstring:String):Variant;
procedure SetSmartReadOnlyFields(aDataSet: TDataSet; valReadOnly: Boolean);
function GetPlatformDataSet(const SQLstring:String):TDataSet;
function GetGeneralDataSet:TDataSet;


implementation

uses DBUtils, sysutils, Common, StrUtils,
     updStoredProc, updQuery; //DBenv, AdmTst, ADOdb;

type THackDataSet = class(TDataSet) end;
     THackDataSource=class(TDataSource) end;

type TSQLPropType=(ptSelect, ptInsert, ptUpdate, ptProc);

//var FExecuter:TADOCommand;
//    FLookuper:TADODataSet;
//    FConnection:TCustomConnection;

{function Executer:TADOCommand;
begin
  if FExecuter=nil then
  begin
    FExecuter:=TADOCommand.Create(Application);
    with FExecuter do
    begin
      ConnectionString:=GetADOConnString;
      ExecuteOptions:=[eoExecuteNoRecords];
      ParamCheck:=false;
      Prepared:=false;
      CommandType:=cmdText;
    end;
  end;
  result:=FExecuter;
end;

function Lookuper:TADODataSet;
begin
  if FLookuper=nil then
  begin
    FLookuper:=TADODataSet.Create(Application);
    FLookuper.ConnectionString:=GetADOConnString;
    FLookuper.LockType:=ltReadOnly;
    FLookuper.ParamCheck:=false;
    FLookuper.Prepared:=false;
    FLookuper.CommandType:=cmdText;
  end;
  FLookuper.Active:=false; //  
  result:=FLookuper;
end;
}

function GetGeneralDataSet:TDataSet;
var res:Integer; ctrl:TControl;
begin
  ctrl:=Screen.ActiveControl;
  result:=nil;
  if ctrl is TCustomDBGrid then
     result:=TCustomDBGrid(ctrl).DataSource.DataSet
  else
    begin
      res:=ctrl.Perform(CM_GETDATALINK,0,0);
      if res>0 then result:=TDataLink(res).DataSet;
    end;
end;

procedure ReQueryOne(DataSet:TDataSet; const NewSQL:string='');
var Id:integer;   p:TDataSetNotifyEvent;
begin
   try ConfirmDataSetCancel(DataSet);
   except on EAbort do   //    "Cancel"
     begin
       ErrorMsg('   '#10#13'  ');
       raise; //     "Cancel"
              //    ,
              //      "No"
     end;
   end;
   DataSet.DisableControls;
   try p:=DataSet.AfterScroll;
     try
       if Assigned(p) then DataSet.AfterScroll:=nil;
       if DataSet.Active and (DataSet.FindField('Id')<>nil)
         then Id:=DataSet.FieldByName('Id').AsInteger
         else Id:=-1;
       DataSet.Active:=false;
       if (DataSet is TQuery) and (NewSQL<>'') then TQuery(DataSet).SQL.Text:=NewSQL;
       try
         DataSet.Open;
       except on e:Exception do
         raise Exception.Create(e.Message+#10#13'DataSet.Name="'+DataSet.Name+'"');
       end;
       if Id=0 then
           begin
             DataSet.First;
             while not DataSet.EOF do   //  max(Id)
             begin
               if DataSet.FieldByName('Id').AsInteger>Id
                    then Id:=DataSet.FieldByName('Id').AsInteger;
               DataSet.Next;
             end;
           end
         else
           begin
             DataSet.Last;
             DataSet.First;
           end;
       if Id>0 then DataSet.Locate('Id',Id,[]);
     finally if Assigned(p) then DataSet.AfterScroll:=p;
     end;
   finally
     DataSet.EnableControls;
   end;
   THackDataSet(DataSet).DataEvent(deDataSetChange, 0);
   if Assigned(p) then DataSet.AfterScroll(DataSet);
end;

procedure SetSQLstr(ds:TDataSet; const SQLstr:string);
begin
  if ds is TQuery then TQuery(ds).SQL.Text:=SQLstr
  //else if ds is TOrdinaryQuery then TOrdinaryQuery(ds).SQL.Text:=SQLstr
  //else if ds is TLiveQuery then TLiveQuery(ds).SQL.Text:=SQLstr
  //else if ds is TADODataSet then TADODataSet(ds).CommandText:=SQLstr
  else raise Exception.Create('   ');
end;

function GetSQLstr(ds:TDataSet):string;
begin
  if ds is TQuery then result:=TQuery(ds).SQL.Text+' '
  //else if ds is TOrdinaryQuery then result:=TOrdinaryQuery(ds).SQL.Text+' '
  //else if ds is TLiveQuery then result:=TLiveQuery(ds).SQL.Text+' '
  //else if ds is TADODataSet then result:=TADODataSet(ds).CommandText+' '
  else raise Exception.Create('   ');
end;


procedure ReQueryAll(Sender:TComponent);
var
  i:integer;
  aQuery: TQuery;
  aDataSet: TDataSet;
begin
  //1. not ReQuestLive TQuery
  for i:=0 to Sender.ComponentCount-1 do
    begin
    if (Sender.Components[i] is TQuery) then
      begin
      aQuery := Sender.Components[i] as TQuery;
      stmp:=aQuery.Name;
      if (aQuery.Tag<>-1) and
         (not aQuery.ReQuestLive) then
          ReQueryOne(aQuery);
      end;
    end;
  //2. ReQuestLive TQuery and all other TDataSet
  for i:=0 to Sender.ComponentCount-1 do
    begin
      if (Sender.Components[i] is TQuery) then
        begin
        aQuery := Sender.Components[i] as TQuery;
        stmp:=aQuery.Name;
        if (aQuery.Tag<>-1) and
           (aQuery.ReQuestLive) then
            ReQueryOne(aQuery);
        end
      else if (Sender.Components[i] is TDataSet) then
        begin
        aDataSet := Sender.Components[i] as TDataSet;
        stmp := aDataSet.Name;
        if aDataSet.Tag<>-1 then
          ReQueryOne(aDataSet);
        end;
      end;
end;

procedure ReQueryTotal(Sender:TComponent=nil);
        procedure ReQueryOneForm(Sender:TComponent);
        var k:integer;
        begin
          for k:=0 to Sender.ComponentCount-1 do
           if Sender.Components[k] is TDataSet then
             if TDataSet(Sender.Components[k]).Active then
               if TDataSet(Sender.Components[k]).Tag=0 then
                 ReQueryOne(TDataSet(Sender.Components[k]));
          for k:=0 to Sender.ComponentCount-1 do
           if Sender.Components[k] is TDataSet then
             if TDataSet(Sender.Components[k]).Active then
               if TDataSet(Sender.Components[k]).Tag=-1 then
                 ReQueryOne(TDataSet(Sender.Components[k]));
        end;
var i:integer;
begin
  if Sender=nil then
    begin
      for i:=0 to Screen.DataModuleCount-1 do
        ReQueryOneForm(Screen.DataModules[i]);
      for i:=0 to Screen.FormCount-1 do
        if Screen.Forms[i]<>Screen.ActiveForm then
          ReQueryOneForm(Screen.Forms[i]);
      ReQueryOneForm(Screen.ActiveForm);
    end
   else ReQueryOneForm(Sender);
end;

function GetTableName(DataSet:TDataSet; const Id:Integer=0):String;
var txt,oper:string; ps:integer;
begin
{  if (DataSet is TQuery) and (pos('select', lowercase(TQuery(DataSet).SQL.Text))>0) then
    begin
      propstr:=TQuery(DataSet).SQL.Text;
      proptype:=ptSelect
    end
  else if (DataSet is TCustom) and (pos('select', lowercase(TQuery(DataSet).SQL.Text))>0) then
    begin
      propstr:=TQuery(DataSet).SQL.Text;
      proptype:=ptSelect
    end}

  if DataSet is TupdStoredProc then
      begin
        txt:='u_'+trim(lowercase(TupdStoredProc(DataSet).ModifySQL.text));
        if txt='u_' then txt:='i_'+trim(lowercase(TupdStoredProc(DataSet).InsertSQL.text));
        if txt='i_' then txt:='d_'+trim(lowercase(TupdStoredProc(DataSet).DeleteSQL.text));
      end
  else if DataSet is TupdQuery then
      begin
        txt:='u_'+trim(lowercase(TupdQuery(DataSet).ModifySQL.text));
        if txt='u_' then txt:='i_'+trim(lowercase(TupdQuery(DataSet).InsertSQL.text));
        if txt='i_' then txt:='d_'+trim(lowercase(TupdQuery(DataSet).DeleteSQL.text));
        if txt='d_' then txt:='s_'+trim(lowercase(TupdQuery(DataSet).SQL.text));
      end
  else if DataSet is TQuery then
        txt:='s_'+trim(lowercase(TQuery(DataSet).SQL.text));
  if length(txt)<3 then exit;
  case txt[1] of
     'u':oper:='update';
     'i':oper:='insert';
     'd':oper:='delete';
     's':oper:='select';
    else exit;
  end;
  ps:=pos(oper,txt);
  if ps<3 then exit;
  txt:=copy(txt,ps,length(txt));
  txt:=ReplaceStr(txt,#10,#32);
  txt:=ReplaceStr(txt,#13,#32);
  txt:=ReplaceStr(txt,#9,#32);
  txt:=ReplaceStr(txt,',',#32);
  while pos(#32#32,txt)>0 do txt:=ReplaceStr(txt,#32#32,#32);
  if oper='update' then ps:=8
    else if oper='delete' then ps:=13
    else if oper='insert' then
      begin if pos('insert into ',txt)=0 then ps:=8 else ps:=13 end
    else ps:=Pos(' from ',txt)+6;
  txt:=copy(txt,ps,length(txt));
  ps:=pos(#32,txt)-1;
  if (ps<2) and (ps<>-1) then
      raise exception.create('   "'+txt+'"');
  if ps<>-1 then result:=trim(copy(txt,1,ps))
            else result:=txt;
  if (pos('dbo.',result)>0) or (pos('DBO.',result)>0)
      then result:=copy(result,5,Length(result)-4);
end;

function GetDBName:string;
begin
  if GetDBObject is TDatabase then
    result:=(GetDBObject as TDatabase).DatabaseName
  else
    raise Exception.Create('This connection is not TDatabase');
end;

function GetDBObject:TCustomConnection;
begin
  result:= nil;
  if Sessions.Count>0 then
    if Sessions[0].DatabaseCount>0
      then result:=Sessions[0].Databases[0];
  if (result=nil) then
      raise Exception.Create('    ');

{  if FConnection=nil then
  begin
{//    if IsADOPresent then
//    begin
      for i:=0 to Screen.DataModuleCount-1 do
       for j:=0 to Screen.DataModules[i].ComponentCount-1 do
        if Screen.DataModules[i].Components[j] is TADOConnection then
            FConnection:=TADOConnection(Screen.DataModules[i].Components[j]);
//    end;
    if FConnection=nil then
      if Sessions.Count>0 then
        if Sessions[0].DatabaseCount>0
          then FConnection:=Sessions[0].Databases[0];
  end;
  if (FConnection=nil) then
      raise Exception.Create('    ');
  result:=FConnection;}
end;

{procedure DoSQLBDEOnly(const SQLstring:String);
begin
    with TQuery.Create(nil) do
    try
      DatabaseName:=GetDBName;
      SQL.Text:=SQLstring;
      ExecSQL;
    finally
      Free;
    end
end;}

procedure DoSQL(const SQLstring:String; const IsAsync:boolean=false);
begin
  (GetDBObject as TDatabase).Execute(SQLstring);
{  else
    with Executer do
    begin
      cs:=ConnectionString;
      ConnectionString:='';
      CommandText:=SQLstring;
      ConnectionString:=cs;
      if IsAsync
        then ExecuteOptions:=ExecuteOptions+[eoAsyncExecute]
        else ExecuteOptions:=ExecuteOptions-[eoAsyncExecute];
      Execute;
    end;}
end;

function GetPlatformDataSet(const SQLstring:String):TDataSet;
begin
  //if not IsADOImplement then
  //  begin
      result:=TQuery.Create(Application);
      with TQuery(result) do
      begin
        DatabaseName:=GetDBName;
        ParamCheck:=false;
        SQL.Text:=SQLstring;
      end;
{    end
  else
    begin
      result:=TADODataSet.Create(Application);
      with TADODataSet(result) do
      begin
        LockType:=ltReadOnly;
        ParamCheck:=false;
        CommandType:=cmdText;
        CommandText:='set nocount on '#10#13+SQLstring+#10#13' set nocount off';
        ConnectionString:=GetADOConnString;
      end;
    end;}
  result.Name:='PlatformDataSet';
  try
    result.Open;
    result.Last; //MultiPlatform "FetchAll"
    result.First;
  except
    FreeAndNil(result);
    raise;
  end;
end;


function DLookup(const SQLstring:String):Variant;
begin
  result:=DLookupArray(SQLstring)[1];
end;

function DLookupArray(const SQLstring:String):Variant;
var i:Integer; //cs:WideString;
begin
  with TQuery.Create(nil) do
  try
    DatabaseName:= GetDBName;
    SQL.Text:=SQLstring;
    Open;
    result:=VarArrayCreate([1,FieldCount],varVariant);
    for i:=1 to FieldCount do
    begin
      if Fields[i-1] is TMemoField
        then result[i]:=TMemoField(Fields[i-1]).AsString
        else result[i]:=Fields[i-1].AsVariant;
    end;
    Close;
  finally
    Free;
  end;

{  if (not IsADOPresent) then
    with TQuery.Create(nil) do
    try
      DatabaseName:=GetDBName;
      SQL.Text:=SQLstring;
      Open;
      result:=VarArrayCreate([1,FieldCount],varVariant);
      for i:=1 to FieldCount do
      begin
        if Fields[i-1] is TMemoField
          then result[i]:=TMemoField(Fields[i-1]).AsString
          else result[i]:=Fields[i-1].AsVariant;
      end;
      Close;
    finally
      Free;
    end
  else
    with Lookuper do
    try
      cs:=ConnectionString;
      ConnectionString:='';
      CommandText:='set nocount on '#10#13+SQLstring+#10#13' set nocount off';
      ConnectionString:=cs;
      Open;
      result:=VarArrayCreate([1,FieldCount],varVariant);
      for i:=1 to FieldCount do
      begin
        if Fields[i-1] is TMemoField
          then result[i]:=TMemoField(Fields[i-1]).AsString
          else result[i]:=Fields[i-1].AsVariant;
      end;
    finally
      Active:=false;
    end}
end;

{function exists(SQLstring:String):boolean;
begin
  result:=
   (Integer(dlookup('declare @res int '+
                    'if exists ('+SQLstring+') select @res=1 else select @res=0 '+
                   'select @res'))=1);
end;}

function DateForQuery(cdate:TDateTime):string;
var day,month,year:word;
begin
  DecodeDate(cdate,year,month,day);
  result:= char(39)+IntToStr(year);
  if month>9
    then result:=result+IntToStr(month)
    else result:=result+'0'+IntToStr(month);
  if day>9
    then result:=result+IntToStr(day)+char(39)
    else result:=result+'0'+IntToStr(day)+char(39);
end;

function Str2SQLstr(sInput:string):string;
begin
  result := ''''+ sInput + '''';
end;

procedure SetSmartReadOnlyFields(aDataSet: TDataSet; valReadOnly: Boolean);
var
  i: integer;
  aField: TField;
  keyFieldsNames: TStringList;
begin
  keyFieldsNames := TStringList.Create;
  try
    for i:=0 to aDataSet.FieldCount-1 do
    begin
      aField := aDataSet.Fields[i];
      If aField.Lookup Then
        begin
        keyFieldsNames.Add(aField.FieldName);
        keyFieldsNames.Add(aField.KeyFields);
        end;
    end;

    for i:=0 to aDataSet.FieldCount-1 do
    begin
      aField := aDataSet.Fields[i];
      If keyFieldsNames.IndexOf(aField.FieldName)<0 then
        aField.ReadOnly:= valReadOnly
    end;
  finally
    keyFieldsNames.Free;
  end;
end;


end.
