unit RegSet;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBGrids, DBTables, Grids, ExtCtrls,
  RXDBCtrl, Placemnt, Buttons, Dialogs, ComCtrls, DBUtils, Mask;

type
  TfmRegSet = class(TForm)
    btOk: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btOkClick(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  protected
    procedure CreateParams(var Params : TCreateParams); override;
  private
    rgn : HRGN;
    procedure WMNCHitTest(var Message : TWMNCHitTest); message WM_NCHITTEST;
  public
    user:integer;
    good:boolean;
  end;

procedure CheckUser;

implementation

uses Common, QueryEx, AppInfo;

{$R *.DFM}

procedure CheckUser;
var retcode:Variant; build:string;
begin
   try build:=IntToStr(GetBuild);
   except build:='NULL';
   end;
   retcode:=DLookup('declare @retcode int'#10#13
                +'exec @retcode=spStart '+IntToStr(GetMinorVersion)+#10#13+', '
                +build+#10#13+'select @retcode');
   if (VarType(retcode)<>varInteger) then RaiseProjectCloseException;
   if retcode>0 then
   begin
     with TfmRegSet.Create(nil) do
     try
       user:=retcode;
       ShowModal;
       if not good then RaiseProjectCloseException;
     finally
       Release;
     end;
   end;
end;

procedure TfmRegSet.CreateParams(var Params : TCreateParams);
begin
  inherited CreateParams(Params);
//  Params.Style:=Params.Style or (not WS_CAPTION);
//  Params.ExStyle:=Params.ExStyle or WS_EX_TRANSPARENT;
end;

procedure TfmRegSet.WMNCHitTest(var Message : TWMNCHitTest);
begin
  if PtInRegion(rgn, Message.XPos, Message.YPos) then
    Message.Result:=Windows.HTCAPTION
  else
    Message.Result:=Windows.HTNOWHERE;
end;

procedure TfmRegSet.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TfmRegSet.FormCreate(Sender: TObject);
begin
  good:=false;
  rgn:=CreateRectRgn(Left,Top,Left+Width,Top+Height);
end;

procedure TfmRegSet.btOkClick(Sender: TObject);
begin
   DoSQL('exec spFillInfo @id='         +IntToStr(user)
                      +', @surname='    +#39+Edit1.Text+#39
                      +', @name='       +#39+Edit2.Text+#39
                      +', @patronymic=' +#39+Edit3.Text+#39
                      +', @post='       +#39+Edit4.Text+#39,true);
   good:=true;
   Close;
end;

procedure TfmRegSet.EditChange(Sender: TObject);
begin
    if    (Length(trim(Edit1.text))>0)
      and (Length(trim(Edit2.text))>0)
      and (Length(trim(Edit3.text))>0)
      and (Length(trim(Edit4.text))>0)
         then btOk.Enabled:=true
         else btOk.Enabled:=false;
end;

procedure TfmRegSet.FormDestroy(Sender: TObject);
begin
  DeleteObject(rgn);
end;

end.
