unit Register;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBGrids, DBTables, Grids, ExtCtrls,
  RXDBCtrl, Placemnt, Buttons, Dialogs, ComCtrls, DBUtils, Mask;

type
  TfmFirm = class(TForm)
    FormStorage1: TFormStorage;
    qCity: TQuery;
    dsCity: TDataSource;
    qFirm: TQuery;
    dsFirm: TDataSource;
    Panel2: TPanel;
    Panel4: TPanel;
    DBNavigator1: TDBNavigator;
    DBGrid1: TrxDBGrid;
    Panel1: TPanel;
    qFirmId: TAutoIncField;
    qFirmItem: TStringField;
    qFirmShortItem: TStringField;
    qFirmParent: TIntegerField;
    qFirmSubLevel: TIntegerField;
    qFirmINN: TStringField;
    qFirmOKONH: TStringField;
    qFirmOKPO: TStringField;
    qFirmIdCity: TIntegerField;
    qFirmAddress: TStringField;
    qFirmIsOurs: TBooleanField;
    qFirmIdType: TIntegerField;
    qFirmIdNearRWStation: TIntegerField;
    qCityId: TAutoIncField;
    qCityItem: TStringField;
    qFirmCity: TStringField;
    qType: TQuery;
    AutoIncField1: TAutoIncField;
    StringField1: TStringField;
    dsType: TDataSource;
    qFirmType: TStringField;
    qStation: TQuery;
    AutoIncField2: TAutoIncField;
    StringField2: TStringField;
    dsStation: TDataSource;
    qFirmNearRWStation: TStringField;
    qParent: TQuery;
    dsParent: TDataSource;
    qParentId: TAutoIncField;
    qParentItem: TStringField;
    qFirmsParent: TStringField;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBLookupComboBox1: TDBLookupComboBox;
    cbIsOurs: TDBCheckBox;
    DBLookupComboBox2: TDBLookupComboBox;
    DBLookupComboBox3: TDBLookupComboBox;
    DBLookupComboBox4: TDBLookupComboBox;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    qFirmBank: TStringField;
    DBEdit7: TDBEdit;
    qFirmVIP: TStringField;
    qFirmDescript: TStringField;
    qFirmRWCode: TIntegerField;
    Label12: TLabel;
    DBEdit8: TDBEdit;
    Label13: TLabel;
    DBEdit9: TDBEdit;
    Label14: TLabel;
    DBEdit10: TDBEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormStorage1SavePlacement(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure qFirmAfterPost(DataSet: TDataSet);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure qFirmAfterInsert(DataSet: TDataSet);
    procedure DBGrid1GetCellParams(Sender: TObject; Field: TField;
      AFont: TFont; var Background: TColor; Highlight: Boolean);
    procedure DBGrid1EditChange(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  fmFirm: TfmFirm;

implementation

uses
   Global, DataMdl;

{$R *.DFM}

procedure TfmFirm.FormCreate(Sender: TObject);
begin
   RestoreIniOrderBy(qFirm);
end;

procedure TfmFirm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Action := caFree;
   ConfirmDataSetCancel(qFirm);
   if qFirm.Modified then Action:=caNone;
end;

procedure TfmFirm.FormActivate(Sender: TObject);
begin
  CreateMenu(Self, qFirm, TDBGrid(DBGrid1),'', '');
  ReQuery(qFirm);
end;

procedure TfmFirm.FormStorage1SavePlacement(Sender: TObject);
begin
  SaveOrderBy(FormStorage1, qFirm);
end;

procedure TfmFirm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Key=VK_ESCAPE then Close;
end;

procedure TfmFirm.qFirmAfterPost(DataSet: TDataSet);
begin ReQuery(qFirm); end;

procedure TfmFirm.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
  if Button=nbRefresh then begin ReQuery(qFirm); Abort; end;
  if Button=nbInsert then begin qFirm.Append; Abort; end;
end;

procedure TfmFirm.DBGrid1CellClick(Column: TColumn);
begin
    if DBGrid1.SelectedField.DataType=ftBoolean then
      begin
        if not DBGrid1.DataSource.DataSet.Modified
          then DBGrid1.DataSource.DataSet.Edit;
        if DBGrid1.SelectedField.AsBoolean
          then DBGrid1.SelectedField.AsBoolean:=false
          else DBGrid1.SelectedField.AsBoolean:=true;
      end;
end;

procedure TfmFirm.qFirmAfterInsert(DataSet: TDataSet);
begin qFirm['IsOurs']:=false; end;

procedure TfmFirm.DBGrid1GetCellParams(Sender: TObject; Field: TField;
  AFont: TFont; var Background: TColor; Highlight: Boolean);
begin
     Background:=clWindow;
     AFont.Color:=clWindowText;
     if Field.DataType=ftBoolean then
     begin
       (DBGrid1.DataSource.DataSet.FieldByName(Field.FieldName) as TBooleanField).DisplayValues:=#252';';
       Field.Alignment:=taCenter;
       with AFont do begin
         CharSet:=SYMBOL_CHARSET;
         Style:=[fsBold];
         Size:=12;
         Color:=clGreen;
       end;
     end;
     SetUnknowColor(Field,AFont);
end;

procedure TfmFirm.DBGrid1EditChange(Sender: TObject);
begin
   if DBGrid1.SelectedField.DataType=ftBoolean then
   begin
     DBGrid1.Tag:=DBGrid1.SelectedIndex;
     DBGrid1.SelectedIndex:=-1;
     DBGrid1.SelectedIndex:=DBGrid1.Tag;
   end;
end;

procedure TfmFirm.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if ((DBGrid1.SelectedField.DataType=ftBoolean) and (Key=#32))
    then DBGrid1CellClick(nil);
end;

end.
