unit SBctrl;

interface

uses Windows, Sysutils, Classes, graphics, comctrls, Forms;

type
  TSBctrl = class
    private
      FText: string;
      FStyle:TFontStyles;
      FColor:TColor;
      FStatusBar:TStatusBar;
      FHint: string;
      procedure SetText(const Value: string);
      procedure SetColor(const Value: TColor);
      procedure SetStyle(const Value: TFontStyles);
    procedure SetHint(const Value: string);
    public
      constructor Create(StatusBar:TStatusBar);
      property Hint:string read FHint write SetHint;
      property Color:TColor read FColor write SetColor;
      property Style:TFontStyles read FStyle write SetStyle;
      property Text:string read FText write SetText;
      procedure DrawStatus(Rect:TRect);
      procedure Repaint;
    end;


implementation

{ SBctrl }

constructor TSBctrl.Create(StatusBar:TStatusBar);
begin
  FStatusBar := StatusBar;
  Ftext:='';
end;


procedure TSBctrl.DrawStatus(Rect: TRect);
begin
  FStatusBar.Canvas.Lock;
  FStatusBar.Canvas.Brush.Style:=bsClear;
  if Length(Trim(FText))>0 then
    begin
      FStatusBar.Canvas.Font.Style:=FStyle;
      FStatusBar.Canvas.Font.Color:=FColor;
      FStatusBar.Canvas.TextOut(Rect.left+3, Rect.top, FText);
    end
  else FStatusBar.Canvas.FillRect(Rect);
  FStatusBar.Canvas.UnLock;
end;

procedure TSBctrl.SetColor(const Value: TColor);
begin
  if Value<>FColor then
  begin
    FColor:=Value;
  end;
end;

procedure TSBctrl.SetHint(const Value: string);
begin
  if Value<>FHint then
  begin
    FHint:= Value;
    FStatusBar.Hint:=FHint;
  end;
end;

procedure TSBctrl.SetStyle(const Value: TFontStyles);
begin
  if Value<>FStyle then
  begin
    FStyle := Value;
  end;
end;

procedure TSBctrl.SetText(const Value: string);
begin
  if Value<>FText then
  begin
    FText := Value;
    SetHint('');
  end;
end;

procedure TSBctrl.Repaint;
begin
  Forms.Application.ProcessMessages;
  FStatusBar.Repaint;
  Forms.Application.ProcessMessages;
end;

end.
