unit SQLThrd;

interface

uses
  Classes, SysUtils, dbtables;

type
  TSQLThread = class(TThread)
  private
    ErrMsg:string;
    procedure ErrorShow;
  protected
    Query : TQuery;
    SQLstr:string;
    procedure Execute; override;
  public
    constructor SQLThreadCreate(SQLstring:string);
  end;

implementation

uses Common;

constructor TSQLThread.SQLThreadCreate(SQLstring:string);
begin
	inherited Create(False);
   SQLstr:=SQLstring;
end;

procedure TSQLThread.Execute;
begin
  try
    try  ;
       Query := TQuery.Create(nil);
       Query.DatabaseName := 'dbMain';
       Query.SQL.Add(SQLstr);
       Query.Prepare;
       Query.ExecSQL;


    except on E : Exception do
       begin
           ErrMsg:=E.Message;
           Synchronize(ErrorShow);
       end;
    end;
  finally
    Query.Free;
    Terminate;
  end;
end;

procedure TSQLThread.ErrorShow;
begin
  SQLErrorMsg('  :'
     +char(10)+char(13)+char(10)+char(13)+char(39)+SQLstr+char(39)
     +char(10)+char(13)+char(10)+char(13)+char(10)+char(13)
     +'  :'+char(10)+char(13)
     +char(10)+char(13)+char(39)+ErrMsg+char(39));
end;

end.
