unit SendMsg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, DBCtrls, Buttons, RXCtrls, mdMailSlot, Animate,
  GIFCtrl, RXSplit, ExtCtrls, RxLookup, StrUtils, syncobjs, unThrdSender;

type
  TfmSendMessage = class(TForm)
    dsUsers: TDataSource;
    qUsers: TQuery;
    Panel1: TPanel;
    lbAdressee: TRxDBLookupList;
    RxSplitter1: TRxSplitter;
    qUserssuid: TIntegerField;
    qUsersNameAdressee: TStringField;
    Panel3: TPanel;
    Panel2: TPanel;
    Memo: TMemo;
    Panel4: TPanel;
    Panel5: TPanel;
    RxLabel1: TRxLabel;
    btSend: TBitBtn;
    btSendP: TBitBtn;
    Panel6: TPanel;
    RxLabel2: TRxLabel;
    qUsersComputer: TStringField;
    qUsersProgram: TStringField;
    cbAll: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure MemoChange(Sender: TObject);
    procedure btSendClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RxGIFAnimator1DblClick(Sender: TObject);
    procedure MemoKeyPress(Sender: TObject; var Key: Char);
    procedure btSendPClick(Sender: TObject);
    procedure qUsersBeforeOpen(DataSet: TDataSet);
    procedure cbAllClick(Sender: TObject);
  end;

procedure CreateMSlotMessage;
procedure SendAdminAlert(const msg:string; const adr:string='all');

implementation

{$R *.DFM}

uses Common, QueryEx, AppInfo;

procedure CreateMSlotMessage;
begin
  GetOneForm(TfmSendMessage);
end;

procedure TfmSendMessage.FormCreate(Sender: TObject);
begin
  with qUsers do
  begin
    DatabaseName:=GetDBName;
    Open;
    FetchAll;
    First;
  end;
end;

procedure TfmSendMessage.MemoChange(Sender: TObject);
begin
  btSend.Enabled:=(Length(Trim(Memo.Text))>0);
  btSendP.Enabled:=(Length(Trim(Memo.Text))>0);
  if Length(Memo.Text)>400 then
  begin
    ErrorMsg('   400 ');
    Memo.Text:=copy(Memo.Text,1,400);
  end;
end;

procedure TfmSendMessage.btSendClick(Sender: TObject);
var msg:string; addrs:TAddrs;
begin
  if exists('select * from sysobjects where type='#39'U'#39
                   +' and name='#39'MessageHistory'#39) then
      DoSQL('insert into MessageHistory(LoginSender, LoginAdressee, Msg) values ('
            +'SUSER_NAME(), SUSER_NAME('+qUserssuid.AsString+'), '#39
            +ReplaceStr(ReplaceStr(Memo.Text,#39,'#'),'"','#')+#39')',true);
  if not IsAdmin then msg:='  '+GetUserFIO+#10#13#10#13
                 else msg:='  :'#10#13#10#13;
  msg:=msg+Memo.Text;
  if qUserssuid.AsInteger>0 then
    begin
     SetLength(addrs,1);
     addrs[0].comp:=qUsersComputer.AsString;
     addrs[0].slot:=qUsersProgram.AsString;
    end
  else
    with qUsers do
    begin
     First;
     DisableControls;
     try
       while not EOF do
       begin
         if (qUserssuid.AsInteger<>0) then
         begin
           SetLength(addrs,Length(addrs)+1);
           addrs[Length(addrs)-1].comp:=qUsersComputer.AsString;
           addrs[Length(addrs)-1].slot:=qUsersProgram.AsString;
         end;
         Next;
       end;
       First;
     finally
       EnableControls;
     end;
    end;
  TThreadSender.CreateEx(addrs,msg);
  ShowMessage(' ');
end;

procedure TfmSendMessage.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=VK_ESCAPE then Close;
end;

procedure TfmSendMessage.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfmSendMessage.RxGIFAnimator1DblClick(Sender: TObject);
//var srv,cmd:string;
begin
{  srv:=qUsersServer.AsString;
  cmd:=SYS_COMMAND_ATTR+' '+Memo.Text;
  if (srv<>'All') and (srv<>ADMIN_SLOT) then
     SendToMailSlot(srv,ExeFileName,cmd);
  if (srv=ADMIN_SLOT) then
     SendToMailSlot(ADMIN_HOST,ExeFileName,cmd);}
end;

procedure TfmSendMessage.MemoKeyPress(Sender: TObject; var Key: Char);
begin
  if Length(Memo.Text)>=400 then
  begin
    ErrorMsg('   400 ');
    Key:=#0
  end;
end;

procedure TfmSendMessage.btSendPClick(Sender: TObject);
var msg:string;
begin
  msg:=Memo.Text+#32;
  if Length(msg)>390 then raise Exception.Create('  '#10#13', ');
  SendAdminAlert(msg);
  ShowMessage('  ');
end;

procedure SendAdminAlert(const msg:string; const adr:string='all');
begin
  if adr<>'gleb' then SendToWinpopup('kuzn_vv', 'kuzn_vv', Login, msg);
  if adr<>'kuzn_vv' then SendToWinpopup('odissey', 'gleb', Login, msg);
end;

procedure TfmSendMessage.qUsersBeforeOpen(DataSet: TDataSet);
begin
  if cbAll.Checked
     then qUsers.ParamByName('PROGRAM').AsString:='ALL'
     else qUsers.ParamByName('PROGRAM').AsString:=GetProgName;
end;

procedure TfmSendMessage.cbAllClick(Sender: TObject);
begin
  ReQueryOne(qUsers);
end;

end.
