unit SystemEx;

interface

uses Windows, sysutils;

type pboolean=^boolean;

function ExecuteWait(const CmdLine: string; wait:Cardinal=INFINITE):Cardinal;
function GetLastWin32Error:string;
procedure AsyncProcedure(proc:TProcedure; const delay:integer=0);
function GetTempPathStr:string;

implementation

uses classes, Common;

type TAsyncProcedure=class(TThread)
     private
       Fproc:TProcedure;
       Fdelay:Integer;
       procedure ProcExec;
     public
       constructor CreateEx(proc:TProcedure; const delay:integer);
       procedure Execute; override;
     end;

procedure AsyncProcedure(proc:TProcedure; const delay:integer=0);
begin
  TAsyncProcedure.CreateEx(proc,delay);
end;

function GetLastWin32Error:string;
begin
  SetLength(result,10240) ;
  SetLength(result,FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_IGNORE_INSERTS,
              nil, GetLastError, 0, Pchar(result), 10240, nil));
end;

function ExecuteWait(const CmdLine: string; wait:Cardinal=INFINITE):Cardinal;
var pi:TProcessInformation; si:TStartupInfo;
begin
  GetStartupInfo(si);
  if CreateProcess(nil,pchar(CmdLine),nil,nil,false,0,nil,nil,si,pi) then
    begin
      result:=WaitForSingleObject(pi.hProcess, wait);
      CloseHandle(pi.hProcess);
    end
  else raise Exception.Create('Impossible to execute with message:'#10#13+GetLastWin32Error);
end;


function GetTempPathStr:string;
begin
  SetLength(result,MAX_PATH+1);
  SetLength(result,GetTempPath(MAX_PATH+1,Pchar(result)));
end;

{function GetTempFileNameStr:string;
var tmp_path:string;
begin
  tmp_path:=GetTempPathStr;
  SetLength(result,MAX_PATH+1);
  UINT GetTempFileName(pchar(tmp_path),'SMU',0,pchar(result));
end;}

{ TAsyncProcedure }

constructor TAsyncProcedure.CreateEx(proc: TProcedure; const delay: integer);
begin
  Create(true);
  Fproc:=proc;
  Fdelay:=delay;
  FreeOnTerminate:=true;
  Priority:=tpIdle;
  Resume;
end;

procedure TAsyncProcedure.Execute;
begin
  sleep(Fdelay);
  try Synchronize(ProcExec);
  except on e:Exception do  ErrorMsg(e.Message);
  end;
end;

procedure TAsyncProcedure.ProcExec;
begin
  Fproc;
end;

end.
