unit TreeReport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Qrctrls, QuickRpt, ExtCtrls, ComCtrls;

type
  TfrmTreeReport = class(TForm)
    QuickAbstractRep1: TQuickAbstractRep;
    QRLoopBandTitle: TQRLoopBand;
    QRLabelTitle: TQRLabel;
    QRLoopBandDetail: TQRLoopBand;
    QRImage1: TQRImage;
    QRLabel1: TQRLabel;
    procedure QRLoopBandDetailBeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  private
    { Private declarations }
    FTreeView: TTreeView;
    FcurrNode: TTreeNode;
    //FTitle: string;
    FLabelLeft, FImageLeft: integer;
  public
    { Public declarations }
    procedure PreviewTree(TreeView: TTreeView; Title: string);
  end;

procedure TreeReportPreview(TreeView: TTreeView; Title: string='');

implementation

{$R *.DFM}

procedure TreeReportPreview(TreeView: TTreeView; Title: string='');
var
  frmTreeReport: TfrmTreeReport;
begin
  frmTreeReport:= TfrmTreeReport.Create(nil);
  frmTreeReport.PreviewTree(TreeView, Title);
  frmTreeReport.Release;
end;


procedure TfrmTreeReport.PreviewTree(TreeView: TTreeView; Title: string);
begin
  If Length(Trim(Title))>0 then
  begin
    QRLoopBandTitle.PrintCount := 1;
    QRLabelTitle.Caption := Title;
  end;


  FTreeView := TreeView;
  FLabelLeft := QRLabel1.Left;
  FImageLeft := QRImage1.Left;
  QRLoopBandDetail.PrintCount := FTreeView.Items.Count;
  FcurrNode := FTreeView.Items[0];

  QuickAbstractRep1.Preview;
end;

procedure TfrmTreeReport.QRLoopBandDetailBeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
var
  aBitmap : TBitmap;
begin
  If FcurrNode=nil then Exit;

  QRLabel1.Left := FLabelLeft + FcurrNode.Level*20;
  QRImage1.Left := FImageLeft + FcurrNode.Level*20;

  QRLabel1.Caption := FcurrNode.Text;
  aBitmap := TBitmap.Create;
  FTreeView.Images.GetBitmap(FcurrNode.ImageIndex, aBitmap);
  QRImage1.Picture.Assign(aBitmap);
  aBitmap.Free;

  FcurrNode := FcurrNode.getNext;
end;

end.
