unit URep3T;

interface

uses SysUtils, DB, DbClient;


function PackDataSet(aDataSet: TDataSet): OleVariant;
procedure UnPackDataSet(aClientDataSet: TClientDataSet; Data: OleVariant);

function UnPackParams(ParamsData:OleVariant; ParamName: String): OleVariant;

implementation


function PackDataSet(aDataSet: TDataSet): OleVariant;
var
  data: OleVariant;
  size, i, j : integer;
begin
  size := 2 + (aDataSet.FieldCount*2) + (aDataSet.FieldCount*aDataSet.RecordCount);
  data := VarArrayCreate([1, size], varVariant);

  // first (2)
  data[1] := aDataSet.FieldCount;
  data[2] := 370;

  // metadata (FieldCount*2)
  for i:=0 to aDataSet.FieldCount-1 do
  begin
    data[3+ (i*2)] := Ord(aDataSet.Fields[i].DataType);
    data[4+ (i*2)] := aDataSet.Fields[i].FullName;
  end;

  // data  (RecordCount*FieldCount)
  aDataSet.First;
  for i:=0 to aDataSet.RecordCount-1 do
  begin
    size := 3 + (aDataSet.FieldCount*2) + (i*aDataSet.FieldCount);
    for j:=0 to aDataSet.FieldCount-1 do
    begin
      data[size + j] := aDataSet.Fields[j].Value;
    end;
    aDataSet.Next;
  end;
  result := data;
end;


procedure UnPackDataSet(aClientDataSet: TClientDataSet; Data: OleVariant);
var
  i, j, iFieldCount, iRecordCount, size : integer;
begin
  size := VarArrayHighBound(Data, 1);
  iFieldCount := Data[1];
  iRecordCount := Round((size - 2 - (iFieldCount*2)) / iFieldCount);

  for i:=0 to iFieldCount-1 do
  begin
    with aClientDataSet.FieldDefs.AddFieldDef do
    begin
      DataType := data[3+ (i*2)];
      Name     := data[4+ (i*2)];
    end;
  end;
  aClientDataSet.CreateDataSet;

  for i:=0 to iRecordCount-1 do
  begin
    size := 3 + (iFieldCount*2) + (i*iFieldCount);
    aClientDataSet.Append;
    for j:=0 to iFieldCount-1 do
    begin
      aClientDataSet.Fields[j].Value := data[size + j];
    end;
    aClientDataSet.Post;
  end;
end;


function UnPackParams(ParamsData: OleVariant; ParamName: String): OleVariant;
var
  i, size : integer;
  vParam: OleVariant;
  sName: String;
begin
  result := NULL;

  size := VarArrayHighBound(ParamsData, 1);
  for i:=1 to size do
  begin
    vParam := ParamsData[i];
    sName := vParam[1];
    If (sName=ParamName) then
    begin
      result := vParam[2];
      break;
    end;
  end;
end;


end.
