unit UserInfo;

interface

function GetLoginName: string;
function GetFullLoginName: string;
procedure ClearFullLoginName;

implementation

uses classes, dbtables, QueryEx;

function GetLoginName: string;
begin
  result := (GetDBObject as TDatabase).Params.Values['USER NAME'];
end;

var sFullLoginName: string;
var bFullLoginNameExists: Boolean;

function GetFullLoginName: string;
var
  sLoginName: String;
  iCnt: Integer;
begin
  if not bFullLoginNameExists then
  begin
    sLoginName := GetLoginName;
    iCnt := DLookup('select count(*) from vwURepLogins where LoginName='+Str2SQLstr(sLoginName)+' and IsRole=0');
    if iCnt>0 then
      sFullLoginName:=DLookup('select FullName from vwURepLogins where LoginName='+Str2SQLstr(sLoginName)+' and IsRole=0')
    else
      sFullLoginName:=sLoginName;
    bFullLoginNameExists := True;
  end;
  result := sFullLoginName;
end;

procedure ClearFullLoginName;
begin
  bFullLoginNameExists := False;
  sFullLoginName := '';
end;

initialization
  bFullLoginNameExists := False;

end.
