unit dlgOrd;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   Grids, StdCtrls, Buttons, DBTables, DB, RxGrids, RXCtrls, Placemnt,
   UpdQuery;

type
   TMyFieldRec = class (TObject)
     public
      num : integer;
      FieldName : string;
      DisplayLabel : string;
      DataType : TFieldType;
      FieldKind : TFieldKind;
      KeyFields : string;
      Desc : Boolean;
      Origin: String;
      constructor Create( aNum : integer; aFieldName : string;
         aDisplayLabel : string; aDataType : TFieldType;
         aFieldKind : TFieldKind;  aKeyFields : string; aOrigin: String='');
   end;

   TMyFieldList = class;

   TMyFieldList = class (TObject)
     private
      FList : TList;
      function getField( num : Integer ) : TMyFieldRec;
     public
      function Count : integer;
      function Add(Item: TMyFieldRec): Integer;
      procedure Delete(Index: Integer);
      property Field[num : Integer] : TMyFieldRec read getField;

      function getFieldByName( fldname : string ) : TMyFieldRec;
      procedure readFields( aDataSet : TDataSet );
      procedure Redraw( grid : TStringGrid );
      procedure RedrawRx( grid : TRxDrawGrid );
      procedure insFields( FullFieldList : TMyFieldList; OrdFieldName : string);

      constructor Create;
      destructor Destroy; override;
   end;


   TdlgOrder = class( TForm )
      gridLeft : TRxDrawGrid;
      BitBtnOK : TBitBtn;
      BitBtnCancel : TBitBtn;
      gridRight : TRxDrawGrid;
      Label1 : TLabel;
      Label2 : TLabel;
      btnRight : TButton;
      btnLeft : TButton;
      FormStorage1 : TFormStorage;
      procedure btnRightClick( Sender : TObject );
      procedure FormDestroy( Sender : TObject );
      procedure btnLeftClick( Sender : TObject );
      procedure gridLeftDblClick( Sender : TObject );
      procedure gridRightDblClick( Sender : TObject );
      procedure BitBtnOKClick( Sender : TObject );
      procedure gridLeftDrawCell( Sender : TObject; Col, Row : Integer;
         Rect : TRect; State : TGridDrawState );
      procedure gridRightDrawCell( Sender : TObject; Col, Row : Integer;
         Rect : TRect; State : TGridDrawState );
      procedure gridRightGetEditStyle( Sender : TObject; ACol, ARow : Integer;
         var Style : TInplaceEditStyle );
      procedure gridRightGetPicklist( Sender : TObject; ACol, ARow : Integer;
         PickList : TStrings );
      procedure gridRightSetEditText( Sender : TObject; ACol, ARow : Integer;
         const Value : string );
      procedure gridRightShowEditor( Sender : TObject; ACol, ARow : Integer;
         var AllowEdit : Boolean );
      procedure gridRightGetEditText( Sender : TObject; ACol, ARow : Integer;
         var Value : string );
   private
    { Private declarations }
      aDataSet : TDataSet;
      lstLeft : TMyFieldList;
      lstRight : TMyFieldList;
      //procedure readFields;
      procedure redrawFields;
      //procedure insFields( fNam : string );
      procedure MoveLeft;
      procedure MoveRight;
   public
    { Public declarations }
      constructor CreateDlg( AOwner : TComponent; aaDataSet : TDataSet );
   end;

procedure ResortDataSet(aDataSet: TDataSet; aFldList: TMyFieldList );

procedure ResortQuery( aQuery: TQuery; aFldList: TMyFieldList );
procedure ResortSP( aSProc: TStoredProc; aFldList: TMyFieldList );
function isResortedSP( aSProc: TStoredProc ) : Boolean;
function IsResortedSP_SQL(ds:TDataSet) : Boolean;
procedure readFieldsOrdList(lstLeft, lstRight: TMyFieldList; aDataSet: TDataSet);

const
   cnstAscnOrder = '';
   cnstDescOrder = '';
   cnstSPparSortPart = '@parSortPart';
   cnstSP_SQLparSortPart = 'SortCritery'; {gleb   for use in SQL property}


implementation
{$R *.DFM}
uses Common, CommonVV, QueryEx;

constructor TMyFieldRec.Create( aNum : integer; aFieldName : string;
   aDisplayLabel : string; aDataType : TFieldType ;
   aFieldKind : TFieldKind;  aKeyFields : string; aOrigin: String);
begin
   num := aNum;
   FieldName := aFieldName;
   DisplayLabel := aDisplayLabel;
   DataType := aDataType;
   FieldKind := aFieldKind;
   KeyFields := aKeyFields;
   Desc := False;
   Origin := aOrigin;
end;

constructor TMyFieldList.Create;
begin
  FList := TList.Create;
end;

destructor TMyFieldList.Destroy;
var
  i: integer;
  aMyFieldRec : TMyFieldRec;
begin
  for i:=0 to Count-1 do
    begin
    aMyFieldRec := TMyFieldRec(FList.Items[i]);
    if assigned(aMyFieldRec) then
      aMyFieldRec.Free;
    end;
  FList.Free;

  inherited Destroy;
end;

function TMyFieldList.Count : integer;
begin
  result := FList.Count;
end;

function TMyFieldList.Add(Item: TMyFieldRec): Integer;
begin
  result := FList.Add(Item);
end;

procedure TMyFieldList.Delete(Index: Integer);
begin
  FList.Delete(Index);
end;

function TMyFieldList.getField( num : Integer ) : TMyFieldRec;
begin
   result := TMyFieldRec( FList.Items[num] );
end;

function TMyFieldList.getFieldByName( fldname : string ) : TMyFieldRec;
var
   i : integer;
begin
   result := nil;
   for i := 0 to Count - 1 do
      if getField( i ).FieldName = fldname then
         begin
            result := TMyFieldRec( FList.Items[i] );
            break;
         end;
end;

procedure TMyFieldList.readFields( aDataSet : TDataSet );
var
   i : integer;
   aFieldRec : TMyFieldRec;
begin
   //  
   for i := 0 to aDataSet.FieldCount - 1 do
     with aDataSet.Fields[i] do
       begin
       if ( not calculated ) then
         begin
         aFieldRec := TMyFieldRec.Create( i, FieldName, DisplayLabel, DataType, FieldKind, KeyFields, Origin);
         FList.Add( aFieldRec );
         end;
       end;
end;


procedure TMyFieldList.Redraw( grid : TStringGrid );
var
   i : integer;
begin
   for i := 0 to Count - 1 do
      with getField( i ) do
         begin
            grid.Cells[0, i + 1] := FieldName;
            grid.Cells[1, i + 1] := DisplayLabel;
         end;
   if Count = 0 then
      begin
         grid.RowCount := 2;
         grid.Cells[0, 1] := '';
         grid.Cells[1, 1] := '';
      end
   else
      grid.RowCount := Count + 1;
end;

procedure TMyFieldList.RedrawRx( grid : TRxDrawGrid );
begin
   if Count = 0 then
      grid.RowCount := 2
   else
      grid.RowCount := Count + 1;
   grid.Invalidate;
end;

procedure TMyFieldList.insFields( FullFieldList :TMyFieldList ; OrdFieldName : string);
var
   aFieldRec : TMyFieldRec;
   i, t, nDesc : integer;
   sFldN : string;
begin
   t := Pos( '.', OrdFieldName );
   if t > 0 then
      sFldN := Copy( OrdFieldName, t + 1, length( OrdFieldName ) )
   else
      sFldN := OrdFieldName;

   nDesc := Pos( 'DESC', UpperCase( sFldN ) );
   if nDesc > 0 then
      sFldN := Trim( Copy( sFldN, 1, nDesc - 1 ) );

   for i := 0 to FullFieldList.Count - 1 do
      if FullFieldList.getField( i ).FieldName =
          TRIM( sFldN ) then
         begin
            aFieldRec := FullFieldList.getField( i );
            if nDesc > 0 then
               aFieldRec.Desc := True;
            Self.Add( aFieldRec );
            FullFieldList.Delete( i );
            break;
         end;
end;

//----------------------------------------------------------------

constructor TdlgOrder.CreateDlg( AOwner : TComponent; aaDataSet : TDataSet );
begin
   inherited Create( AOwner );
   aDataSet := aaDataSet;
   lstLeft := TMyFieldList.Create;
   lstRight := TMyFieldList.Create;
   readFieldsOrdList(lstLeft, lstRight, aDataSet);
   redrawFields;

   if ((aDataSet is TStoredProc) and (not isResortedSP(TStoredProc(aDataSet))))
        or ((aDataSet is TQuery) and (not(aDataSet is TUpdQuery) ))
      then BitBtnOK.Enabled := False;
end;

procedure TdlgOrder.FormDestroy( Sender : TObject );
begin
   lstLeft.Free;
   lstRight.Free;
end;


procedure readFieldsOrdList(lstLeft, lstRight: TMyFieldList; aDataSet: TDataSet);
var
   Len, jj : integer;
   sSQL, ss, sf : string;
   aQuery : TQuery;
   strField, strProcParam : string;
begin
   strField := ' ';
  //  
   lstLeft.readFields( aDataSet );
  //  
   // :: TQuery
   if ( aDataSet is TQuery ) and (not IsResortedSP_SQL(aDataSet)) then
      begin
         aQuery := ( aDataSet as TQuery );
         sSQL := trim( aQuery.SQL.Text );

         jj := Pos( 'ORDER BY', UpperCase( sSQL ) );
         if jj > 0 then
            begin
               ss := Trim( Copy( sSQL, jj + 8, Length( sSQL ) ) );
               while Length( ss ) > 1 do
                  begin
                     jj := Pos( ',', ss );
                     if jj > 0 then
                        begin
                           sf := Trim( Copy( ss, 1, jj - 1 ) );
                           lstRight.insFields(lstLeft, sf );
                           ss := Trim( Copy( ss, jj + 1, Length( ss ) ) );
                        end
                     else
                        begin
                           if Length( ss ) > 1 then
                              begin
                                 sf := Trim( ss );
                                 lstRight.insFields(lstLeft, sf );
                              end;
                           break;
                        end;
                  end;
            end;
      end;
   // :: TStoredProc
   if ( aDataSet is TStoredProc ) and
      (isResortedSP(aDataSet as TStoredProc)) then
      begin
         strProcParam := ( aDataSet as TStoredProc ).ParamByName(cnstSPparSortPart).AsString;
         strProcParam := Trim( strProcParam );
         Len := Length( strProcParam );
         jj := 1;
         while jj <= Len do
            begin
               if strProcParam[jj] <> ',' then
                  strField := strField + strProcParam[jj]
               else
                  begin
                     lstRight.insFields(lstLeft, strField );
                     strField := ' ';
                  end;
               jj := jj + 1;
            end;
         //     ',',  
         lstRight.insFields(lstLeft, strField );
      end;
   if ( aDataSet is TQuery ) and IsResortedSP_SQL(aDataSet) then
   begin
     strProcParam := TQuery(aDataSet).ParamByName(cnstSP_SQLparSortPart).AsString;
     strProcParam := Trim( strProcParam );
     Len := Length( strProcParam );
     jj := 1;
     while jj <= Len do
     begin
       if strProcParam[jj] <> ',' then
          strField := strField + strProcParam[jj]
       else
          begin
             lstRight.insFields(lstLeft, strField );
             strField := ' ';
          end;
       jj := jj + 1;
     end;
     //     ',',  
     lstRight.insFields(lstLeft, strField );
   end;
end;

procedure TdlgOrder.redrawFields;
begin
  // Left
   lstLeft.RedrawRx( gridLeft );
  // Right
   lstRight.RedrawRx( gridRight );
end;

procedure TdlgOrder.MoveRight;
var
   aFieldRec : TMyFieldRec;
   sel : integer;
begin
   if lstLeft.Count > 0 then
      begin
         sel := gridLeft.Row - 1;
         aFieldRec := lstLeft.getField( sel );
         lstLeft.Delete( sel );
         lstRight.Add( aFieldRec );
         redrawFields;
      end;
end;

procedure TdlgOrder.MoveLeft;
var
   aFieldRec : TMyFieldRec;
   sel : integer;
begin
   if ( lstRight.Count > 0 ) and
      ( gridRight.EditorMode = False ) then
      begin
         sel := gridRight.Row - 1;
         aFieldRec := lstRight.getField( sel );
         aFieldRec.Desc := False;
         lstRight.Delete( sel );
         lstLeft.Add( aFieldRec );
         redrawFields;
      end;
end;

procedure TdlgOrder.btnRightClick( Sender : TObject );
begin
   MoveRight;
end;

procedure TdlgOrder.btnLeftClick( Sender : TObject );
begin
   MoveLeft;
end;

procedure TdlgOrder.gridLeftDblClick( Sender : TObject );
begin
   MoveRight;
end;

procedure TdlgOrder.gridRightDblClick( Sender : TObject );
begin
   MoveLeft;
end;

procedure TdlgOrder.BitBtnOKClick( Sender : TObject );
begin
   ResortDataSet(aDataSet, lstRight);
end;

{
function getFullField( sSQL, sFldname : string ) : string;
var
  i1, i2, k1, k2 : integer;
  s1 : string;
begin
  result := '';

  i1 := Pos( 'SELECT', UpperCase( sSQL ) ) + 6;
  i2 := Pos( 'FROM', UpperCase( sSQL ) );
  s1 := Copy( sSQL, i1, i2 - i1 );
  k1 := Pos( sFldname, s1 );
  if k1 > 0 then
    begin
    while s1[k1] <> ' ' do
      Dec( k1 );
    s1 := Trim( Copy( s1, k1, length( s1 ) ) ) + ' ';

    for k2 := 1 to length( s1 ) do
      if s1[k2] in [' ', ','] then
        begin
        result := Copy( s1, 1, k2 - 1 );
        break;
        end;
    end
  else // *
    result := sFldname;
end;
}


procedure ResortQuery( aQuery : TQuery; aFldList : TMyFieldList );
var
  sFullSQL, sWoSQL, ss : string;
  i : integer;
  aMyFieldRec: TMyFieldRec;
   strSortPart : string;
begin
  if not IsResortedSP_SQL(aQuery) then
    begin
      //  SQL  ORDER BY
      sFullSQL := trim( aQuery.SQL.Text );
      sWoSQL := GetSQLWithoutOrderBy(aQuery);
      ss := sWoSQL;

      if aFldList.Count > 0 then
        begin // ORDER BY  
        ss := sWoSQL + ' ORDER BY ';
        for i := 0 to aFldList.Count - 1 do
          begin
          aMyFieldRec := aFldList.Field[i];
          case aMyFieldRec.FieldKind of
            fkData :
              If Length(Trim(aMyFieldRec.Origin))>0 then
                ss := ss + aMyFieldRec.Origin
              else
              ss := ss + aMyFieldRec.FieldName ;
            fkLookup :
              ss := ss + aMyFieldRec.KeyFields ;
            else
              begin
              WarningMsg('   '+aMyFieldRec.FieldName+'  ');
              ss := sFullSQL;
              break;
              end;
            end;

          if aMyFieldRec.Desc then
            ss := ss + ' DESC';
          if  i<>(aFldList.Count - 1) then
            ss := ss + ', ';
          end;
        end;
      ReQueryOne( aQuery, ss );
    end
  else
    begin
      for i := 0 to aFldList.Count - 1 do
      begin
        strSortPart := strSortPart + ',' + aFldList.GetField(i).FieldName;
        if aFldList.GetField(i).Desc then
          strSortPart := strSortPart + ' DESC'
      end;
      //     
      if length(strSortPart)>0 then strSortPart[1] := ' ';
      if aQuery.Active then aQuery.Close;
      aQuery.ParamByName(cnstSP_SQLparSortPart).AsString := strSortPart;
      ReQueryOne(aQuery);
    end;
end;

procedure TdlgOrder.gridLeftDrawCell( Sender : TObject; Col, Row : Integer;
   Rect : TRect; State : TGridDrawState );
var
   ss : string;
begin
   ss := '';
   if Row = 0 then
      begin
         case Col of
            0 : ss := '';
            1 : ss := ' ';
         end;
      end
   else
      begin
         if lstLeft.Count > 0 then
            begin
               with lstLeft.getField( Row - 1 ) do
                  begin
                     case Col of
                        0 : ss := FieldName;
                        1 : ss := DisplayLabel;
                     end;
                  end;
            end;
      end;
   gridLeft.DrawStr( Rect, ss, taLeftJustify );
end;

procedure TdlgOrder.gridRightDrawCell( Sender : TObject; Col, Row : Integer;
   Rect : TRect; State : TGridDrawState );
var
   ss : string;
begin
   ss := '';
   if Row = 0 then
      begin
         case Col of
            0 : ss := '';
            1 : ss := ' ';
            2 : ss := '.';
         end;
      end
   else
      begin
         if lstRight.Count > 0 then
            begin
               with lstRight.getField( Row - 1 ) do
                  begin
                     case Col of
                        0 : ss := FieldName;
                        1 : ss := DisplayLabel;
                        2 :
                           if Desc then
                              ss := cnstDescOrder
                           else
                              ss := cnstAscnOrder;
                     end;
                  end;
            end;
      end;
   gridRight.DrawStr( Rect, ss, taLeftJustify );
end;

procedure TdlgOrder.gridRightGetEditStyle( Sender : TObject; ACol,
   ARow : Integer; var Style : TInplaceEditStyle );
begin
   if ACol = 2 then
      Style := iePickList
   else
      Style := ieSimple;
end;

procedure TdlgOrder.gridRightGetPicklist( Sender : TObject; ACol,
   ARow : Integer; PickList : TStrings );
begin
   if ACol = 2 then
      begin
         PickList.Add( cnstAscnOrder );
         PickList.Add( cnstDescOrder );
      end;
end;

procedure TdlgOrder.gridRightSetEditText( Sender : TObject; ACol,
   ARow : Integer; const Value : string );
begin
   if ACol = 2 then
      if ( Value = cnstDescOrder ) and ( lstRight.Count > 0 ) then
         lstRight.getField( ARow - 1 ).Desc := True
      else
         lstRight.getField( ARow - 1 ).Desc := False;
end;

procedure TdlgOrder.gridRightShowEditor( Sender : TObject; ACol,
   ARow : Integer; var AllowEdit : Boolean );
begin
   AllowEdit := True;
   if ( lstRight.Count = 0 ) or ( ACol <> 2 ) then
      AllowEdit := False;
end;

procedure TdlgOrder.gridRightGetEditText( Sender : TObject; ACol,
   ARow : Integer; var Value : string );
begin
   if ACol = 2 then
      if ( lstRight.Count > 0 ) and
         ( lstRight.getField( ARow - 1 ).Desc = True ) then
         Value := cnstDescOrder
      else
         Value := cnstAscnOrder;
end;

function isResortedSP( aSProc : TStoredProc ) : Boolean;
var i : Integer;
begin
  result := False;
  with aSProc.Params do
  begin
    for i:=0 to Count-1 do
    begin
      if Items[i].Name=cnstSPparSortPart then
      begin
        result := True;
        Break;
      end;
    end;
  end;
end;

function IsResortedSP_SQL(ds:TDataSet) : Boolean;
var i:Integer;
begin
  result:=false;
  for i:=0 to TQuery(ds).ParamCount-1 do
  begin
    if TQuery(ds).Params[i].Name=cnstSP_SQLparSortPart then
    begin
      result:=true;
      exit;
    end;
  end;
end;

procedure ResortSP( aSProc : TStoredProc; aFldList : TMyFieldList );
var
   i : Integer;
   strSortPart : string;
begin
  if not isResortedSP(aSProc) then Exit;
  for i := 0 to aFldList.Count - 1 do
    begin
    strSortPart := strSortPart + ',' + aFldList.GetField( i ).FieldName;
    if aFldList.GetField( i ).Desc then
      strSortPart := strSortPart + ' DESC'
    end;
  //     
  strSortPart[1] := ' ';
  if aSProc.Active then
    aSProc.Close;

  aSProc.ParamByName(cnstSPparSortPart).AsString := strSortPart;

  try
    aSProc.Open;
  except
    on E : Exception do
      begin
      MessageDlg( '  .' + #10 + #13 + ':'
               + #10 + #13 + E.Message, mtError, [mbCancel], 0 );
      Exit;
      end;
  end;
end;

procedure ResortDataSet(aDataSet  : TDataSet; aFldList : TMyFieldList );
var id:integer; fld:TField;
begin
   fld:=aDataSet.FindField('Id');
   if fld<>nil then id:=fld.AsInteger else id:=0;
   if ( aDataSet is TQuery ) then
      ResortQuery( ( aDataSet as TQuery ), aFldList );

   if ( aDataSet is TStoredProc ) then
      ResortSP( ( aDataSet as TStoredProc ), aFldList );
   if (fld=nil) or (not aDataSet.Locate('Id',id,[]))
     then aDataSet.First;
end;

end.

