unit dmdURep;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, Db, DBTables, QUICKRPT, qrddlgs, QRExport, QRDesign,
  mwHighlighter, vvSQLSyn, vvVBSSyn, vvJScript, AskMe, DcjPerlSyn,
  URepQuery;

type
  TURepTreeSortOrder = (soNumm, soName, soId);

  TdmURep = class(TDataModule)
    imgLstURep: TImageList;
    qQuery: TQuery;
    qForm: TQuery;
    qQueryId: TAutoIncField;
    qQueryNumm: TIntegerField;
    qQueryName: TStringField;
    qFormId: TAutoIncField;
    qFormNumm: TIntegerField;
    qFormName: TStringField;
    qQueryParam: TQuery;
    qQueryParamId: TAutoIncField;
    qQueryParamIdQuery: TIntegerField;
    qQueryParamNumm: TIntegerField;
    qQueryParamParName: TStringField;
    qQueryParamParLabel: TStringField;
    qQueryParamIdParTyp: TIntegerField;
    qFrm2Qry: TQuery;
    qFrm2QryId: TAutoIncField;
    qFrm2QryIdForm: TIntegerField;
    qFrm2QryNumm: TIntegerField;
    qFrm2QryIdQuery: TIntegerField;
    qGroup: TQuery;
    qGroupId: TAutoIncField;
    qGroupGrpName: TStringField;
    qGroupIdParent: TIntegerField;
    qGrpBody: TQuery;
    qFrmRep: TQuery;
    qFrmRepReport: TBlobField;
    qFormIdDestination: TIntegerField;
    qFormIdTypExec: TIntegerField;
    QRTextFilter1: TQRTextFilter;
    QRCSVFilter1: TQRCSVFilter;
    QRHTMLFilter1: TQRHTMLFilter;
    ReportDesignerDialog1: TReportDesignerDialog;
    QRExcelFilter1: TQRExcelFilter;
    QRRTFFilter1: TQRRTFFilter;
    QRWMFFilter1: TQRWMFFilter;
    dsGroup: TDataSource;
    dsForm: TDataSource;
    qMSservers: TQuery;
    qFormDescription: TStringField;
    qScript: TQuery;
    qScriptId: TAutoIncField;
    qScriptNumm: TIntegerField;
    qScriptName: TStringField;
    qScriptBody: TQuery;
    qScriptBodyScriptText: TMemoField;
    qScriptBodyScrEngName: TStringField;
    qFrmRepId: TAutoIncField;
    qFrmRepIdDestination: TIntegerField;
    qFrmRepIdTypExec: TIntegerField;
    qImports: TQuery;
    qImportsBody: TQuery;
    qImportsBodyId: TAutoIncField;
    qImportsBodyName: TStringField;
    qImportsBodyDescription: TStringField;
    qImportsBodyNumm: TIntegerField;
    qImportsBodyFileTemplate: TStringField;
    qImportsBodyIdScrEng: TIntegerField;
    qImportsBodySQLtext: TMemoField;
    qImportsBodyScriptText: TMemoField;
    qImportsBodyScrEngName: TStringField;
    qImportsId: TAutoIncField;
    qImportsNumm: TIntegerField;
    qImportsName: TStringField;
    qImportsFileTemplate: TStringField;
    VBSsyntax: TvvVbsSyn;
    SQLSyntax: TvvSqlSyn;
    qRemoteData: TQuery;
    qRemoteDataId: TAutoIncField;
    qRemoteDataNumm: TIntegerField;
    qRemoteDataName: TStringField;
    qGrpBodyId: TAutoIncField;
    qGrpBodyIdScript: TIntegerField;
    qGrpBodyIdGroup: TIntegerField;
    qGrpBodyIdForm: TIntegerField;
    qGrpBodyNumm: TIntegerField;
    qFrm2QryQueryShortName: TStringField;
    qFrm2QryIdRemoteData: TIntegerField;
    qGrpBodyName: TStringField;
    qGrpBodyIdDestination: TIntegerField;
    qGrpBodyIdTypExec: TIntegerField;
    qFrm2QryName: TStringField;
    qGroupNumm: TIntegerField;
    JScriptSyntax: TvvJScriptSyn;
    qScriptBodyName: TStringField;
    qScrEng: TQuery;
    qScrEngIval: TIntegerField;
    qScrEngItem: TStringField;
    qScrEngComment: TStringField;
    qRemoteDataParam: TQuery;
    qRemoteDataParamId: TAutoIncField;
    qRemoteDataParamIdRemoteData: TIntegerField;
    qRemoteDataParamNumm: TIntegerField;
    qRemoteDataParamParName: TStringField;
    qRemoteDataParamParLabel: TStringField;
    qRemoteDataParamIdParTyp: TIntegerField;
    PerlSyntax: TDcjPerlSyn;
    qFrm2QryIsMaster: TIntegerField;
    qTypObj: TQuery;
    qTypObjIval: TIntegerField;
    qTypObjItem: TStringField;
    procedure ReportDesignerDialog1AfterReportLoaded(Form: TForm;
      QRD: TComponent);
    procedure ReportDesignerDialog1BeforeOpenDataset(DS: TDataset);
    procedure qMSserversBeforeOpen(DataSet: TDataSet);
    procedure SetOrderByBeforeOpen(DataSet: TDataSet);
    procedure qGroupBeforeOpen(DataSet: TDataSet);
    procedure qGrpBodyBeforeOpen(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    FParAskList: TParamAskMeList;
    FQueryList : TQueryList;
    FFrmName: string;

    FSortOrder: TURepTreeSortOrder;
  end;

var
  dmURep: TdmURep;

const
  URepTreeSortGrpOrderStr : array [TURepTreeSortOrder] of string =
    ('Numm', 'GrpName', 'Id');

  URepTreeSortGBOrderStr : array [TURepTreeSortOrder] of string =
    ('2, 5', '2, 6', '2, 1');
    //('IdGroup, gb.Numm', 'IdGroup, Name', 'IdGroup, gb.Id');

  URepTreeSortOrderString : array [TURepTreeSortOrder] of string =
    ('Numm', 'Name', 'Id');


function GetProgName:string;

implementation

{$R *.DFM}

uses fURepFunc1, URepConstants, Common, CommonVV, Qrdsgn2;


procedure TdmURep.ReportDesignerDialog1AfterReportLoaded(Form: TForm;
  QRD: TComponent);
begin
  URepCreateDataSets(Form, FParAskList, FQueryList, True);
  (QRD as TQRDLoader).QReport.ReportTitle := FFrmName;
end;

procedure TdmURep.ReportDesignerDialog1BeforeOpenDataset(DS: TDataset);
var
  aQueryItem: TQueryListItem;
  aFld : TField;
  j: integer;
  aURepQuery : TURepQuery;
  aQuery : TQuery;
begin
  if DS.Name = cnstUsrPARAM then Exit;
  aQueryItem := FQueryList.ItemByShortName(DS.Name);

  if aQueryItem.QueryType=AskMe.ttSQL then    //ttSQL
  begin
    if (DS is TURepQuery) then
    begin
      aURepQuery := TURepQuery(DS);
      with aURepQuery do // reopen with new SQL
        if SQL.text<>aQueryItem.sqltext then
          SQL.text := aQueryItem.sqltext;
    end;

    if (DS is TQuery) then
    begin
      aQuery := TQuery(DS);
      with aQuery do // reopen with new SQL
        if SQL.text<>aQueryItem.sqltext then
          SQL.text := aQueryItem.sqltext;
    end;

    with DS do
    begin
      for j:=1 to FieldDefs.Count Do //create new Fields ?????
      begin
        aFld:=FindField(FieldDefs[j-1].Name);
        If aFld=NIL Then
          FieldDefs.Find(FieldDefs[j-1].Name).CreateField(DS);
      end;                         //create new Fields ?????
      Tag := aQueryItem.id;
    end;

    DataSetBindParamAskMe(DS, FParAskList);
    URepSetMasterDtSrc(DS.Owner, DS, FQueryList);
  end;
end;

function GetProgName:string;
var i:integer; IsDebug:boolean;
begin
   result:=UpperCase(ExtractFileName(ParamStr(0)));
   IsDebug:=(result='DELPHI32.EXE');
   if IsDebug then
    for i:=1 to ParamCount do
     if pos('.EXE',ParamStr(i))>0 then
     begin
       result:=UpperCase(ExtractFileName(ParamStr(i)));
       break;
     end;
   if pos('.EXE',result)>0 then result:=copy(result,1,pos('.EXE',result)-1);
   if IsDebug then result:=result+'_DEBUG';
end;

procedure TdmURep.qMSserversBeforeOpen(DataSet: TDataSet);
begin
  qMSservers.ParamByName('PROGRAM').AsString := GetProgName;
end;

procedure TdmURep.SetOrderByBeforeOpen(DataSet: TDataSet);
begin
  setOrderBy(DataSet, cnstOrderBy+URepTreeSortOrderString[FSortOrder]);
end;

procedure TdmURep.qGroupBeforeOpen(DataSet: TDataSet);
begin
  setOrderBy(DataSet, cnstOrderBy+URepTreeSortGrpOrderStr[FSortOrder]);
end;

procedure TdmURep.qGrpBodyBeforeOpen(DataSet: TDataSet);
begin
  setOrderBy(DataSet, cnstOrderBy+URepTreeSortGBOrderStr[FSortOrder]);
end;

end.

