unit fImport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, Db, DBCtrls, DBTables, Grids, DBGrids, RXDBCtrl,
  Placemnt, StdCtrls, Mask, RxLookup, Buttons, ToolEdit, mwCustomEdit,
  DBmwEdit, ToolWin, UpdQuery, StrUtils, ActnList, SmartDBmwEdit;

type
  TfrmImportSet = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    RxDBGrid1: TRxDBGrid;
    qSelImports: TUpdQuery;
    dsSelImports: TDataSource;
    qSelImportsId: TAutoIncField;
    qSelImportsName: TStringField;
    qSelImportsDescription: TStringField;
    qSelImportsNumm: TIntegerField;
    qSelImportsFileTemplate: TStringField;
    qSelImportsIdScrEng: TIntegerField;
    FormPlacement1: TFormPlacement;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label6: TLabel;
    qSelImportsScrEngName: TStringField;
    TabSheetTest: TTabSheet;
    FilenameEdit1: TFilenameEdit;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    StatusBarSQL: TStatusBar;
    DBmwEditSQL: TSmartDBmwEdit;
    Panel2: TPanel;
    Label7: TLabel;
    LookupComboImport: TRxDBLookupCombo;
    DBNavigator2: TDBNavigator;
    q1Import: TQuery;
    ds1Import: TDataSource;
    q1ImportId: TAutoIncField;
    q1ImportName: TStringField;
    q1ImportDescription: TStringField;
    q1ImportNumm: TIntegerField;
    q1ImportFileTemplate: TStringField;
    q1ImportIdScrEng: TIntegerField;
    q1ImportSQLtext: TMemoField;
    q1ImportScriptText: TMemoField;
    q1ImportScrEngName: TStringField;
    StatusBarScript: TStatusBar;
    DBmwEditScript: TSmartDBmwEdit;
    DBEdit5: TDBEdit;
    Label8: TLabel;
    ActionList1: TActionList;
    ActionRight: TAction;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    DBNavigator1: TDBNavigator;
    dsScrEng: TDataSource;
    DBLookupComboBox1: TDBLookupComboBox;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActionBrowser: TAction;
    ActionReferenses: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PageControl1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure LookupComboImportChange(Sender: TObject);
    procedure q1ImportNewRecord(DataSet: TDataSet);
    procedure q1ImportBeforeOpen(DataSet: TDataSet);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure DBmwEditScriptChange(Sender: TObject);
    procedure DBmwEditScriptLoadData(Sender: TObject);
    procedure ds1ImportDataChange(Sender: TObject; Field: TField);
    procedure DBmwEditSQLChange(Sender: TObject);
    procedure DBmwEditSQLLoadData(Sender: TObject);
    procedure LookupComboImportDropDown(Sender: TObject);
    procedure LookupComboImportCloseUp(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure dsSelImportsDataChange(Sender: TObject; Field: TField);
    procedure q1ImportAfterPost(DataSet: TDataSet);
    procedure q1ImportBeforePost(DataSet: TDataSet);
    procedure q1ImportAfterDelete(DataSet: TDataSet);
    procedure ActionRightExecute(Sender: TObject);
    procedure q1ImportAfterOpen(DataSet: TDataSet);
    procedure DBmwEditSQLStatusChange(Sender: TObject;
      Changes: TmwStatusChanges);
    procedure DBmwEditScriptStatusChange(Sender: TObject;
      Changes: TmwStatusChanges);
    procedure ActionBrowserExecute(Sender: TObject);
    procedure ActionReferensesExecute(Sender: TObject);
    procedure DBmwEditScriptDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure DBmwEditScriptDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure qSelImportsBeforeOpen(DataSet: TDataSet);
  private
    { Private declarations }
    WasInsert : Boolean;
    procedure ScrTextInfoUpdate;
    procedure SQLTextInfoUpdate;
    procedure ReQueryq1Import;
  public
    { Public declarations }
  end;

var
  frmImportSet: TfrmImportSet;

implementation

{$R *.DFM}

uses Common, CommonVV, QueryEx, LayoutEx, ImportActScrSite, dmdURep, fURepRights,
     URepGen_TLB, AppUtils, fURepBrowser, unAxBowser, fURepReferences, URepConstants;

procedure TfrmImportSet.FormCreate(Sender: TObject);
begin
  If not dmURep.qScript.Active then dmURep.qScript.Open;
  PageControl1.ActivePage := TabSheet1;
  ReQueryAll(Self);

  qSelImports.First;
  LookupComboImport.Value:= qSelImportsId.AsString;
  if qSelImports.RecordCount=0 then
    ReQueryq1Import;

  //controls layout
  FitControlLeftToParent(DBNavigator2);
  FitControlWidthToRControl(LookupComboImport, DBNavigator2);
  FitControlWidthToParent(DBEdit1);
  FitControlWidthToParent(DBEdit2);
  FitControlWidthToParent(DBEdit3);
  FitControlWidthToParent(FilenameEdit1);
end;

procedure TfrmImportSet.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmImportSet.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePage = TabSheetTest then
  begin
    FilenameEdit1.FileName := q1ImportFileTemplate.Value;
  end;
  if PageControl1.ActivePage <> TabSheet1 then
  begin
    if q1ImportId.Value<>StrToIntDef(LookupComboImport.Value,0) then
      ReQueryq1Import;
  end;
  if PageControl1.ActivePage = TabSheet4 then
  begin
    ScrTextInfoUpdate;
  end;
end;

procedure TfrmImportSet.BitBtn1Click(Sender: TObject);
begin
  RunImportScript(q1ImportId.Value, FilenameEdit1.FileName, DBmwEditScript);
end;

procedure TfrmImportSet.LookupComboImportChange(Sender: TObject);
begin
  if PageControl1.ActivePage <> TabSheet1 then
  begin
    ReQueryq1Import;
  end
end;


procedure TfrmImportSet.q1ImportNewRecord(DataSet: TDataSet);
var
  params : TParams;
begin
  //q1ImportNumm.Value := DLookup('declare @numm int '+
  //                     'Exec @numm=spURepImportsNumm '+
  //                     'select @numm');;
  params := TParams.Create;
  try
    params.CreateParam(DB.ftInteger, prmPrefix+fldNumm, ptOutput);
    ExecSP('spURepImportsNumm', params);
    q1ImportNumm.Value := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;

  PageControl1.ActivePage := TabSheet2;
end;

procedure TfrmImportSet.q1ImportBeforeOpen(DataSet: TDataSet);
begin
  q1Import.ParamByName('Id').asInteger := StrToIntDef(LookupComboImport.Value, 0);
end;

procedure TfrmImportSet.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  if LookupComboImport.Value <> qSelImportsId.asString then
    LookupComboImport.Value := qSelImportsId.asString;
end;

procedure TfrmImportSet.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then
   begin
     ReQueryq1Import;
     Abort;
   end;
   if Button=nbInsert then
   begin
     q1Import.Append;
     Abort;
   end;
   if Button=nbDelete then
   begin
     PageControl1.ActivePage := TabSheet2;
     if LookupComboImport.Value <> q1ImportId.asString then
       ReQueryq1Import;
   end;
   if Button=nbEdit then
   begin
     if PageControl1.ActivePage = TabSheet1 then
       PageControl1.ActivePage := TabSheet2;
     if LookupComboImport.Value <> q1ImportId.asString then
       ReQueryq1Import;
   end;
end;

procedure TfrmImportSet.DBmwEditScriptChange(Sender: TObject);
begin
  ScrTextInfoUpdate;
end;

procedure TfrmImportSet.DBmwEditScriptLoadData(Sender: TObject);
begin
  ScrTextInfoUpdate;
end;

procedure TfrmImportSet.ScrTextInfoUpdate;
begin
  if not assigned(StatusBarScript) then Exit;
  StatusBarScript.Panels[0].Text :=
    RightStr(IntToStr(DBmwEditScript.CaretY),4)+':'+
    RightStr(IntToStr(DBmwEditScript.CaretX),4);

  if DBmwEditScript.InsertMode Then
    StatusBarScript.Panels[1].Text := 'Insert'
  else
    StatusBarScript.Panels[1].Text := 'Overwrite';
end;

procedure TfrmImportSet.SQLTextInfoUpdate;
begin
  if not assigned(StatusBarSQL) then Exit;
  StatusBarSQL.Panels[0].Text :=
    RightStr(IntToStr(DBmwEditSQL.CaretY),4)+':'+
    RightStr(IntToStr(DBmwEditSQL.CaretX),4);

  if DBmwEditScript.InsertMode Then
    StatusBarSQL.Panels[1].Text := 'Insert'
  else
    StatusBarSQL.Panels[1].Text := 'Overwrite';
end;


procedure TfrmImportSet.ds1ImportDataChange(Sender: TObject;
  Field: TField);
begin
  if (Field=nil) or (Field=q1ImportIdScrEng) then
  begin
    if AnsiUpperCase(q1ImportScrEngName.Value)='VBSCRIPT' then
      DBmwEditScript.HighLighter := dmURep.VBSsyntax
    else
      DBmwEditScript.HighLighter := nil;
  end
end;

procedure TfrmImportSet.DBmwEditSQLChange(Sender: TObject);
begin
  SQLTextInfoUpdate;
end;

procedure TfrmImportSet.DBmwEditSQLLoadData(Sender: TObject);
begin
  SQLTextInfoUpdate;
end;

procedure TfrmImportSet.LookupComboImportDropDown(Sender: TObject);
begin
  RxDBGrid1.DisableScroll;
end;

procedure TfrmImportSet.LookupComboImportCloseUp(Sender: TObject);
begin
  RxDBGrid1.EnableScroll;
  qSelImports.Locate('Id', StrToIntDef(LookupComboImport.Value, 0), []);
end;

procedure TfrmImportSet.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  if PageControl1.ActivePage = TabSheet1 then
  begin
    if LookupComboImport.Value <> qSelImportsId.asString then
      LookupComboImport.Value := qSelImportsId.asString;
   end;
end;

procedure TfrmImportSet.dsSelImportsDataChange(Sender: TObject;
  Field: TField);
begin
  if (Field=nil) and (ActiveControl=RxDBGrid1) then
  begin
    if LookupComboImport.Value <> qSelImportsId.asString then
      LookupComboImport.Value := qSelImportsId.asString;
  end;
end;

procedure TfrmImportSet.q1ImportAfterPost(DataSet: TDataSet);
var
  maxId : integer;
begin
   ReQueryOne(qSelImports); //!
   if WasInsert then
     begin
     maxId :=DLookup('select max(Id) from URepImports');
     qSelImports.Locate('Id', maxId, []);
     end;
   LookupComboImport.Value:= qSelImportsId.AsString;//!
end;

procedure TfrmImportSet.q1ImportBeforePost(DataSet: TDataSet);
begin
  WasInsert:=(q1Import.State=dsInsert);
end;

procedure TfrmImportSet.q1ImportAfterDelete(DataSet: TDataSet);
begin
   ReQueryOne(qSelImports);
   LookupComboImport.Value:= qSelImportsId.AsString;
end;

procedure TfrmImportSet.ActionRightExecute(Sender: TObject);
var
  frmURepRights : TfrmURepRights;
begin
  frmURepRights := GetOneForm(TfrmURepRights) as TfrmURepRights;
  frmURepRights.FindObject(6, StrToIntDef(LookupComboImport.Value,0));
end;

procedure TfrmImportSet.ReQueryq1Import;
begin
  ReQueryOne(q1Import);
end;

procedure TfrmImportSet.q1ImportAfterOpen(DataSet: TDataSet);
begin
  if PageControl1.ActivePage = TabSheetTest then
  begin
    FilenameEdit1.FileName := q1ImportFileTemplate.Value;
  end;
end;

procedure TfrmImportSet.DBmwEditSQLStatusChange(Sender: TObject;
  Changes: TmwStatusChanges);
begin
  SQLTextInfoUpdate;
end;

procedure TfrmImportSet.DBmwEditScriptStatusChange(Sender: TObject;
  Changes: TmwStatusChanges);
begin
  ScrTextInfoUpdate;
end;

procedure TfrmImportSet.ActionBrowserExecute(Sender: TObject);
var
  frmURepBrowser: TfrmURepBrowser;
begin
  if q1ImportId.Value<>StrToIntDef(LookupComboImport.Value,0) then
    ReQueryq1Import;
  frmURepBrowser := FindForm(TfrmURepBrowser) as TfrmURepBrowser;
  If frmURepBrowser=nil Then
    frmURepBrowser := TfrmURepBrowser.Create(Self,
                       GlObjURepDataImportName, URepGen_TLB.IID_URepDataImport,
                       q1Import);
  //frmURepBrowser.ReShowTree(GlObjURepDataImportName, URepGen_TLB.IID_URepDataImport);
  frmURepBrowser.Show;
end;

procedure TfrmImportSet.ActionReferensesExecute(Sender: TObject);
var
  frmURepReferences: TfrmURepReferences;
begin
  if q1ImportId.Value<>StrToIntDef(LookupComboImport.Value,0) then
    ReQueryq1Import;
  frmURepReferences := TfrmURepReferences.Create(Forms.Application, q1Import);
  frmURepReferences.ShowModal;
  frmURepReferences.Release;
end;

procedure TfrmImportSet.DBmwEditScriptDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Sender = DBmwEditScript) and
     (Source.ClassName = 'TTreeView') and
     (TComponent(Source).Name='tvAxBrowser') then
    begin
    Accept := True;
    end
end;

procedure TfrmImportSet.DBmwEditScriptDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  pItemData: PTTLItemData;
begin
  if (Sender = DBmwEditScript) and
     (Source.ClassName = 'TTreeView') and
     (TComponent(Source).Name='tvAxBrowser') then
    begin
    DBmwEditScript.ComputeCaret(x,y);
    pItemData := (TTreeView(Source)).Selected.Data;
    DBmwEditScript.SelText :=
      GetEnterStr(pItemData, q1ImportIdScrEng.Value, DBmwEditScript.Lines, DBmwEditScript.CaretXY);
    end;
end;

procedure TfrmImportSet.qSelImportsBeforeOpen(DataSet: TDataSet);
begin
  setOrderBy(DataSet, cnstOrderBy+URepTreeSortOrderString[dmURep.FSortOrder]);
end;

end.
