unit fLoginDB;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, AppUtils, ExtCtrls, ImgList, Mask, ToolEdit,
  Menus, dbtables, registry, db, ComCtrls, Grids, Placemnt, RXGrids, inifiles,
  ActnList;

type
  TfrmLoginDB = class(TForm)
    Panel1: TPanel;
    AppTitleLabel: TLabel;
    HintLabel: TLabel;
    AppIcon: TImage;
    KeyImage: TImage;
    Label3: TLabel;
    Label4: TLabel;
    edtPassword: TEdit;
    Panel3: TPanel;
    BitBtnAdvanced: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    Image1: TImage;
    Image3: TImage;
    ImageList1: TImageList;
    Panel4: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    comboConnections: TComboBox;
    rbRegistry: TRadioButton;
    rbFile: TRadioButton;
    PageControl1: TPageControl;
    TabSheetBase: TTabSheet;
    lblServer: TLabel;
    imgServer: TImage;
    lblDatabase: TLabel;
    imgDatabase: TImage;
    edtDatabase: TEdit;
    edtServer: TEdit;
    TabSheetTable: TTabSheet;
    RxDrawGridParms: TRxDrawGrid;
    edtDriver: TEdit;
    Label2: TLabel;
    edtUser: TComboBox;
    ActionList1: TActionList;
    Image2: TImage;
    actnConnAdd: TAction;
    actnConnDel: TAction;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    spbtnConnAdd: TSpeedButton;
    FormPlacement1: TFormPlacement;
    procedure FormCreate(Sender: TObject);
    procedure BitBtnAdvancedClick(Sender: TObject);
    procedure RxDrawGridParmsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure RxDrawGridParmsShowEditor(Sender: TObject; ACol,
      ARow: Integer; var AllowEdit: Boolean);
    procedure RxDrawGridParmsSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure PageControl1Change(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure RxDrawGridParmsGetEditText(Sender: TObject; ACol,
      ARow: Integer; var Value: String);
    procedure comboConnectionsChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actnConnAddExecute(Sender: TObject);
    procedure actnConnDelExecute(Sender: TObject);
    procedure edtServerExit(Sender: TObject);
    procedure edtDatabaseExit(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);

  private
    FCustomIniFile: TCustomIniFile;
    FPrevPanelHeight : integer;
    FAdvancedVisible : Boolean;
    FCaption: String;
    FConnection: TCustomConnection;
    FParamChanged: Boolean;
    FPrevConnectionName: string;
    FEditConnections: Boolean;

    function RestoreConnectionList: string;
    procedure WriteConnectionParam(ConnectionName, DriverName: string; strgsParams: TStrings);

  protected
    procedure PromtSaveConnectionParam;
  end;


function OnLoadedFormLoginDB(Connection: TCustomConnection; bTerminateOnCancel: Boolean=True): String;
procedure ConnectSlient(Connection: TCustomConnection; connectionname,user,psw: String);

procedure ChangePasswordDlg(CanCancel, OldPassw: Boolean; Connection: TCustomConnection);

const
  // TDtabase
  cnstDBDriverStandard = 'STANDARD';
  cnstDBDriverMSSQL    = 'MSSQL';
  cnstDBDriverINTRBASE = 'INTRBASE';
  cnstDBparamServerName    = 'SERVER NAME';
  cnstDBparamDatabaseName  = 'DATABASE NAME';
  cnstDBparamUserName      = 'USER NAME';
  cnstDBparamPassword      = 'PASSWORD';
  cnstDBparamLANGDRIVER    = 'LANGDRIVER';
  cnstDBparamBLOBSIZE      = 'BLOB SIZE';
  cnstDBparamHOSTNAME      = 'HOST NAME';
  cnstDBparamAPPLICATIONNAME ='APPLICATION NAME';


implementation

{$R *.DFM}

uses fPasswrd, QueryEx, ADOdb, Common, AppInfo, LayoutEx; //gvMconn,


type TlParameter=(prUsr,prPsw,prDB,prSrv);
     TlParameters=set of TlParameter;

const
  // INI file
  cnstFLogConnections =  'Connections';
  cnstFLogDefConnection = 'DefConnection';
  cnstFLogDriver = 'Driver';
  cnstFLogEditConnections = 'EditConnections';

  // Registry always
  cnstResentConnectionsSection = 'ResentConnections';
  cnstResentConnection = 'ResentConnection';

procedure ChangePasswordDlg(CanCancel, OldPassw: Boolean; Connection: TCustomConnection);
var
  PasswordDlg: TPasswordDlg;
  sql:string;
  mr: integer;
  sOldPassword: string;
begin
  PasswordDlg := TPasswordDlg.Create(nil);
  PasswordDlg.OldPassword := OldPassw;
  try
    mr := PasswordDlg.ShowModal;
    if mr=mrOK then
    begin
      if OldPassw then
        sOldPassword := ''''+PasswordDlg.OldPassw.Text+''''
      else
        sOldPassword := 'NULL';
      sql:='Exec sp_password '+sOldPassword+', '''+PasswordDlg.Password.Text+'''';
      if Connection is TDatabase
         then (Connection as TDatabase).Execute(sql)
      else if Connection is TADOConnection
         then (Connection as TADOConnection).Execute(sql)
      else raise Exception.Create(' ');
    end;
  finally
    PasswordDlg.Release;
  end;
  if (mr<>mrOK) and (not CanCancel) then
    Forms.Application.Tag := -1;
end;

function ReadResentConnection : String;
var
  RegIniFile : TRegIniFile;
begin
  RegIniFile := TRegIniFile.Create(GetDefaultIniRegKey);
  try
    result:=RegIniFile.ReadString(cnstResentConnectionsSection, cnstResentConnection, '');
  finally
    RegIniFile.Free;
  end;
end;

procedure ReadConnectionLoginList(Connection: String; Strings: TStrings);
var
  RegIniFile : TRegIniFile;
  strsValueNames: TStrings;
  i: integer;
begin
  strsValueNames := TStringList.Create;
  RegIniFile := TRegIniFile.Create(GetDefaultIniRegKey);
  try
    RegIniFile.ReadSectionValues(cnstResentConnectionsSection+'\'+Connection, strsValueNames);
    for i:=strsValueNames.Count-1 downto 0 do
      Strings.Add(strsValueNames.Values[strsValueNames.Names[i]])
  finally
    RegIniFile.Free;
    strsValueNames.Free;
  end;
end;



procedure WriteResentConnections(ResentConnection, ResentLogin: String);
var
  RegIniFile : TRegIniFile;
  sConSection: String;
  function GetLastLoginIdentName: string;
  var
    strsValueNames: TStrings;
    i, iFindLoginIdx: integer;
  begin
    result := IntToStr(0);
    iFindLoginIdx := -1;
    strsValueNames := TStringList.Create;
    try
      RegIniFile.ReadSectionValues(sConSection, strsValueNames);
      for i:=0 to strsValueNames.Count-1 do
      begin
        if strsValueNames.values[strsValueNames.Names[i]]= ResentLogin then
        begin
          iFindLoginIdx := i;
          Break;
        end
      end;

      if iFindLoginIdx>=0 then
      begin
        RegIniFile.WriteString(sConSection,
                              strsValueNames.Names[iFindLoginIdx],
                              strsValueNames.Values[strsValueNames.Names[strsValueNames.Count-1]]);
        result := strsValueNames.Names[strsValueNames.Count-1];
      end
        else
      begin
        if strsValueNames.Count<9 then
          result := IntToStr(strsValueNames.Count)
        else
          result := IntToStr(strsValueNames.Count-1);
      end;
    finally
      strsValueNames.Free;
    end;
  end;
begin
  RegIniFile := TRegIniFile.Create(GetDefaultIniRegKey);
  try
    RegIniFile.WriteString(cnstResentConnectionsSection, cnstResentConnection, ResentConnection);

    sConSection := cnstResentConnectionsSection+'\'+ResentConnection;
    RegIniFile.WriteString(sConSection, GetLastLoginIdentName, ResentLogin);
  finally
    RegIniFile.Free;
  end;
end;



function TfrmLoginDB.RestoreConnectionList: string;
var
  i : integer;
  Connections: TStrings;
  sValue: string;
begin
  result := '';
  comboConnections.Items.BeginUpdate;
  try
    comboConnections.Items.Clear;
    Connections := TStringList.Create;
    try
      FCustomIniFile.ReadSection(cnstFLogConnections, Connections);
      for i:=0 to Connections.Count-1 do
      begin
        sValue := FCustomIniFile.ReadString(cnstFLogConnections,Connections.Strings[i], '');
        if Connections.Strings[i]=cnstFLogDefConnection then
          result := sValue
        else if Connections.Strings[i]=cnstFLogEditConnections then
          FEditConnections := (UpperCase(sValue)='TRUE')
        else
          comboConnections.Items.Add(sValue);
      end;
    finally
      Connections.Free;
    end;
    If comboConnections.Items.Count=0
      Then FEditConnections := True;
  finally
    comboConnections.Items.EndUpdate;
  end;
end;

// return DriverName
function RestoreConnectionParam(ConnectionName: String;
                                Connection: TCustomConnection;
                                CustomIniFile: TCustomIniFile): string;
var
  i : integer;
  ParamNames: TStrings;
  sValue: string;
begin
  result := '';
  ParamNames := TStringList.Create;
  try
    CustomIniFile.ReadSection(ConnectionName, ParamNames);
    for i:=0 to ParamNames.Count-1 do
    begin
      sValue := CustomIniFile.ReadString(ConnectionName, ParamNames.Strings[i], '');
      if ParamNames.Strings[i]=cnstFLogDriver then
      begin
        result := sValue;
        (Connection as TDatabase).DriverName := sValue;
      end
      else
      begin
         if ParamNames.Strings[i]=cnstDBparamHOSTNAME then
           sValue := GetCompName;
         if ParamNames.Strings[i]=cnstDBparamAPPLICATIONNAME then
           sValue := GetProgName;
        (Connection as TDatabase).Params.Add(ParamNames.Strings[i]+'='+sValue);
      end;
    end;
  finally
    ParamNames.Free;
  end;
end;



function GetDefaultConnIniName: string;
begin
  result := ExtractFilePath(Forms.Application.ExeName)+ 'URepConn.ini';
end;

procedure RestoreConnections(frmLoginDB: TfrmLoginDB);
var
  sDefConnection: string;
  iIndex: integer;
  Connection: TCustomConnection;
  ResentConnection: String;
begin
  ResentConnection := ReadResentConnection;

  Connection := frmLoginDB.FConnection;
  if frmLoginDB.rbFile.Checked then
    frmLoginDB.FCustomIniFile := TIniFile.Create(GetDefaultConnIniName)
  else
    frmLoginDB.FCustomIniFile := TRegistryIniFile.Create(GetDefaultIniRegKey);

  sDefConnection := frmLoginDB.RestoreConnectionList;

  (Connection as TDatabase).DriverName := '';
  (Connection as TDatabase).Params.Clear;

  iIndex := frmLoginDB.comboConnections.Items.IndexOf(ResentConnection);
  if iIndex<0 then
    iIndex := frmLoginDB.comboConnections.Items.IndexOf(sDefConnection);
  if (iIndex<0) and (frmLoginDB.comboConnections.Items.Count>0) then
    iIndex := 0;

  if iIndex>=0 then
  begin
    with frmLoginDB do
    begin
      comboConnections.ItemIndex:= iIndex;
      comboConnectionsChange(nil);
      if edtUser.Text<>'' then
        ActiveControl := edtPassword;
    end;
  end else
    begin
    frmLoginDB.BitBtnAdvancedClick(nil);
    frmLoginDB.comboConnectionsChange(nil);
    end;
end;

procedure TfrmLoginDB.PromtSaveConnectionParam;
begin
  if (FPrevConnectionName<>'') and
     (FParamChanged = True) then
  begin
    If Confirmation('   .  ?') then
    begin
      WriteConnectionParam(FPrevConnectionName, '', (FConnection as TDatabase).Params);
      FParamChanged := False;
    end;
  end;
end;

procedure TfrmLoginDB.comboConnectionsChange(Sender: TObject);
var
  sConnectionName, sDriver: string;
  bServerNameExists, bDatabaseNameExists: Boolean;
begin
  PromtSaveConnectionParam;

  // FEditConnections
{  if (comboConnections.Items.Count=0) or
     (FEditConnections) then }
  spbtnConnAdd.Visible := FEditConnections;
  actnConnAdd.Enabled := FEditConnections;
  actnConnDel.Enabled := FEditConnections;
  edtServer.ReadOnly := not FEditConnections;
  edtDatabase.ReadOnly := not FEditConnections;


  sConnectionName := comboConnections.Text;
  FPrevConnectionName :=  sConnectionName;
  (FConnection as TDatabase).Params.BeginUpdate;
  try
    (FConnection as TDatabase).Params.Clear;
    sDriver := RestoreConnectionParam(sConnectionName, FConnection, FCustomIniFile)
  finally
    (FConnection as TDatabase).Params.EndUpdate;
    RxDrawGridParms.RowCount := (FConnection as TDatabase).Params.Count+2;
  end;

  // set Visibility of edtServer and edtDatabase
  bServerNameExists := ((FConnection as TDatabase).Params.IndexOfName(cnstDBparamServerName)>=0);
  edtServer.Visible := bServerNameExists;
  lblServer.Visible := bServerNameExists;
  imgServer.Visible := bServerNameExists;
  bDatabaseNameExists := ((FConnection as TDatabase).Params.IndexOfName(cnstDBparamDatabaseName)>=0);
  edtDatabase.Visible := bDatabaseNameExists;
  lblDatabase.Visible := bDatabaseNameExists;
  imgDatabase.Visible := bDatabaseNameExists;
  PageControl1Change(nil);
  FParamChanged := False;


  // read login list
  edtUser.Items.Clear;
  if sConnectionName<>'' then
    ReadConnectionLoginList(sConnectionName, edtUser.Items);
  if edtUser.Items.Count>0 then
    edtUser.Text := edtUser.Items[0]
  else
    edtUser.Text := '';


  edtDriver.Text := sDriver;
  Caption := FCaption+  ' /'+ sConnectionName +'/';
end;



Procedure SaveLastDBProperties(frmLoginDB: TfrmLoginDB);
var
  Connection, Login: string;
begin
  with frmLoginDB do
  begin
    PromtSaveConnectionParam;
    Connection := comboConnections.Text;
    Login     := edtUser.Text;
  end;

  WriteResentConnections(Connection, Login);
end;


procedure SetConnectionParam(Connection: TCustomConnection; user,psw: String);
begin
  if Connection is TDatabase then
    with (Connection as TDatabase).Params do
    begin
      Values[cnstDBparamUserName]:= user;
      Values[cnstDBparamPassword]:= psw;
    end
  else raise Exception.Create(' ');
end;

function TryLoginToServer(oConnection: TCustomConnection; frmLoginDB: TfrmLoginDB): Boolean;
var
  user,psw, sError: string;
begin
  with frmLoginDB do
  begin
    user := edtUser.Text;
    psw := edtPassword.Text;
  end;

  // 1. try connect with password
  SetConnectionParam(oConnection, user, psw);
  //ShowMessage(TMainConnection(oConnection).ConnectionString);
  result := True;
  try
    oConnection.Open;
  except
    On E: Exception do
      begin
      result := False;
      sError := E.Message;
      end;
  end;

  // 2. on error check NULL password
  if (not result) and (psw<>'') then
  begin
    psw := '';
    SetConnectionParam(oConnection, user, psw);
    try
      oConnection.Open;
      result := True;
    except
      result := False;
    end;
  end;

  // 3. on connect with NULL psw -> ChangePassword
  if result and (psw='') then
    begin
    ChangePasswordDlg(False, False, oConnection);
    Exit;
    end;

 if not result then
  MessageDlg(sError ,mtError,[mbAbort],0);
end;


//===============================================================================
// OnLoadedFormLoginDB
//===============================================================================
function OnLoadedFormLoginDB(Connection: TCustomConnection; bTerminateOnCancel: Boolean=True): String;
var
  frmLoginDB: TfrmLoginDB;
  res, iTryNumber : integer;
  bLoginned : Boolean;
begin
  result := '';
  bLoginned := False;
  Connection.LoginPrompt := False;
  frmLoginDB := TfrmLoginDB.Create(nil);
  frmLoginDB.FConnection := Connection;
  try
    RestoreConnections(frmLoginDB);
    for iTryNumber:=1 to 3 do
    begin
      res := frmLoginDB.ShowModal;
      if res=mrOK then
      begin
        bLoginned := TryLoginToServer(Connection, frmLoginDB);
        if bLoginned then
        begin
          SaveLastDBProperties(frmLoginDB);
          result := frmLoginDB.comboConnections.Text;
          Break;
        end;
      end
      else
        Break;
    end;
  finally
    frmLoginDB.Release;
  end;

  if not bLoginned then
  begin
    Connection.Connected := False;
    if bTerminateOnCancel then Forms.Application.Tag := -1;
  end;
end;

procedure TfrmLoginDB.FormCreate(Sender: TObject);
begin
  FCustomIniFile := nil;
  FParamChanged := False;
  FEditConnections := False;
  AppIcon.Picture.Icon := Application.Icon;
  AppTitleLabel.Caption := AppTitleLabel.Caption + Application.Title;

  ImageList1.GetBitmap(3, spbtnConnAdd.Glyph);
  ImageList1.GetBitmap(0, BitBtnAdvanced.Glyph);
  FCaption := Self.Caption;
  FPrevPanelHeight := 200;
  FAdvancedVisible := False;
  Self.Height :=  Self.Height - Panel4.Height;

  //controls layout
  FitControlWidthToParent(edtServer);
  FitControlWidthToParent(edtDatabase);
end;

procedure TfrmLoginDB.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if FAdvancedVisible then
  begin
    BitBtnAdvancedClick(nil);
    Application.ProcessMessages;
  end;
end;

procedure TfrmLoginDB.FormDestroy(Sender: TObject);
begin
  FCustomIniFile.Free;
end;

procedure TfrmLoginDB.FormActivate(Sender: TObject);
begin
  if FAdvancedVisible then
  begin
    if Self.Height<350 then  Self.Height := 350;
  end;
end;



procedure TfrmLoginDB.BitBtnAdvancedClick(Sender: TObject);
var
  aBitmap: TBitmap;
  iIndex: integer;
begin
  if FAdvancedVisible then
  begin
    iIndex := 0;
    FPrevPanelHeight := Panel4.Height;
    Self.Height :=  Self.Height - Panel4.Height;
  end else begin
    iIndex := 1;
    Self.Height :=  Self.Height + FPrevPanelHeight;
  end;
  aBitmap := TBitmap.Create;
  ImageList1.GetBitmap(iIndex, aBitmap);
  BitBtnAdvanced.Glyph.Assign(aBitmap);
  aBitmap .Free;
  Panel4.Visible := (iIndex = 1);

  FAdvancedVisible := not FAdvancedVisible;
end;

procedure TfrmLoginDB.RxDrawGridParmsDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  ss: String;
begin
  ss := '????';

  case ARow of
   0:
    begin
      case ACol of
        0: ss := '';
        1: ss := '';
      end;
    end;
   1:
    begin
      case ACol of
        0: ss := 'Driver';
        1: ss := (FConnection as TDatabase).DriverName;
      end;
    end;
   else
    begin
      if (ARow<=(FConnection as TDatabase).Params.Count+1) then
      begin
        ss := (FConnection as TDatabase).Params.Names[ARow-2];
        if ACol=1 then
          ss := (FConnection as TDatabase).Params.Values[ss];
      end;
    end;
  end;

  if (ARow=1) then
  begin
   if not (fsBold in RxDrawGridParms.Canvas.Font.Style) then
     RxDrawGridParms.Canvas.Font.Style :=
       RxDrawGridParms.Canvas.Font.Style + [fsBold];
  end
  else
  begin
   if fsBold in RxDrawGridParms.Canvas.Font.Style then
     RxDrawGridParms.Canvas.Font.Style :=
       RxDrawGridParms.Canvas.Font.Style - [fsBold];
  end;

  RxDrawGridParms.DrawStr( Rect, ss, taLeftJustify );
end;

procedure TfrmLoginDB.RxDrawGridParmsShowEditor(Sender: TObject; ACol,
  ARow: Integer; var AllowEdit: Boolean);
begin
 if (ACol=0) or (ARow<=1) then AllowEdit := False
 else AllowEdit := FEditConnections;
end;

procedure TfrmLoginDB.RxDrawGridParmsGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
var
  ss: string;
begin
  ss := (FConnection as TDatabase).Params.Names[ARow-2];
  Value := (FConnection as TDatabase).Params.Values[ss]
end;

procedure TfrmLoginDB.RxDrawGridParmsSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  ss, sValue: string;
begin
  if Value='' then sValue:=' ' else sValue:=Value;
  ss := (FConnection as TDatabase).Params.Names[ARow-2];
  (FConnection as TDatabase).Params.Values[ss] := sValue;
  FParamChanged := True;
end;

function NotEmptyStr(ss: string): string;
begin
  if Length(ss)=0 then result:=' ' else result:=ss;
end;

procedure TfrmLoginDB.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePage = TabSheetBase then
  begin
    if edtServer.Visible then edtServer.Text := (FConnection as TDatabase).Params.Values[cnstDBparamServerName];
    if edtDatabase.Visible then edtDatabase.Text := (FConnection as TDatabase).Params.Values[cnstDBparamDatabaseName];
  end;
end;

procedure TfrmLoginDB.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  if PageControl1.ActivePage = TabSheetBase then
  begin
    if edtServer.Visible then (FConnection as TDatabase).Params.Values[cnstDBparamServerName] := NotEmptyStr(edtServer.Text);
    if edtDatabase.Visible then (FConnection as TDatabase).Params.Values[cnstDBparamDatabaseName] := NotEmptyStr(edtDatabase.Text);
  end;
end;

procedure TfrmLoginDB.edtServerExit(Sender: TObject);
begin
  if (FConnection as TDatabase).Params.Values[cnstDBparamServerName]=edtServer.Text then Exit;
  (FConnection as TDatabase).Params.Values[cnstDBparamServerName] := NotEmptyStr(edtServer.Text);
  FParamChanged := True;
end;

procedure TfrmLoginDB.edtDatabaseExit(Sender: TObject);
begin
  if (FConnection as TDatabase).Params.Values[cnstDBparamDatabaseName] = edtDatabase.Text then Exit;
  (FConnection as TDatabase).Params.Values[cnstDBparamDatabaseName] := NotEmptyStr(edtDatabase.Text);
  FParamChanged := True;
end;

procedure TfrmLoginDB.WriteConnectionParam(ConnectionName, DriverName: string; strgsParams: TStrings);
var
  i: integer;
  sName: string;
begin
  for i:= 0 to strgsParams.Count-1 do
  begin
    if Length(DriverName)>0 then
      FCustomIniFile.WriteString(ConnectionName, cnstFLogDriver, DriverName);
    sName := strgsParams.Names[i];
    if (sName<>cnstDBparamUserName) and  // don't save username and password
       (sName<>cnstDBparamPassword) then
    FCustomIniFile.WriteString(ConnectionName, sName, strgsParams.Values[sName]);
  end;
end;

procedure TfrmLoginDB.actnConnAddExecute(Sender: TObject);
var
  frm : TForm;
  cmb : TComboBox;
  edt : TEdit;
  sDriverName, sConnName: string;
  strgsParams: TStringList;
  iIdx: integer;
begin
  sDriverName := '';
  frm := TForm.Create(Application);
  with frm do
    begin
    Caption := ' ';
    BorderStyle := bsDialog;
    Width := 360;
    Height := 150;
    Position := poScreenCenter;
    end;

  with TLabel.Create(frm) do
    begin
    Parent := frm;
    Caption := '';
    Top := 12;
    Left := 10;
    end;
  edt := TEdit.Create(frm);
  with edt do
    begin
    Parent := frm;
    Top := 8;
    Width := 240;
    Left := 100;
    end;

  with TLabel.Create(frm) do
    begin
    Parent := frm;
    Caption := '';
    Top := 44;
    Left := 10;
    end;
  cmb := TComboBox.Create(frm);
  with cmb do
    begin
    Parent := frm;
    Top := 40;
    Left := 100;
    Width := 240;
    Style := csDropDownList;
    end;


  with TBitBtn.Create(frm) do //OK
    begin
    Parent := frm;
    Top := 80;
    Left := 88;
    Kind := bkOK;
    end;
  with TBitBtn.Create(frm) do //Cancel
    begin
    Parent := frm;
    Top := 80;
    Left := 192;
    Kind := bkCancel;
    end;
  Session.GetDriverNames(cmb.Items);
  iIdx := cmb.Items.IndexOf(cnstDBDriverStandard);
  if iIdx>=0 then cmb.Items.Delete(iIdx);
  if cmb.Items.Count>0 then cmb.ItemIndex:=0;

  if frm.ShowModal=mrOK then
  begin
    sDriverName := cmb.Text;
    sConnName := Trim(edt.Text);
  end;
  frm.Release;
  if (sConnName='') or (sDriverName='') then Exit;

  strgsParams:= TStringList.Create;
  Session.GetDriverParams(sDriverName, strgsParams);

  // set defaults
  if sDriverName=cnstDBDriverMSSQL then
    strgsParams.Values[cnstDBparamLANGDRIVER] := 'DBWINUS0';
  if sDriverName=cnstDBDriverINTRBASE then
    strgsParams.Values[cnstDBparamLANGDRIVER] := 'ancyrr';
  iIdx := strgsParams.IndexOfName(cnstDBparamBLOBSIZE);
  if iIdx>=0 then
    strgsParams.Values[strgsParams.Names[iIdx]]:=IntToStr(512);
  iIdx := strgsParams.IndexOfName(cnstDBparamDatabaseName);
  if iIdx>=0 then
    strgsParams.Values[strgsParams.Names[iIdx]]:= NotEmptyStr(strgsParams.Values[strgsParams.Names[iIdx]]);

  //  Connection
  FCustomIniFile.WriteString(cnstFLogConnections, sConnName, sConnName);
  FCustomIniFile.WriteString(cnstFLogConnections, 'EditConnections', 'True');   //????
  WriteConnectionParam(sConnName, sDriverName, strgsParams);
  strgsParams.Free;

  // 
  RestoreConnectionList;
  comboConnections.ItemIndex:= comboConnections.Items.IndexOf(sConnName);
  comboConnectionsChange(nil);

end;

procedure TfrmLoginDB.actnConnDelExecute(Sender: TObject);
begin
  If Confirmation(' ?') then
  begin
    FCustomIniFile.DeleteKey(cnstFLogConnections, comboConnections.Text);
    FCustomIniFile.EraseSection(comboConnections.Text);
    FParamChanged := False;
    comboConnections.Items.Delete(comboConnections.ItemIndex);
    if comboConnections.Items.Count>=0 then
      comboConnections.ItemIndex:=0;
    comboConnectionsChange(nil);
  end;
end;


procedure ConnectSlient(Connection: TCustomConnection; connectionname,user,psw: String);
var
  CustomIniFile: TCustomIniFile;
begin
  CustomIniFile := TIniFile.Create(GetDefaultConnIniName);
  try
    RestoreConnectionParam(ConnectionName, Connection, CustomIniFile);
    SetConnectionParam(Connection, user, psw);
  finally
    CustomIniFile.Free;
  end;

  try
    Connection.Open;
  except
    On E: Exception do
      MessageDlg(E.Message ,mtError,[mbAbort],0);
  end;
end;

end.
