unit fRecRights;

interface         

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBGrids, DBTables, Grids, ExtCtrls,
  RXDBCtrl, RxLookup, Placemnt, ActnList, Buttons, ComCtrls,
  ToolWin, ScrlQuery;

type
  TfRecordRights = class(TForm)
    DBGrid1: TRxDBGrid;
    Panel1: TPanel;
    dsRecRights: TDataSource;
    Panel2: TPanel;
    qRecRights: TScrollQuery;
    qLogins: TQuery;
    cbTable: TRxDBLookupCombo;
    Label1: TLabel;
    qTables: TQuery;
    dsTables: TDataSource;
    qRecRightsId: TAutoIncField;
    qRecRightsIdTable: TIntegerField;
    qRecRightsIdRecord: TIntegerField;
    qRecRightsLoginName: TStringField;
    qTablesId: TAutoIncField;
    qTablesTblName: TStringField;
    qTablesItem: TStringField;
    cbRecord: TRxDBLookupCombo;
    Label2: TLabel;
    dsRecord: TDataSource;
    qRecord: TQuery;
    qTablesRecordFld: TStringField;
    qLoginsFIO: TStringField;
    qLoginsLogin: TStringField;
    qRecRightsFIO: TStringField;
    FormPlacement1: TFormPlacement;
    ActionList1: TActionList;
    ActionCopy: TAction;
    ActionPaste: TAction;
    CoolBar1: TCoolBar;
    PageScroller1: TPageScroller;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    DBNavigator: TDBNavigator;
    procedure qRecRightsAfterPost(DataSet: TDataSet);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure qRecRightsNewRecord(DataSet: TDataSet);
    procedure DBNavigatorBeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure FormCreate(Sender: TObject);
    procedure qRecRightsBeforeOpen(DataSet: TDataSet);
    procedure cbTableChange(Sender: TObject);
    procedure cbRecordChange(Sender: TObject);
    procedure ActionCopyExecute(Sender: TObject);
    procedure ActionPasteExecute(Sender: TObject);
  private
    { private declarations }
    FCopyIdRecord: integer;
  public
    { public declarations }
  end;

implementation
{$R *.DFM}

uses Common, QueryEx, CommonVV, DataMdl;

procedure TfRecordRights.FormCreate(Sender: TObject);
begin
  FCopyIdRecord := 0;
  ReQueryAll(Self);
  qTables.First;
  cbTable.Value := IntToStr(qTablesId.Value);
end;

procedure TfRecordRights.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfRecordRights.cbTableChange(Sender: TObject);
begin
  FCopyIdRecord :=0;
  qRecord.Close;
  if qTables.RecordCount>0 then
    begin
    cbRecord.LookupDisplay := qTablesRecordFld.Value;
    qRecord.SQL.Clear;
    qRecord.SQL.Add('select Id, '+ Trim(qTablesRecordFld.Value)+
                    ' from '+ Trim(qTablesTblName.Value)+
                    ' order by '+ Trim(qTablesRecordFld.Value));
    qRecord.Open;
    qRecord.FetchAll;
    qRecord.First;

    cbRecord.Value := qRecord.FieldByName('Id').asString;
    end;
end;

procedure TfRecordRights.cbRecordChange(Sender: TObject);
begin
  RequeryOne(qRecRights);
end;

procedure TfRecordRights.qRecRightsBeforeOpen(DataSet: TDataSet);
begin
  qRecRights.ParamByName('IdTable').asInteger := StrToIntDef(cbTable.Value, 0);
  qRecRights.ParamByName('IdRecord').asInteger := StrToIntDef(cbRecord.Value, 0);
end;

procedure TfRecordRights.qRecRightsAfterPost(DataSet: TDataSet);
begin
  ReQueryOne(qRecRights);
end;

procedure TfRecordRights.qRecRightsNewRecord(DataSet: TDataSet);
begin
  qRecRightsIdTable.asInteger := StrToIntDef(cbTable.Value, 0);
  qRecRightsIdRecord.asInteger := StrToIntDef(cbRecord.Value, 0);
end;

procedure TfRecordRights.DBNavigatorBeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then
     begin
     ReQueryOne(qRecRights);
     Abort;
     end;
   if Button=nbInsert then
     begin
     qRecRights.Append;
     Abort;
     end;
end;

procedure TfRecordRights.ActionCopyExecute(Sender: TObject);
begin
  FCopyIdRecord := StrToIntDef(cbRecord.Value, 0);
end;

procedure TfRecordRights.ActionPasteExecute(Sender: TObject);
begin
  if FCopyIdRecord=0 then Exit;
  try
  DoSQL(
  'insert into RightsRecord (IdTable, IdRecord, LoginName) '+
  'select IdTable, '+cbRecord.Value+', LoginName '+
  'from RightsRecord r1 where IdTable='+cbTable.Value+
  ' and IdRecord='+IntToStr(FCopyIdRecord)+
  ' and not exists(select * from RightsRecord r2 where '+
  ' r2.IdTable=r1.IdTable and r2.LoginName=r1.LoginName and '+
  ' r2.IdRecord='+cbRecord.Value+' )'
  );
  finally
    ReQueryOne(qRecRights);
    end;
end;

end.
