unit fURepBLOB2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, DB, DBCtrls, ExtCtrls, JPEG, RxGIF, 
  Placemnt, ImgList, Buttons, RXSpin, RXCtrls, ToolWin, Menus, Math;

type
  TfrmURepBLOBimage = class(TForm)
    Timer1: TTimer;
    FormPlacement1: TFormPlacement;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    btnZoomFit: TToolButton;
    btnZoom100: TToolButton;
    btnZoomToWidth: TToolButton;
    ToolButton3: TToolButton;
    spbtnScale: TRxSpeedButton;
    RxSpinButton1: TRxSpinButton;
    ToolButton5: TToolButton;
    SaveReport: TToolButton;
    Separator4: TToolButton;
    ExitButton: TSpeedButton;
    Images: TImageList;
    ScrollBox1: TScrollBox;
    PopupMenu1: TPopupMenu;
    mnu500: TMenuItem;
    mnu200: TMenuItem;
    mnu100: TMenuItem;
    mnu75: TMenuItem;
    mnu20: TMenuItem;
    Image1: TImage;
    mnu50: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnZoomFitClick(Sender: TObject);
    procedure btnZoom100Click(Sender: TObject);
    procedure btnZoomToWidthClick(Sender: TObject);
    procedure mnuClick(Sender: TObject);
    procedure RxSpinButton1BottomClick(Sender: TObject);
    procedure RxSpinButton1TopClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SaveReportClick(Sender: TObject);
  private
    { Private declarations }
    FFieldName: string;
    FDataSource: TDataSource;

    FZoom: Integer;
    FZoomUpdating: Boolean;

    procedure DataSourceDataChange(Sender: TObject; Field: TField);
    procedure UpdateZoomState;
    procedure WriteZoom(aZoom: integer);
    procedure ZoomToFit;
    procedure ZoomToWidth;
  protected
    property Zoom: integer read FZoom write WriteZoom;
  public
    { Public declarations }
    constructor CreateFrm(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource);
  end;

function URepShowFrmBLOBimage(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource) : TfrmURepBLOBimage;

implementation

{$R *.DFM}

function URepShowFrmBLOBimage(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource) : TfrmURepBLOBimage;
var
  i : integer;
  frmURepBLOBimage: TfrmURepBLOBimage;
begin
  result := nil;
  for i:=0 to (Application.MainForm.MDIChildCount-1) do
  if (Application.MainForm.MDIChildren[i] is TfrmURepBLOBimage) then
    begin
    frmURepBLOBimage := Application.MainForm.MDIChildren[i] as TfrmURepBLOBimage;
    if (frmURepBLOBimage.Owner=AOwner) and (frmURepBLOBimage.FFieldName=aFieldName) and
       (frmURepBLOBimage.FDataSource=aDataSource) then
      result:=frmURepBLOBimage;
    break;
    end;
  if result = nil then
    result := TfrmURepBLOBimage.CreateFrm(AOwner, aFieldName, aDataSource);
  result.Show;
end;


constructor TfrmURepBLOBimage.CreateFrm(AOwner: TComponent; aFieldName: string; aDataSource: TDataSource);
begin
  FFieldName := aFieldName;
  FDataSource := aDataSource;
  inherited Create(AOwner);
  Caption := Caption + FFieldName;

  FZoomUpdating := False;
  FZoom := 100;
  btnZoom100.Down := true;

  FDataSource.OnDataChange := DataSourceDataChange;
end;

procedure TfrmURepBLOBimage.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepBLOBimage.DataSourceDataChange(Sender: TObject; Field: TField);
begin
  if Field<>nil then Exit;
  Timer1.Enabled := False;
  Timer1.Enabled := True;
end;


procedure TfrmURepBLOBimage.Timer1Timer(Sender: TObject);
var
  TS: TMemoryStream;
  aField: TField;
  bLoad: Boolean;

  GIFImage: TGIFImage;
  JPEGImage: TJPEGImage;
begin
  Timer1.Enabled := False;
  bLoad := False; JPEGImage := nil;

  GIFImage := TGIFImage.Create;
  TS:=TMemoryStream.Create;
  try
    aField := FDataSource.DataSet.FieldByName(FFieldName);
    (aField as TBlobField).SaveToStream(TS);

    TS.Seek(0,soFromBeginning);
    try
      GIFImage.LoadFromStream(TS);
      bLoad := True;
    except
    end;

    if bLoad then
      Image1.Picture.Assign(GIFImage)
    else
      begin
        JPEGImage := TJPEGImage.Create;
        TS.Seek(0,soFromBeginning);
        try
          JPEGImage.LoadFromStream(TS);
          bLoad := True;
        except
        end;

        if bLoad then
          Image1.Picture.Assign(JPEGImage)
        else
          Image1.Picture.Assign(aField);  //for BitMap Only
      end;

  finally
    TS.Free;
    GIFImage.Free;
    JPEGImage.Free;
    FormResize(nil);
  end;
end;

procedure TfrmURepBLOBimage.FormDestroy(Sender: TObject);
begin
  FDataSource.OnDataChange := nil;
  Timer1.Enabled := False;
end;

procedure TfrmURepBLOBimage.btnZoomFitClick(Sender: TObject);
begin
  Application.ProcessMessages;
  ZoomToFit;
end;

procedure TfrmURepBLOBimage.btnZoom100Click(Sender: TObject);
begin
  Application.ProcessMessages;
  Zoom := 100;
  UpdateZoomState;
end;

procedure TfrmURepBLOBimage.btnZoomToWidthClick(Sender: TObject);
begin
  Application.ProcessMessages;
  ZoomToWidth;
end;

procedure TfrmURepBLOBimage.mnuClick(Sender: TObject);
begin
  Zoom := (Sender as TMenuItem).Tag;
  btnZoomFit.Down := False;
  btnZoom100.Down := False;
  btnZoomToWidth.Down := False;
  UpdateZoomState;
end;

procedure TfrmURepBLOBimage.UpdateZoomState;
begin
  if not FZoomUpdating then
    begin
    FZoomUpdating := True;
    spbtnScale.Caption := IntToStr(Zoom)+'%';
    FZoomUpdating := False;
    end;
end;

procedure TfrmURepBLOBimage.WriteZoom(aZoom: integer);
var
  iHeight, iWidth: integer;
begin
  If aZoom<1 then Exit;

  If aZoom=100 then
  begin
    Image1.Stretch := False;
    Image1.AutoSize := True;
  end
  else
  begin
    Image1.Stretch := True;
    Image1.AutoSize := False;

    iWidth := Image1.Picture.Graphic.Width;
    iHeight := Image1.Picture.Graphic.Height;

    Image1.Width := Round(iWidth * (aZoom/100));
    Image1.Height := Round(iHeight * (aZoom/100));
  end;
  FZoom := aZoom;
end;

procedure TfrmURepBLOBimage.ZoomToWidth;
var
  iZoom: integer;
begin
  if Image1.Picture.Graphic.Width=0 then
    iZoom := FZoom
  else
  begin
    iZoom := Round(Int(((ScrollBox1.Width-ScrollBox1.VertScrollBar.Size-4)/Image1.Picture.Graphic.Width)*100))-1;
  end;

  Zoom := iZoom;
  UpdateZoomState;
end;

procedure TfrmURepBLOBimage.ZoomToFit;
var
  iZoom, iZoom1, iZoom2: integer;
begin
  if (Image1.Picture.Graphic.Width=0) and
     (Image1.Picture.Graphic.Height=0) then
    iZoom := FZoom
  else
  begin
    iZoom1 := Round(Int(((ScrollBox1.Width-ScrollBox1.VertScrollBar.Size-4)/Image1.Picture.Graphic.Width)*100))-1;
    iZoom2 := Round(Int(((ScrollBox1.Height-ScrollBox1.HorzScrollBar.Size-4)/Image1.Picture.Graphic.Height)*100))-1;
    iZoom := Min(iZoom1, iZoom2);
  end;
  Zoom := iZoom;
  UpdateZoomState;
end;


procedure TfrmURepBLOBimage.RxSpinButton1BottomClick(Sender: TObject);
begin
  Application.ProcessMessages;
  Zoom := Zoom - 5;
  btnZoomFit.Down := False;
  btnZoom100.Down := False;
  btnZoomToWidth.Down := False;
  UpdateZoomState;
end;

procedure TfrmURepBLOBimage.RxSpinButton1TopClick(Sender: TObject);
begin
  Application.ProcessMessages;
  Zoom := Zoom + 5;
  btnZoomFit.Down := False;
  btnZoom100.Down := False;
  btnZoomToWidth.Down := False;
  UpdateZoomState;
end;

procedure TfrmURepBLOBimage.ExitButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmURepBLOBimage.FormResize(Sender: TObject);
begin
  if btnZoomFit.Down=True then ZoomToFit
  else if btnZoomToWidth.Down=True then ZoomToWidth
  else Zoom := FZoom;
end;

procedure TfrmURepBLOBimage.SaveReportClick(Sender: TObject);
begin
//
end;

end.
