unit fURepFunc1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, buttons, Dialogs, StdCtrls, menus, Mask, ToolEdit, askMe,
  DB, DBTables, RxQuery, VCLUtils, QUICKRPT, qrextra, QRExport, qrddlgs,
  URepTypes, qrdprocs, Qrdsgn3, ScrlQuery, dbclient, FieldVals, SBctrl,
  URepQuery, RxMemDS;

type
  TURepFormAction = (factEdit, factExecDef, factOutPreview, factOutPrint, factOutSave, factViewAsTbl);

  // functions for extern call
  function URepDefFormAction(IdForm: integer; FrmName: string;
                              ParAskList: TParamAskMeList; OutFName: string = ''): Boolean;

  // intermediate functions
  function URepExtFormAction(IdForm: integer; FrmName: string;
                              ParAskList: TParamAskMeList; frmActn: TURepFormAction;
                              OutFName: string; idDestination, idTypExec : integer;
                              bFreeParList: Boolean = True) : Boolean;
  function URepCreateParamList(IdCaller : integer; ItemType: TURepTreeItemType; var res: Boolean;
                             rep_name : string) : TParamAskMeList;
  function  URepActionReport(IdForm: integer; FrmName: string;
                          idDestination, idTypExec : integer): Boolean;
  procedure URepEditRepForm(IdForm: integer; FrmName: string);
         // set flag ReRunReport
  procedure URepSetReRunReport(mnuReRunReport: TMenuItem);
  procedure URepChangeReRunReport(mnuReRunReport: TMenuItem);
  function URepGetReRunReport: Boolean;

  // internal functions only
  function URepGetMainForm: TForm;
  function URepCreateQueryList(IdCaller : integer; ItemType: TURepTreeItemType) : TQueryList;
  procedure URepCreateDataSets(aOwner: TForm; aParAskList: TParamAskMeList; aQueryList: TQueryList; bIsReport: Boolean);
  procedure URepInternalCreateParamList(IdCaller : integer; ItemType: TURepTreeItemType;  ParamAskMeList: TList);
  function URepSelDestination(var IdDestination: integer): Boolean;
  procedure URepSetMasterDtSrc(aOwner: TComponent; DataSet: TDataSet; aQueryList: TQueryList);
  function URepFindDatasource4Dataset(DS: TDataSet): TDatasource;
  function URepImageIndexFromIdTypObj(IdTypObj: integer): integer;
  procedure URepFormMainObjectID(IdForm:integer; var IdQuery, IdRemoteData : integer);

  procedure URepGetParamPrefix;
  function  URepGroupAdd(GroupName: string): integer;
  procedure URepGroupDelete(IdGroup: integer);
  procedure URepFormDelete(IdForm: integer);
  function  URepFormAdd(FormName: string; IdQuery: integer): integer;
  function  URepFrm2QryNumm(IdForm: integer): integer;
  procedure URepQueryDelete(IdQuery: integer);
  function  URepQueryAdd(QueryName: string; IdForm: integer): integer;
  procedure URepScriptDelete(IdScript: integer);
  function  URepScriptAdd(ScriptName:string): integer;
  function  URepRemoteDataAdd(RemoteDataName: String):integer;
  procedure URepRemoteDataDelete(IdRemoteData : integer);
  function  URepParamAdd(ParName: string; IdQuery, IdRemoteData: integer): integer;
  procedure URepParamDelete(IdParam: integer);


// utilit for def. IsAdmin
type
  TURepGetIsAdminFunc = function(bUpdate: Boolean)  : Boolean;

  function URepIsAdmin(bUpdate: Boolean = False) : Boolean;
  function GetURepIsAdminFunc : TURepGetIsAdminFunc;
  procedure SetURepIsAdminFunc(pIsAdminFunc : TURepGetIsAdminFunc);

// utilit for ScrollBar
  procedure SetURepScrollBarControl(SBctrl: TSBctrl);
  function GetURepScrollBarControl: TSBctrl;

implementation

uses Common, CommonVV, registry, AppUtils, ComObj,
     dmdURep, fURepQryBro, Qrdsgn2, QueryEx, ExceptEx,
     URepConstants, URep3T, fURepMain, fURepFunc0; 

// utilit for ScrollBar
var
  glSBctrl: TSBctrl;

procedure SetURepScrollBarControl(SBctrl: TSBctrl);
begin
  glSBctrl := SBctrl;
end;

function GetURepScrollBarControl: TSBctrl;
begin
  result := glSBctrl;
end;

// set flag ReRunReport
const
  cnstURepUserSettingsSection = 'URepUserSettings';
  cnstReRunReportIdent = 'ReRunReport';
var
  glReRunReport: Boolean;

// utilit for def. IsAdmin
var
  glPtrTURepGetIsAdminFunc : TURepGetIsAdminFunc;
  bIsAdminValSet, bIsAdminVal : Boolean;

function URepIsAdmin(bUpdate: Boolean = False) : Boolean;
begin
  result := glPtrTURepGetIsAdminFunc(bUpdate);
end;

function GetURepIsAdminFunc : TURepGetIsAdminFunc;
begin
  result := glPtrTURepGetIsAdminFunc;
end;

procedure SetURepIsAdminFunc(pIsAdminFunc : TURepGetIsAdminFunc);
begin
  glPtrTURepGetIsAdminFunc := pIsAdminFunc;
end;

function URepDeffGetIsAdmin(bUpdate: Boolean) : Boolean;
var
  params : TParams;
const
  spURepGetIsAdmin = 'spURepGetIsAdmin';
begin
  if (not bIsAdminValSet) or bUpdate then
   begin
    try
      params := TParams.Create;
      try
        params.CreateParam(ftInteger, prmPrefix+'IsAdmin', ptOutput);
        ExecSP(spURepGetIsAdmin, params);
        bIsAdminVal := (params.ParamValues[prmPrefix+'IsAdmin']>0);
      finally
        params.Free;
      end;
      bIsAdminValSet := True;
    except
       on E : Exception do
         ErrorMsg('Error Execute '+spURepGetIsAdmin+Chr(13)+Chr(10)+ E.Message);
    end;
   end;
  result := bIsAdminVal;
end;


function URepGetMainForm: TForm;
begin
  result := FindForm(TfrmURepMain);
end;


//=========================================================================
//  Function for Report Generator
//=========================================================================
const
  cnstDisplayParamPrefix = '_Display';

procedure URepFormMainObjectID(IdForm:integer; var IdQuery, IdRemoteData : integer);
var
  aQuery1 : TQuery;
begin
  aQuery1 := TQuery.Create(nil);
  try
    with aQuery1 do
    begin
      DatabaseName := glDatabaseName;
      SQL.Text :='select IdQuery, IdRemoteData from URepFrm2Qry '+
                 'where IdForm='+IntToStr(IdForm)+ ' and '+
                 'Numm=(select min(Numm) from URepFrm2Qry '+
                        'where IdForm='+IntToStr(IdForm)+ ')';
      Open;
      IdQuery := FieldByName(fldIdQuery).asInteger;
      IdRemoteData := FieldByName(fldIdRemoteData).asInteger;
      Close;
    end;
  finally
    aQuery1.Free;
  end;
end;

procedure URepInternalCreateParamList(IdCaller : integer; ItemType: TURepTreeItemType;  ParamAskMeList: TList);
const
 paramSQL =
  'SELECT Id, IdQuery, Numm, ParName, IdParTyp, ParLabel,'+
  '  SQL, Width, LookupField, LookupDisplay, LookupDisplayIndex,'+
  '  IdTypDefVal, DefSQL '+
  'FROM URepParam ';
var
  aQuery2: TQuery;
  IdQuery, IdRemoteData: integer;

  procedure _AddParam;
  var
    paramAskMe : TParamAskMe;
    width : integer;
  begin
    with aQuery2 do
    begin
      Open;
      First;
      while not EOF do
      begin
        paramAskMe := TParamAskMe.Create(
                                FieldByName(fldParLabel).asString,
                                TParamAskMeInputTyp(FieldByName(fldIdParTyp).asInteger),
                                FieldByName(fldParName).asString);
        if paramAskMe.inpTyp=prmDate then paramAskMe.Value:=Date;
        width := FieldByName(fldWidth).asInteger;
        if width>paramAskMe.Width then
          paramAskMe.Width := width;
        paramAskMe.IdParam := FieldByName(fldId).asInteger;
        paramAskMe.idTypDefVal := FieldByName(fldIdTypDefVal).asInteger;
        paramAskMe.defSQL := FieldByName(fldDefSQL).asString;
        if paramAskMe.inpTyp in [prmDBLookup, prmDBMultiSelect] then
        begin
          paramAskMe.DBLookupAskMe := TDBLookupAskMe.Create;
          paramAskMe.DBLookupAskMe.sSQL := FieldByName(fldSQL).asString;
          paramAskMe.DBLookupAskMe.LookupField := FieldByName(fldLookupField).asString;
          paramAskMe.DBLookupAskMe.LookupDisplay := FieldByName(fldLookupDisplay).asString;
          paramAskMe.DBLookupAskMe.LookupDisplayIndex := FieldByName(fldLookupDisplayIndex).asInteger;
        end;

        ParamAskMeList.Add(paramAskMe);
        Next;
      end;
      Close;
    end;
  end;

  procedure AddQueryParam;
  begin
    aQuery2 := TQuery.Create(nil);
    try
      aQuery2.DatabaseName := glDatabaseName;
      aQuery2.SQL.Text := paramSQL +'where IdQuery='+IntToStr(IdQuery);
      setOrderBy(aQuery2, cnstOrderBy+fldNumm);
      _AddParam;
    finally
      aQuery2.Free;
    end;
  end;

  procedure AddRemoteDataParam;
  begin
    aQuery2 := TQuery.Create(nil);
    try
      aQuery2.DatabaseName := glDatabaseName;
      aQuery2.SQL.Text := paramSQL +'where IdRemoteData='+IntToStr(IdRemoteData);
      setOrderBy(aQuery2, cnstOrderBy+fldNumm);
      _AddParam;
    finally
      aQuery2.Free;
    end;
  end;

begin
  If ItemType=ttForm then                 //ttForm
  begin
    URepFormMainObjectID(IdCaller, IdQuery, IdRemoteData);
    If IdQuery>0 Then AddQueryParam
    Else AddRemoteDataParam;
  end
  else If ItemType=ttSQL then        //ttSQL
  begin
    IdQuery := IdCaller;
    AddQueryParam;
  end
  else If ItemType=ttRemoteData then   //ttRemoteData
  begin
    IdRemoteData := IdCaller;
    AddRemoteDataParam;
  end;
end;


function URepCreateParamList(IdCaller: integer; ItemType: TURepTreeItemType; var res: Boolean;
                           rep_name : string) : TParamAskMeList; //, sName1, sName2
begin
  res := False;
  result := TParamAskMeList.CreateParamList(IdCaller, ItemType);

  if result.Count>0 then
    res := AskMeParams(rep_name, result)
  else
    if MsgBox('', ' :' + rep_name,
                mb_OKCancel+mb_DefButton1)=IDOK then
      res := True
    else
      res := False;
end;


// TList ->ITEM = TQueryListItem
function URepCreateQueryList(IdCaller: integer; ItemType: TURepTreeItemType) : TQueryList;
var
  aQuery1: TQuery;
  idQuery, idRemoteData: integer;
  bIsMaster: Boolean;
  sQueryShortName: string;

  procedure AddQuery;
  var
    QueryListItem : TQueryListItem;
    aQuery2: TQuery;
  begin
    QueryListItem := TQueryListItem.Create;
    QueryListItem.QueryType := AskMe.ttSQL;
    QueryListItem.id := idQuery;
    QueryListItem.isMaster := bIsMaster;
    QueryListItem.QueryShortName := sQueryShortName;
    aQuery2 := TQuery.Create(nil);
    try
      with aQuery2 do
      begin
        DatabaseName := glDatabaseName;
        SQL.Text :='select Name, Description, SQLtext from URepQuery '+
                   'where Id='+IntToStr(idQuery);
        Open;
        QueryListItem.name := FieldByName(fldName).asString;
        QueryListItem.description := FieldByName(fldDescription).asString;
        QueryListItem.sqltext := FieldByName(fldSQLtext).asString;
        Close;
      end;
    finally
      aQuery2.Free;
    end;
    result.Add(QueryListItem);
  end;

  procedure AddRemoteData;
  var
    QueryListItem : TQueryListItem;
    aQuery2: TQuery;
  begin
    QueryListItem := TQueryListItem.Create;
    QueryListItem.QueryType := AskMe.ttRemoteData;
    QueryListItem.id := idRemoteData;
    QueryListItem.isMaster := bIsMaster;
    QueryListItem.QueryShortName := sQueryShortName;
    aQuery2 := TQuery.Create(nil);
    try
      with aQuery2 do
      begin
        DatabaseName := glDatabaseName;
        SQL.Text :='select Name, Description, IdRemtServerType, ServerName, ServerGUID, ComputerName, IdRemtProtocol, Port'+
                   ' from URepRemoteData'+
                   ' where Id='+IntToStr(idRemoteData);
        Open;
        QueryListItem.name := FieldByName(fldName).asString;
        QueryListItem.description := FieldByName(fldDescription).asString;
        QueryListItem.IdRemtServerType := FieldByName(fldIdRemtServerType).asInteger;
        QueryListItem.ServerName := Trim(FieldByName(fldServerName).asString);
        QueryListItem.ServerGUID := Trim(FieldByName(fldServerGUID).asString);
        QueryListItem.ComputerName := Trim(FieldByName(fldComputerName).asString);
        QueryListItem.IdRemtProtocol := FieldByName(fldIdRemtProtocol).asInteger;
        QueryListItem.Port := FieldByName(fldPort).asInteger;
        Close;
      end;
    finally
      aQuery2.Free;
    end;
    result.Add(QueryListItem);
  end;
begin
  result := TQueryList.Create;
  If ItemType=ttForm then           //ttForm
  begin
    aQuery1 := TQuery.Create(nil);
    try
      with aQuery1 do
      begin
        DatabaseName := glDatabaseName;
        SQL.Text :='select IsMaster, QueryShortName, IdQuery, IdRemoteData '+
                   'from URepFrm2Qry ' +
                   'where IdForm=' + IntToStr(IdCaller) +
                   ' order by Numm';
        Open;
        while not EOF do
        begin
          idQuery := FieldByName(fldIdQuery).asInteger;
          idRemoteData := FieldByName(fldIdRemoteData).asInteger;
          bIsMaster := FieldByName(fldIsMaster).asInteger>0;
          sQueryShortName := FieldByName(fldQueryShortName).asString;
          If idQuery>0 Then          AddQuery
          Else If idRemoteData>0 Then  AddRemoteData;
          Next;
        end;
        Close;
      end;
    finally
      aQuery1.Free;
    end;
  end
  else if ItemType=ttSQL then         //ttSQL
  begin
    idQuery  := IdCaller;
    bIsMaster := False;
    sQueryShortName := 'Query1';
    AddQuery;
  end
  else if ItemType=ttRemoteData then  //ttRemoteData
  begin
    idRemoteData  := IdCaller;
    bIsMaster := False;
    sQueryShortName := 'Query1';
    AddRemoteData;
  end;
end;


function URepFindDatasource4Dataset(DS: TDataSet): TDatasource;
var
  X: Integer;
begin
  URepFindDatasource4Dataset:=NIL;
  If DS=NIL Then Exit;
  For X:=0 to DS.Owner.ComponentCount-1 DO
    If (DS.Owner.Components[X] is TDatasource) AND
       (TDatasource(DS.Owner.Components[X]).Dataset=DS) Then
       begin
         URepFindDatasource4Dataset:=TDatasource(DS.Owner.Components[X]);
         Exit;
       end;
end;

procedure URepSetMasterDtSrc(aOwner: TComponent; DataSet: TDataSet; aQueryList: TQueryList);
var
  i : integer;
  queryListItem: TQueryListItem;
  aComp : TComponent;
  mstDatasource : TDatasource;
begin
  for i:=0 to (aQueryList.Count-1) do
    begin
    queryListItem := aQueryList.Items[i];
    if (queryListItem.isMaster) and
       (queryListItem.QueryShortName<>DataSet.Name)  then
      begin
      aComp := aOwner.FindComponent(queryListItem.QueryShortName);
      if assigned(aComp)then
        begin
        mstDatasource := URepFindDatasource4Dataset(TDataSet(aComp));
        If DataSet is TURepQuery Then
          TURepQuery(DataSet).DataSource := mstDatasource
        Else If DataSet is TQuery Then
          TQuery(DataSet).DataSource := mstDatasource
        Else
          Exception.Create('URep: Can not set master DataSource');
        break;
        end;
      end;
    end;
end;

procedure URepFieldDefsAddField(FieldDefs: TFieldDefs; fldName: string; DataType: TFieldType; DataLen: integer=0);
var
  i : integer;
  bFind: Boolean;
begin
  bFind := False;
  for i:=0 to FieldDefs.Count-1 do
    begin
    if FieldDefs.Items[i].Name=fldName then
      begin
      bFind := True;
      break;
      end;
    end;

  if not bFind then
    FieldDefs.Add(fldName, DataType, DataLen, False);
end;


procedure URepGetRemoteData(aClientDataSet: TClientDataSet;
                            aQueryItem: TQueryListItem;
                            aParAskList: TParamAskMeList);
var
  vObject, vData: OleVariant;
  vMasterQuery, vParams, vVal : OleVariant;
  i: integer;
  i_IDispatch: IDispatch;
  wsServerName, wsDatabaseName,  wsUser, wsPassword: WideString;

  function GetServerClassGUID: TGUID;
  begin
    if Length(aQueryItem.ServerGUID)>0 then
      result := StringToGUID(aQueryItem.ServerGUID)
    else
      result := ProgIDToClassID(aQueryItem.ServerName);
  end;
begin
  vMasterQuery := NULL;
  wsServerName := TDatabase(GetDBObject).Params.Values['SERVER NAME'];
  wsDatabaseName := TDatabase(GetDBObject).Params.Values['DATABASE NAME'];
  wsUser := TDatabase(GetDBObject).Params.Values['USER NAME'];
  wsPassword := TDatabase(GetDBObject).Params.Values['PASSWORD'];

  aClientDataSet.ReadOnly := False;
  aClientDataSet.Close;
  aClientDataSet.FieldDefs.Clear;

  if aQueryItem.IdRemtServerType= 1 then
  begin
    If aParAskList.Count>0 Then
    begin
      vParams := VarArrayCreate([1, aParAskList.Count], varVariant);
      for i:=0 to aParAskList.Count-1 do
      begin
        vVal := VarArrayCreate([1, 2], varVariant);
        vVal[1] := aParAskList.Items[i].parName;
        vVal[2] := aParAskList.Items[i].Value;
        vParams[i+1] := vVal;
      end;
    end
    else
      vParams := NULL;

    if Length(Trim(aQueryItem.ComputerName))>0 then
      i_IDispatch := CreateRemoteComObject(aQueryItem.ComputerName, GetServerClassGUID) as IDispatch
    else
      i_IDispatch := CreateComObject(GetServerClassGUID) as IDispatch;

    vObject := i_IDispatch;
    vData := vObject.GetData(vParams, vMasterQuery,
                    wsServerName, wsDatabaseName, wsUser, wsPassword);

    UnPackDataSet(aClientDataSet, vData);
    end;

  aClientDataSet.ReadOnly := True;
end;


procedure URepCreateDataSets(aOwner: TForm; aParAskList: TParamAskMeList; aQueryList: TQueryList; bIsReport: Boolean);
var
  aQueryItem: TQueryListItem;
  cCmpName : string;
  aComp : TComponent;
  aDataSet: TDataSet;
  aScrollQuery : TScrollQuery;
  aClientDataSet: TClientDataSet;
  aDataSource : TDataSource;
  i : integer;
  aParamAskMe : TParamAskMe;
  bNewQuery, bNewMemoryTable : Boolean;

  aURepQuery : TURepQuery;
  memData: TRxMemoryData;
begin
  Screen.Cursor := crSQLWait;
  try
    for i:=0 to (aQueryList.Count-1) do
      begin
      aDataSet:=nil;
      aQueryItem := aQueryList.Items[i];

      cCmpName := aQueryItem.QueryShortName;
      aComp := aOwner.FindComponent(cCmpName);
      bNewQuery := (aComp=nil);

      // 1. Create or reassign component, then open
      if aQueryItem.QueryType=AskMe.ttSQL then    //ttSQL
      begin

        if bIsReport then   // for report [TURepQuery]
        begin
          if bNewQuery then  // only for new Query - create and open
          begin
            aURepQuery := TURepQuery.Create(aOwner);
            with aURepQuery do
            begin
              Name := cCmpName;
              DatabaseConnName:= glDatabaseName;
              SQL.Text := aQueryItem.sqltext;
              Tag := aQueryItem.id;
              URepSetMasterDtSrc(aOwner, aURepQuery, aQueryList);
              DataSetBindParamAskMe(aURepQuery, aParAskList);
              try
               Open;
              except
                on E : Exception do
                  WarningMsg(E.Message);
              end;
            end;
            aDataSet := aURepQuery;
          end;
        end

        else                // for not report (ViewAsTable or OLE) [TScrollQuery]
        begin
          if not bNewQuery then
            aScrollQuery := TScrollQuery(aComp)
          else
            aScrollQuery := TScrollQuery.Create(aOwner);

          with aScrollQuery do
          begin
            RecNoList.DefaultRecNoItemType := False;
            RecNoList.RecNoItemType := UseBookmarkstr;
            Name := cCmpName;
            DatabaseName:= glDatabaseName;
            Close;
            SQL.Text := aQueryItem.sqltext;
            Tag := aQueryItem.id;
            URepSetMasterDtSrc(aOwner, aScrollQuery, aQueryList);
            DataSetBindParamAskMe(aScrollQuery, aParAskList);
            Open;
          end;
          aDataSet := aScrollQuery;
        end;
      end

      else if aQueryItem.QueryType=AskMe.ttRemoteData then    //ttRemoteData
      begin
        if not bNewQuery then
        begin
          aClientDataSet := TClientDataSet(aComp);
        end
        else
        begin
          aClientDataSet := TClientDataSet.Create(aOwner);
          aClientDataSet.Name := cCmpName;
        end;
        URepGetRemoteData(aClientDataSet, aQueryItem, aParAskList);
        aDataSet := aClientDataSet;
      end;

      // 4. Set TDataSource
      aDataSource := URepFindDatasource4Dataset(aDataSet);
      if aDataSource=nil then
        begin
        aDataSource := TDataSource.Create(aOwner);
        with aDataSource do
          begin
          //Name := 'DataSource'+IntToStr(i+1);
          Tag := aQueryItem.id;
          DataSet := aDataSet;
          end;
        end;

      end;
  finally
    Screen.Cursor := crDefault;
  end;

  if bIsReport then
    begin
    // Add (or Update if Exists)  MemTable -> Parametrs
    if aParAskList.Count>0 then
      begin
      cCmpName := cnstUsrPARAM;
      aComp := aOwner.FindComponent(cCmpName);
      bNewMemoryTable := aComp=nil;
      if not bNewMemoryTable then
        begin
        memData:= TRxMemoryData(aComp);
        memData.Close;
        end
      else
        begin
        memData:= TRxMemoryData.Create(aOwner);
        memData.Name := cCmpName;
        end;
      for i:=0 to (aParAskList.Count-1) do
        begin
        aParamAskMe := aParAskList.Items[i];
        case aParamAskMe.valTyp of
        valString :
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName, ftString, 255);
        valDate :
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName, ftDate);
        valMoney :
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName, ftCurrency);
        valDouble :
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName, ftFloat);
        valInteger:
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName, ftInteger);
        valDateTime :
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName, ftDateTime);
          end;
        if aParamAskMe.inpTyp=prmDBLookup then
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName+cnstDisplayParamPrefix, ftString, 255);
        if aParamAskMe.inpTyp=prmDBMultiSelect then
          URepFieldDefsAddField(memData.FieldDefs, aParamAskMe.parName+cnstDisplayParamPrefix, ftString, 2048);
        end;
      // recreate Fields
      for i:=memData.FieldCount-1 downto 0 do
        memData.Fields[i].Free;
      CreateFields(memData, nil);  // qrdprocs.pas

      memData.Open;
      memData.Insert;
      for i:=0 to (aParAskList.Count-1) do
      begin
        aParamAskMe := aParAskList.Items[i];
        try
        memData.FieldByName(aParamAskMe.parName).Value := aParamAskMe.Value ;
        case aParamAskMe.inpTyp of
          prmDBLookup, prmDBMultiSelect:
            memData.FieldByName(aParamAskMe.parName+cnstDisplayParamPrefix).asString :=
              aParamAskMe.DBLookupAskMe.DisplayValue ;
        end;
        except
        end;
      end;
      memData.Post;

      if bNewMemoryTable then
        begin
        cCmpName := 'ds' + cnstUsrPARAM;
        aComp := aOwner.FindComponent(cCmpName);
        if aComp=nil then
          begin
          aDataSource := TDataSource.Create(aOwner);
          with aDataSource do
            begin
            Name := cCmpName;
            Tag := -1;
            DataSet := memData;
            end;
          end;
        end;
    end;

    end;
end;


function URepExtFormAction(IdForm: integer; FrmName: string;
                            ParAskList: TParamAskMeList; frmActn: TURepFormAction;
                            OutFName: string; idDestination, idTypExec : integer;
                            bFreeParList: Boolean = True): Boolean;
var
  QueryList : TQueryList;
  res: Boolean;
  AsciiExportFilter : TQRAsciiExportFilter;
  CallerItemType: TURepTreeItemType;

   procedure SaveReportToText;
   begin
   AsciiExportFilter := TQRAsciiExportFilter.Create(OutFName);
   URepLogAction(1, IdForm, FrmName);
   dmURep.ReportDesignerDialog1.ExportReport_FromBlobField(dmURep.qFrmRepReport, AsciiExportFilter);
   AsciiExportFilter.Free;
   end;

   procedure PreviewReport;
   begin
   URepLogAction(1, IdForm, FrmName);
   dmURep.ReportDesignerDialog1.PreviewReport_FromBlobField(dmURep.qFrmRepReport);
   {if LastExceptionClassName<>'' then
     begin
     SaveException(LastExceptionClassName, LastExceptionMessage);
     LastExceptionClassName := '';
     end;
   }
   end;

   procedure PrintReport;
   begin
   URepLogAction(1, IdForm, FrmName);
   dmURep.ReportDesignerDialog1.PrintReport_FromBlobField(dmURep.qFrmRepReport);
   {if LastExceptionClassName<>'' then
     begin
     SaveException(LastExceptionClassName, LastExceptionMessage);
     LastExceptionClassName := '';
     end;}
   end;

   procedure ViewAsTable;
   begin
   URepLogAction(2, IdForm, FrmName);
   getFrmQryBro(IdForm, TURepTreeItemType(idTypExec), FrmName, ParAskList, QueryList);
   end;

begin
  result := True;
  CallerItemType := ttForm;
  if frmActn=factViewAsTbl then
    CallerItemType := TURepTreeItemType(idTypExec);

  if ParAskList=nil then
    begin //  
    ParAskList := URepCreateParamList(IdForm, CallerItemType, res, FrmName);
    if not res then
      begin
      result := False;
      ParAskList.Free;
      Exit;
      end;
    end;
  QueryList :=  URepCreateQueryList(IdForm, CallerItemType);

  try
    begin
    dmURep.FParAskList := ParAskList;
    dmURep.FQueryList := QueryList;
    dmURep.FFrmName := FrmName;

    with dmURep.qFrmRep do
      begin
      Close;
      ParamByName('Id').asInteger := IdForm;
      Open;
      end;
    if idTypExec<=0 then
      idTypExec := dmURep.qFrmRepIdTypExec.Value;
    if idDestination<0 then
      idDestination := dmURep.qFrmRepIdDestination.Value;

    case frmActn of
     factEdit:
       begin
       dmURep.qFrmRep.Edit;
       //if qFrmRepReport.isNull then
       //  ReportDesignerDialog1.NewReport_InBlobField(qFrmRepReport, FrmName)
       //else
       dmURep.ReportDesignerDialog1.EditReport_FromBlobField(dmURep.qFrmRepReport, FrmName);
       dmURep.qFrmRep.Post;
       end;

     factOutPreview:
       PreviewReport;

     factOutPrint:
       PrintReport;

     factOutSave:
       SaveReportToText;

     factExecDef:
       begin
       case IdTypExec of
        1: // IdTypExec =  (QR)
         begin
         case idDestination of
           0: // 
             PreviewReport;
           1: // 
             begin
             if URepSelDestination(idDestination) then
               case idDestination of
                 0: PreviewReport;
                 1: PrintReport;
                 2: SaveReportToText;
                 end;
             end;
           2: // 
             PrintReport;
           3: // . 
             SaveReportToText;
           end;
         end;
        1000: //IdTypExec = 
         begin
         ViewAsTable;
         end;
        end;
       end;

     factViewAsTbl:
       ViewAsTable;
     end;

    dmURep.qFrmRep.Close;
    end;
  finally
    if not( (frmActn=factViewAsTbl) or
            ((frmActn=factExecDef) and (IdTypExec=1000)) ) then
      begin
      if bFreeParList then
        ParAskList.Free;
      QueryList.Free;
      dmURep.FParAskList := nil;
      dmURep.FQueryList := nil;
      end;
  end;
end;



procedure URepEditRepForm(IdForm: integer; FrmName: string);
begin
  URepExtFormAction(IdForm, FrmName,
                    nil, factEdit, '', 0, 0);
end;


function URepActionReport(IdForm: integer; FrmName: string;
                          idDestination, idTypExec : integer): Boolean;
begin
  result := URepExtFormAction(IdForm, FrmName,
                    nil, factExecDef, '',
                    idDestination, idTypExec);
end;

function URepDefFormAction(IdForm: integer; FrmName: string;
                            ParAskList: TParamAskMeList; OutFName: string = ''): Boolean;
begin
  result := URepExtFormAction(IdForm, FrmName,
                    ParAskList, factExecDef, OutFName, -1, -1);
end;


function URepSelDestination(var IdDestination: integer): Boolean;
var
  cmb : TComboBox;
  frm : TForm;
begin
  frm := TForm.Create(Application);
  with frm do
    begin
    Caption := '  ';
    BorderStyle := bsDialog;
    Width := 300;
    Height := 100;
    Position := poScreenCenter;
    end;
  with TLabel.Create(frm) do
    begin
    Parent := frm;
    Caption := ' ';
    Top := 8;
    Left := 20;
    end;
  cmb := TComboBox.Create(frm);
  with cmb do
    begin
    Parent := frm;
    Top := 4;
    Left := 120;
    Style := csDropDownList;
    Items.Append(' ');
    Items.Append(' ');
    Items.Append(' ');
    ItemIndex := IdDestination;
    end;
  //cmb.Invalidate;

  with TBitBtn.Create(frm) do //OK
    begin
    Parent := frm;
    Top := 40;
    Left := 65;
    Kind := bkOK;
    end;
  with TBitBtn.Create(frm) do //Cancel
    begin
    Parent := frm;
    Top := 40;
    Left := 155;
    Kind := bkCancel;
    end;

  result := (frm.ShowModal=mrOK);
  IdDestination := cmb.ItemIndex;
  frm.Release;
end;

function URepImageIndexFromIdTypObj(IdTypObj: integer): integer;
begin
  case IdTypObj of
  1: result := 0; //1- 
  2: result := 1; //2-
  3: result := 3; //3-
  4: result := 5; //4-
  5: result := 30; //5-
  6: result := 38; //6-
  7: result := 40; //7- 
  else result := 0;
    end;
end;

// set flag ReRunReport
procedure URepSetReRunReport(mnuReRunReport: TMenuItem);
var
  RegIniFile : TRegIniFile;
begin
  RegIniFile := TRegIniFile.Create(GetDefaultIniRegKey);
  try
    glReRunReport :=
      RegIniFile.ReadBool(cnstURepUserSettingsSection, cnstReRunReportIdent, False);
  finally
    RegIniFile.Free;
  end;
  mnuReRunReport.Checked := glReRunReport;
end;

procedure URepChangeReRunReport(mnuReRunReport: TMenuItem);
var
  RegIniFile : TRegIniFile;
begin
  mnuReRunReport.Checked := not mnuReRunReport.Checked;
  glReRunReport := mnuReRunReport.Checked;
  RegIniFile := TRegIniFile.Create(GetDefaultIniRegKey);
  try
    RegIniFile.WriteBool(cnstURepUserSettingsSection, cnstReRunReportIdent, glReRunReport);
  finally
    RegIniFile.Free;
  end;
end;

function URepGetReRunReport: Boolean;
begin
  result := glReRunReport;
end;

procedure URepGetParamPrefix;
var
  vValue: Variant;
begin
  vValue := DLookup('select Item from Lookups where Teg=''URep_prmPrefix''');
  if VarType(vValue) = varOleStr then
    prmPrefix := Trim(vValue)
  else
    prmPrefix := '';
end;

function URepGroupAdd(GroupName: string): Integer;
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftString, prmPrefix+fldGrpName, ptInput);
   params.CreateParam(ftInteger, prmPrefix+'IdGrp', ptOutput);
   params.ParamValues[prmPrefix+fldGrpName] := GroupName;
   ExecSP('spURepGrpAdd', params);
   result := params.ParamValues[prmPrefix+'IdGrp'];
 finally
   params.Free;
 end;
end;

procedure URepGroupDelete(IdGroup : integer);
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftInteger, prmPrefix+'IdGrp', ptInput);
   params.ParamValues[prmPrefix+'IdGrp'] := IdGroup;
   ExecSP('spURepGrpDel', params);
 finally
   params.Free;
 end;
end;

procedure URepFormDelete(IdForm : integer);
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftInteger, prmPrefix+fldIdForm, ptInput);
   params.ParamValues[prmPrefix+fldIdForm] := IdForm;
   ExecSP('spURepFormDel', params);
 finally
   params.Free;
 end;
end;

function URepFrm2QryNumm(IdForm: integer): integer;
var
 params : TParams;
begin
  params := TParams.Create;
  try
    params.CreateParam(ftInteger, prmPrefix+fldIdForm, ptInput);
    params.CreateParam(ftInteger, prmPrefix+fldNumm, ptOutput);
    params.ParamValues[prmPrefix+fldIdForm] := IdForm;
    ExecSP('spURepFrm2QryNumm', params);
    result := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;
end;

function URepFormAdd(FormName:string; IdQuery: integer): integer;
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftString, prmPrefix+fldName, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdQuery, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdForm, ptOutput);
   params.ParamValues[prmPrefix+fldName] := FormName;
   params.ParamValues[prmPrefix+fldIdQuery] := IdQuery;
   ExecSP('spURepFormAdd', params);
   result := params.ParamValues[prmPrefix+fldIdForm];
 finally
   params.Free;
 end;
end;

procedure URepQueryDelete(IdQuery : integer);
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftInteger, prmPrefix+fldIdQuery, ptInput);
   params.ParamValues[prmPrefix+fldIdQuery] := IdQuery;
   ExecSP('spURepQueryDel', params);
 finally
   params.Free;
 end;
end;

function URepQueryAdd(QueryName: string; IdForm: integer): integer;
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftString, prmPrefix+fldName, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdForm, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdQuery, ptOutput);
   params.ParamValues[prmPrefix+fldName] := QueryName;
   params.ParamValues[prmPrefix+fldIdForm] := IdForm;
   ExecSP('spURepQueryAdd', params);
   result := params.ParamValues[prmPrefix+fldIdQuery];
 finally
   params.Free;
 end;
end;


procedure URepScriptDelete(IdScript : integer);
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftInteger, prmPrefix+fldIdScript, ptInput);
   params.ParamValues[prmPrefix+fldIdScript] := IdScript;
   ExecSP('spURepScriptDel', params);
 finally
   params.Free;
 end;
end;

function URepScriptAdd(ScriptName:string): integer;
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftString, prmPrefix+fldName, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdScript, ptOutput);
   params.ParamValues[prmPrefix+fldName] := ScriptName;
   ExecSP('spURepScriptAdd', params);
   result := params.ParamValues[prmPrefix+fldIdScript];
 finally
   params.Free;
 end;
end;

function  URepRemoteDataAdd(RemoteDataName: String):integer;
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftString, prmPrefix+fldName, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdRemoteData, ptOutput);
   params.ParamValues[prmPrefix+fldName] := RemoteDataName;
   ExecSP('spURepRemoteDataAdd', params);
   result := params.ParamValues[prmPrefix+fldIdRemoteData];
 finally
   params.Free;
 end;
end;

procedure URepRemoteDataDelete(IdRemoteData : integer);
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftInteger, prmPrefix+fldIdRemoteData, ptInput);
   params.ParamValues[prmPrefix+fldIdRemoteData] := IdRemoteData;
   ExecSP('spURepRemoteDataDel', params);
 finally
   params.Free;
 end;
end;

function  URepParamAdd(ParName: string; IdQuery, IdRemoteData: integer): integer;
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftString, prmPrefix+fldParName, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdQuery, ptInput);
   params.CreateParam(ftInteger, prmPrefix+fldIdRemoteData, ptInput);
   params.CreateParam(ftInteger, prmPrefix+'IdParam', ptOutput);
   params.ParamValues[prmPrefix+fldParName] := ParName;
   params.ParamValues[prmPrefix+fldIdQuery] := IdQuery;
   params.ParamValues[prmPrefix+fldIdRemoteData] := IdRemoteData;
   ExecSP('spURepParamAdd', params);
   result := params.ParamValues[prmPrefix+'IdParam'];
 finally
   params.Free;
 end;
end;


procedure URepParamDelete(IdParam: integer);
begin
  DoSQL('Delete from URepParam where Id='+ IntToStr(IdParam));
end;



initialization
  RegisterClasses([TClientDataSet, TDataSource,
                   TURepQuery, TRxMemoryData]);

  glPtrTURepGetIsAdminFunc := URepDeffGetIsAdmin;
  bIsAdminValSet := False;
  bIsAdminVal := False;

end.
