unit fURepGrp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, RXDBCtrl, DBCtrls, StdCtrls, Mask, ExtCtrls, Db, DBTables,
  UpdQuery, Placemnt, ScrlQuery, DBUtils, ComCtrls, ToolWin, ActnList;

type
  TfrmURepGrpFrm = class(TForm)
    Panel1: TPanel;
    DBEditName: TDBEdit;
    Label3: TLabel;
    qGroup: TUpdQuery;
    qGroupGrpId: TAutoIncField;
    qGroupGrpName: TStringField;
    qGroupIdParent: TIntegerField;
    qGrpBodFrm: TUpdQuery;
    qGrpBodFrmId: TAutoIncField;
    qGrpBodFrmIdGroup: TIntegerField;
    qGrpBodFrmIdForm: TIntegerField;
    qGrpBodFrmFormName: TStringField;
    dsGroup: TDataSource;
    dsGrpBodyFrm: TDataSource;
    qForm: TScrollQuery;
    qFormId: TAutoIncField;
    qFormNumm: TIntegerField;
    qFormName: TStringField;
    FormStorage1: TFormStorage;
    qGroupNumm: TIntegerField;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit3: TDBEdit;
    Label5: TLabel;
    qGrpBodFrmNumm: TIntegerField;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheetForms: TTabSheet;
    TabSheetScripts: TTabSheet;
    RxDBGrid1: TRxDBGrid;
    qGrpBodScr: TUpdQuery;
    dsGrpBodScr: TDataSource;
    qScript: TScrollQuery;
    qGrpBodScrId: TAutoIncField;
    qGrpBodScrIdGroup: TIntegerField;
    qGrpBodScrIdScript: TIntegerField;
    qGrpBodScrNumm: TIntegerField;
    qScriptId: TAutoIncField;
    qScriptNumm: TIntegerField;
    qScriptName: TStringField;
    qGrpBodScrScriptName: TStringField;
    RxDBGrid2: TRxDBGrid;
    qGroupId: TAutoIncField;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    DBNavigator1: TDBNavigator;
    CoolBar2: TCoolBar;
    ToolBar2: TToolBar;
    DBNavigator2: TDBNavigator;
    CoolBar3: TCoolBar;
    ToolBar3: TToolBar;
    DBNavigator3: TDBNavigator;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ActionList1: TActionList;
    ActionEditScript: TAction;
    ActionEditForm: TAction;
    qGrpBodFrmName: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure qGrpBodFrmNewRecord(DataSet: TDataSet);
    procedure qGroupAfterPost(DataSet: TDataSet);
    procedure DBNavigator2BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure qGroupNewRecord(DataSet: TDataSet);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure qGroupBeforeOpen(DataSet: TDataSet);
    procedure qGrpBodFrmBeforeOpen(DataSet: TDataSet);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure qFormBeforeOpen(DataSet: TDataSet);
    procedure qGrpBodFrmIdFormChange(Sender: TField);
    procedure qGrpBodScrIdScriptChange(Sender: TField);
    procedure DBNavigator3BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure ActionEditFormExecute(Sender: TObject);
    procedure ActionEditScriptExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FindGrpFrm(IdGroup, IdForm, IdScript: integer);
  end;


implementation

{$R *.DFM}

uses fURepMain, Common, CommonVV, dmdURep, QueryEx, ConstEx, LayoutEx,
     fURepFunc1, fURepFrm, fURepScr, URepConstants;

procedure TfrmURepGrpFrm.FormCreate(Sender: TObject);
begin
  //controls layout
  FitControlWidthToParent(DBEditName);

  ReQueryAll(Self);
end;

procedure TfrmURepGrpFrm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepGrpFrm.FindGrpFrm(IdGroup, IdForm, IdScript: integer);
begin
  if IdGroup<>0 then
    qGroup.Locate('GrpId', IdGroup, []);
  if IdForm<>0 then
    begin
    qGrpBodFrm.Locate('IdForm', IdForm, []);
    PageControl1.ActivePage := TabSheetForms;
    end;
  if IdScript<>0 then
    begin
    qGrpBodScr.Locate('IdScript', IdScript, []);
    PageControl1.ActivePage := TabSheetScripts;
    end;
end;

procedure TfrmURepGrpFrm.qGrpBodFrmNewRecord(DataSet: TDataSet);
begin
  DataSet.FieldByName('IdGroup').asInteger := qGroupGrpId.Value;
end;

procedure TfrmURepGrpFrm.qGroupAfterPost(DataSet: TDataSet);
begin
  GoMessage(WM_UREPTBLCHANGE);
  GoMessage(WM_UREPGrpChange);
end;

procedure TfrmURepGrpFrm.DBNavigator2BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbInsert then
     begin
     qGrpBodFrm.Append;
     Abort;
     end;
end;

procedure TfrmURepGrpFrm.qGroupNewRecord(DataSet: TDataSet);
var
  params: TParams;
begin
  params := TParams.Create;
  try
    params.CreateParam(ftInteger, prmPrefix+fldNumm, ptOutput);
    ExecSP('spURepGrpNumm', params);
    qGroupNumm.Value := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;  
end;

procedure TfrmURepGrpFrm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  ConfirmDataSetCancel(qGroup);
  ConfirmDataSetCancel(qGrpBodFrm);
end;

procedure TfrmURepGrpFrm.qGroupBeforeOpen(DataSet: TDataSet);
begin
  setOrderBy(DataSet, 'ORDER BY '+URepTreeSortGrpOrderStr[dmURep.FSortOrder]);
end;


procedure TfrmURepGrpFrm.qGrpBodFrmBeforeOpen(DataSet: TDataSet);
const
  URepTreeSortGrpOrderStr : array [TURepTreeSortOrder] of string =
    ('2, 4', '2, 5', '2, 1');
begin
  setOrderBy(DataSet, 'ORDER BY '+URepTreeSortGrpOrderStr[dmURep.FSortOrder]);
end;

procedure TfrmURepGrpFrm.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then
     begin
     RequeryOne(qGroup);
     Abort;
     end;
end;

procedure TfrmURepGrpFrm.qFormBeforeOpen(DataSet: TDataSet);
begin
  setOrderBy(DataSet, 'ORDER BY '+URepTreeSortOrderString[dmURep.FSortOrder]);
end;

procedure TfrmURepGrpFrm.qGrpBodFrmIdFormChange(Sender: TField);
begin
  if qGrpBodFrm.State in [dsInsert,dsEdit] then
  begin
    qGrpBodFrmNumm.Value := qFormNumm.Value;
  end;
end;

procedure TfrmURepGrpFrm.qGrpBodScrIdScriptChange(Sender: TField);
begin
  if qGrpBodScr.State in [dsInsert,dsEdit] then
  begin
    qGrpBodScrNumm.Value := qScriptNumm.Value;
  end;
end;

procedure TfrmURepGrpFrm.DBNavigator3BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbInsert then
     begin
     qGrpBodScr.Append;
     Abort;
     end;
end;

procedure TfrmURepGrpFrm.ActionEditFormExecute(Sender: TObject);
var
  frmURepForm : TfrmURepForm;
begin
  frmURepForm := GetOneFormExt(TfrmURepForm, URepGetMainForm) as TfrmURepForm;
  frmURepForm.FindForm(qGrpBodFrmIdForm.Value, 0, 0);
end;

procedure TfrmURepGrpFrm.ActionEditScriptExecute(Sender: TObject);
var
  frmURepScript: TfrmURepScript;
begin
  frmURepScript := GetOneFormExt(TfrmURepScript,URepGetMainForm) as  TfrmURepScript;
  frmURepScript.FindScript(qGrpBodScrIdScript.Value);
end;

end.
