unit fURepLogins;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, UpdQuery, Grids, DBGrids, RXDBCtrl, ExtCtrls, DBCtrls,
  Placemnt;

type
  TfrmURepLogins = class(TForm)
    Panel1: TPanel;
    RxDBGrid1: TRxDBGrid;
    qLogins: TUpdQuery;
    qLoginsLoginName: TStringField;
    qLoginsFullName: TStringField;
    qLoginsIsRole: TIntegerField;
    DBNavigator1: TDBNavigator;
    dsLogins: TDataSource;
    FormStorage1: TFormStorage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure qLoginsBeforeInsert(DataSet: TDataSet);
    procedure qLoginsBeforeDelete(DataSet: TDataSet);
    procedure RxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure RxDBGrid1ShowEditor(Sender: TObject; Field: TField;
      var AllowEdit: Boolean);
    procedure qLoginsBeforeEdit(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation

{$R *.DFM}

uses dmdURep, Common, QueryEx, LayoutEx, URepConstants;


procedure TfrmURepLogins.FormCreate(Sender: TObject);
begin
  ReQueryAll(Self);
end;

procedure TfrmURepLogins.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepLogins.qLoginsBeforeInsert(DataSet: TDataSet);
begin
  Abort;
end;

procedure TfrmURepLogins.qLoginsBeforeDelete(DataSet: TDataSet);
begin
  Abort;
end;

procedure TfrmURepLogins.RxDBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
 iIndex: integer;
 aBitmap: TBitmap;
begin
  if (Column.Field=qLoginsIsRole) and
     (Column.Field.IsNull=False) then
    begin
    iIndex := qLoginsIsRole.Value + 48;
    aBitmap := TBitmap.Create;
    dmURep.imgLstURep.GetBitmap(iIndex, aBitmap);
    RxDBGrid1.Canvas.FillRect(Rect);
    RxDBGrid1.Canvas.Draw(Rect.Left+10,
                          (Rect.Top+Rect.Bottom-aBitmap.Height) div 2,
                          aBitmap);
    aBitmap.Free;
    end
  else
    RxDBGrid1.DefaultDrawColumnCell(Rect,DataCol,Column,State);
end;

procedure TfrmURepLogins.RxDBGrid1ShowEditor(Sender: TObject;
  Field: TField; var AllowEdit: Boolean);
begin
  if (Field=qLoginsIsRole) or
     (Field=qLoginsLoginName)  then
    AllowEdit := False;
end;

procedure TfrmURepLogins.qLoginsBeforeEdit(DataSet: TDataSet);
var
  iCnt: integer;
begin
  if qLoginsIsRole.Value=1 then
  begin
    ErrorMsg(cnstURepNotEdited);
    Abort;
  end
  else
  begin
    iCnt := DLookup('select count(*) from URepLogins where LoginName='+
                    Str2SQLstr(qLoginsLoginName.Value));
    if iCnt>0 then
      qLogins.ModifySQL.Text :=
        'update URepLogins set FullName=:FullName where LoginName=:LoginName'
    else
      qLogins.ModifySQL.Text :=
        'insert into URepLogins (LoginName, FullName) values (:LoginName, :FullName)';
  end;
end;

end.
