unit fURepMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Db, DBTables, Menus, ActnList, ToolWin, Placemnt, VCLUtils,
  vvTreeView, StdCtrls, buttons, RxLookup, unAddQRFnc, unThrdSender, ConstEx,
  URepTypes;


type
  TURepTreeChainType = (tcGrpForm, tcAllForm, tcAllSQL, tcAllScript, tcAllRemoteData);

  TURepTreeItemData = record
    ItemType : TURepTreeItemType;
    ChainType : TURepTreeChainType;
    Id : integer;
    Numm: integer;
    SearchId: integer; // for element search (Id in Table)
    IdDestination, IdTypExec : integer;
  end;

  PURepTreeItemData = ^TURepTreeItemData;

  TfrmURepMain = class(TForm)
    TreeView1: TvvTreeView;
    PopupMenu1: TPopupMenu;
    mnuSepGrpFrm: TMenuItem;
    mnuSepFrm: TMenuItem;
    mnuSepSQL: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    CoolBar1: TCoolBar;
    mnuSepParam: TMenuItem;
    N17: TMenuItem;
    ToolBarOther: TToolBar;
    ToolButton101: TToolButton;
    ToolButton102: TToolButton;
    ToolBarEdit: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ActionList1: TActionList;
    actnNewGrpFrm: TAction;
    actnEditGrpFrm: TAction;
    actnDelGrpFrm: TAction;
    actnNewFrm: TAction;
    actnEditFrm: TAction;
    actnDelFrm: TAction;
    actnNewSQL: TAction;
    actnEditSQL: TAction;
    actnDelSQL: TAction;
    actnNewParam: TAction;
    actnEditParam: TAction;
    actnDelParam: TAction;
    actnUsersList: TAction;
    actnExec: TAction;
    actnExecAsTbl: TAction;
    actnEdtRepFrm: TAction;
    actnRefresh: TAction;
    actnNewScript: TAction;
    actnEditScript: TAction;
    actnDelScript: TAction;
    ToolBarRun: TToolBar;
    ToolButton201: TToolButton;
    ToolButton202: TToolButton;
    ToolButton203: TToolButton;
    ToolButton204: TToolButton;
    ToolButton16: TToolButton;
    ToolButton103: TToolButton;
    ToolButton205: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    ToolButton20: TToolButton;
    FormStorage1: TFormStorage;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N18: TMenuItem;
    mnuSepScript: TMenuItem;
    mnuSepExec: TMenuItem;
    ToolButton21: TToolButton;
    ppmunuSort: TPopupMenu;
    mnSortNum: TMenuItem;
    mnSortName: TMenuItem;
    mnSortId: TMenuItem;
    actnNewRemoteData: TAction;
    actnEditRemoteData: TAction;
    actnDelRemoteData: TAction;
    ToolButton22: TToolButton;
    ToolButton23: TToolButton;
    ToolButton24: TToolButton;
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure actnNewGrpFrmExecute(Sender: TObject);
    procedure actnEditGrpFrmExecute(Sender: TObject);
    procedure actnDelGrpFrmExecute(Sender: TObject);
    procedure actnRefreshExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeView1Editing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure TreeView1Edited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure actnNewFrmExecute(Sender: TObject);
    procedure actnEditFrmExecute(Sender: TObject);
    procedure actnDelFrmExecute(Sender: TObject);
    procedure actnNewSQLExecute(Sender: TObject);
    procedure actnEditSQLExecute(Sender: TObject);
    procedure actnDelSQLExecute(Sender: TObject);
    procedure actnNewParamExecute(Sender: TObject);
    procedure actnEditParamExecute(Sender: TObject);
    procedure actnDelParamExecute(Sender: TObject);
    procedure actnExecExecute(Sender: TObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure actnUsersListExecute(Sender: TObject);
    procedure actnExecAsTblExecute(Sender: TObject);
    procedure actnEdtRepFrmExecute(Sender: TObject);
    procedure TreeView1TreeItemDblClick(Sender: TObject; Node: TTreeNode);
    procedure actnNewScriptExecute(Sender: TObject);
    procedure actnEditScriptExecute(Sender: TObject);
    procedure actnDelScriptExecute(Sender: TObject);
    procedure mnSortClick(Sender: TObject);
    procedure actnNewRemoteDataExecute(Sender: TObject);
    procedure actnEditRemoteDataExecute(Sender: TObject);
    procedure actnDelRemoteDataExecute(Sender: TObject);
    procedure ToolButton21Click(Sender: TObject);
  private
    { Private declarations }
    procedure SetTreeItemProp(Node: TTreeNode;
                              ItemType : TURepTreeItemType;
                              ChainType : TURepTreeChainType;
                              Id, Numm, SearchId: integer);
    procedure FindNode(TreeItemData: TURepTreeItemData; Text: string);
    procedure AddFormItems(parentNode: TTreeNode; ChainType : TURepTreeChainType;
                           IdForm, Numm, SearchId: integer; NameForm: string; idDestination, idTypExec : integer);
    procedure AddQueryParamItems(parentNode: TTreeNode; ChainType : TURepTreeChainType;
                                 IdQuery, SearchId: integer);
    procedure AddRemoteDataParamItems(parentNode: TTreeNode; ChainType: TURepTreeChainType;
                                      IdRemoteData, SearchId: integer);
    procedure OnURepTblChange(var Message: TMessage); message WM_UREPTBLCHANGE;
    procedure OnURepGrpChange(var Message: TMessage); message WM_UREPGrpChange;
  public
    { Public declarations }
    procedure RefreshTree(FindPos: Boolean);
  end;


implementation

{$R *.DFM}

uses dmdURep, QueryEx, CommonVV, Common, AppUtils,
     fURepFunc1, fURepGrp, fURepFrm, fURepQry, fURepParam, fURepScr,
     fURepRights, fURepDelDep, fUrepActScpSite, fURepRemt, URepConstants;

function GetDefaultName(TableName, defName: string; FldName:string='Name'): string;
var
 i: integer;
 _defName: string;
begin
 i := 1;
 _defName := defName;
 while DLookup('select count(*) from '+TableName+
              ' where '+FldName+'='''+_defName+'''')>0 do
   begin
   _defName := defName +' '+ Trim(IntToStr(i));
   Inc(i);
   end;
 result := _defName;
end;

procedure TfrmURepMain.OnURepTblChange(var Message: TMessage);
begin
  RefreshTree(True);
end;

procedure TfrmURepMain.OnURepGrpChange(var Message: TMessage);
{var
  msg: string;
  lst:TStringList;}
begin
{
 msg := SYS_COMMAND_PREFIX + SYSCMD_REFRESHUREPMAIN;
 lst := TStringList.Create;
 try
   with dmURep.qMSservers do
   begin
     Close;
     Open;
     try
       First;
       while not EOF do
       begin
         lst.Add(FieldByName('Server').AsString);
         Next;
       end;
      finally
        Close;
      end;
   end;
   If lst.Count>0 Then
     TThreadSender.CreateEx(lst, GetProgName, msg);
 finally
   lst.Free;
 end;
}
end;


procedure TfrmURepMain.FormCreate(Sender: TObject);
var
  i : integer;
  CoolBand : TCoolBand;
begin
  // rights
  if not URepIsAdmin then
    begin
    CoolBar1.Bands.BeginUpdate;
    CoolBar1.Bands.Clear;
    ToolBarEdit.Free;
    ToolBarOther.Free;
    CoolBand := CoolBar1.Bands.Add;
    CoolBand.Control := ToolBarRun;
    CoolBar1.Bands.EndUpdate;
    for i:= 0 to 17 do
      (ActionList1.Actions[i] as TCustomAction).Enabled :=False;
    end;

  RefreshTree(False);
end;

procedure TfrmURepMain.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepMain.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  for i:=0 to TreeView1.Items.Count-1 do
    Dispose( TreeView1.Items[i].Data);
end;


procedure TfrmURepMain.SetTreeItemProp(Node: TTreeNode;
                           ItemType : TURepTreeItemType;
                           ChainType : TURepTreeChainType;
                           Id, Numm, SearchId : integer);
var
 pTreeItemData: PURepTreeItemData;
 iImageIndex: integer;
begin
 New(pTreeItemData);
 pTreeItemData^.ItemType := ItemType;
 pTreeItemData^.ChainType := ChainType;
 pTreeItemData^.Id := Id;
 pTreeItemData^.Numm := Numm;
 pTreeItemData^.SearchId := SearchId;

 Node.Data := pTreeItemData;

 case ItemType of
 ttGrpScript: iImageIndex := 29;
 ttScript:    iImageIndex := 30;
 ttGrpRemoteData: iImageIndex := 39;
 ttRemoteData:    iImageIndex := 40;
 else  iImageIndex := Ord(ItemType);
 end;
 Node.ImageIndex := iImageIndex;
 Node.SelectedIndex := iImageIndex;

end;

procedure TfrmURepMain.FindNode(TreeItemData: TURepTreeItemData; Text: string);
var
 iiTreeItemData : TURepTreeItemData;
 i: integer;
begin
  for i:=0 to TreeView1.Items.Count-1 do
    begin
    iiTreeItemData := (PURepTreeItemData(TreeView1.Items[i].Data))^;
    if (iiTreeItemData.ItemType = TreeItemData.ItemType) and
       (iiTreeItemData.ChainType = TreeItemData.ChainType) and
       (iiTreeItemData.Id = TreeItemData.Id) and
       //(TreeView1.Items[i].Text=Text) and
       (iiTreeItemData.SearchId = TreeItemData.SearchId) then
       begin
         TreeView1.Selected := TreeView1.Items[i];
         Break;
       end;
    end;
end;


procedure TfrmURepMain.RefreshTree(FindPos: Boolean);
var
 parentNode, aNode1: TTreeNode;
 TreeItemData : TURepTreeItemData;
 text : string;
 idGroup: integer;
begin
// ReOpen Query
  with dmURep do
  begin
    ReQueryOne(qGroup);
    ReQueryOne(qGrpBody);
    ReQueryOne(qFrm2Qry);
    ReQueryOne(qQueryParam);
    ReQueryOne(qRemoteDataParam);
  end;

  if FindPos then
  begin
    if assigned(TreeView1.Selected) then
    begin
      TreeItemData := (PURepTreeItemData(TreeView1.Selected.Data))^;
      text := TreeView1.Selected.Text;
    end
    else
      FindPos := False;
  end;

  TreeView1.Items.BeginUpdate;
  try
    // ClearTree
    FormDestroy(nil);
    TreeView1.Items.Clear;

    // Fill Tree
    with dmURep do
    begin
      //1.  
      qGroup.First;
      while not qGroup.EOF do
      begin
        parentNode := TreeView1.Items.Add(nil, qGroupGrpName.Value);
        SetTreeItemProp(parentNode, ttGrpForm, tcGrpForm,
                        qGroupId.Value, qGroupNumm.Value, qGroupId.Value);
        //1.2  
        //qGrpBody.Filter:='IdGroup = '+ qGroupId.AsString;
        //qGrpBody.Filtered := True;
        qGrpBody.First;
        idGroup := qGroupId.Value;
        qGrpBody.Locate(fldIdGroup, idGroup, []);
        while not qGrpBody.EOF do
        begin
          If qGrpBodyIdGroup.Value<>idGroup then Break;
          if (not qGrpBodyIdForm.IsNull) then // form
          begin
            AddFormItems(parentNode, tcGrpForm,
                         qGrpBodyIdForm.Value, qGrpBodyNumm.Value, qGrpBodyId.Value,
                         qGrpBodyName.Value, qGrpBodyIdDestination.Value, qGrpBodyIdTypExec.Value)
          end
          else if (not qGrpBodyIdScript.IsNull) then // script
          begin
            aNode1 := TreeView1.Items.AddChild(parentNode, qGrpBodyName.Value);
            SetTreeItemProp(aNode1, ttScript, tcGrpForm,
                            qGrpBodyIdScript.Value, qGrpBodyNumm.Value, qGrpBodyId.Value);
          end;
          qGrpBody.Next;
        end;

        qGroup.Next
      end;

      //2.  
      if URepIsAdmin then
      begin
        ReQueryOne(qForm);
        parentNode := TreeView1.Items.Add(nil, cnstAllReports);
        SetTreeItemProp(parentNode, ttGrpForm, tcAllForm, 0 ,0, 0);
        qForm.First;
        while not qForm.EOF do
        begin
          AddFormItems(parentNode, tcAllForm,
                       qFormId.Value, qFormNumm.Value, qFormId.Value,
                       qFormName.Value, qFormIdDestination.Value, qFormIdTypExec.Value);
          qForm.Next;
        end;
      end;

      //3.  
      if URepIsAdmin then
      begin
        ReQueryOne(qQuery);
        //qQuery.Filtered :=False;
        //qQuery.Filter := '';
        parentNode := TreeView1.Items.Add(nil, cnstAllQuerys);
        SetTreeItemProp(parentNode, ttGrpSQL, tcAllSQL, 0, 0, 0);
        with dmURep do
        begin
          qQuery.First;
          while not qQuery.EOF do
          begin
            aNode1 := TreeView1.Items.AddChild(parentNode, qQueryName.Value);
            SetTreeItemProp(aNode1, ttSQL, tcAllSQL,
                            qQueryId.Value, qQueryNumm.Value, qQueryId.Value);
            //3.1  
            AddQueryParamItems(aNode1, tcAllSQL, qQueryId.Value, qQueryId.Value);
            qQuery.Next;
          end;
        end;
      end;

      //4.   
      if URepIsAdmin Then
      begin
        ReQueryOne(qRemoteData);
        parentNode := TreeView1.Items.Add(nil, cnstAllRemoteData);
        SetTreeItemProp(parentNode, ttGrpRemoteData, tcAllRemoteData, 0, 0, 0);
        qRemoteData.First;
        while not qRemoteData.EOF do
        begin
          aNode1 := TreeView1.Items.AddChild(parentNode, qRemoteDataName.Value);
          SetTreeItemProp(aNode1, ttRemoteData, tcAllRemoteData,
                          qRemoteDataId.Value, qRemoteDataNumm.Value, qRemoteDataId.Value);

          //4.1   
          AddRemoteDataParamItems(aNode1, tcAllRemoteData, qRemoteDataId.Value, qRemoteDataId.Value);

          qRemoteData.Next;
        end;
      end;

      //5.  
      if URepIsAdmin then
      begin
        ReQueryOne(qScript);
        parentNode := TreeView1.Items.Add(nil, cnstAllScripts);
        SetTreeItemProp(parentNode, ttGrpScript, tcAllScript, 0, 0, 0);
        qScript.First;
        while not qScript.EOF do
        begin
          aNode1 := TreeView1.Items.AddChild(parentNode, qScriptName.Value);
          SetTreeItemProp(aNode1, ttScript, tcAllScript,
                          qScriptId.Value, qScriptNumm.Value, qScriptId.Value);
          qScript.Next;
        end;
      end;

    end;
  finally
    TreeView1.Items.EndUpdate;
  end;

  if FindPos then // position on old item
    FindNode(TreeItemData, text);
  if (not URepIsAdmin) and
     ((not FindPos)or (TreeView1.Selected=TreeView1.Items[0])) then
    if TreeView1.Items.Count>0 then
      TreeView1.Items[0].Expand(False);
end;

procedure TfrmURepMain.AddFormItems(parentNode: TTreeNode; ChainType: TURepTreeChainType;
                       IdForm, Numm, SearchId: integer; NameForm: string;idDestination, idTypExec : integer);
var
 aNode1, aNode2, aNode3: TTreeNode;
 bFirst : Boolean;
 IdFirstQuery, IdFirstRemoteData : integer;
begin
  aNode1 := TreeView1.Items.AddChild(parentNode, NameForm);
  SetTreeItemProp(aNode1, ttForm, ChainType, IdForm, Numm, SearchId);
  PURepTreeItemData(aNode1.Data)^.IdDestination := idDestination;
  PURepTreeItemData(aNode1.Data)^.IdTypExec := idTypExec;

  with dmURep do
  begin
    // 1.    (qFrm2Qry):    
    bFirst := True; IdFirstQuery := 0; IdFirstRemoteData :=0;
    aNode2 := TreeView1.Items.AddChild(aNode1, cnstFrmGrpSQLName);
    SetTreeItemProp(aNode2, ttGrpSQL, ChainType, 0, 0, SearchId);
    //qFrm2Qry.Filter:='IdForm = '+ IntToStr(IdForm);
    //qFrm2Qry.Filtered := True;
    qFrm2Qry.First;
    qFrm2Qry.Locate(fldIdForm, IdForm, []);
    while not qFrm2Qry.EOF do
    begin
      If qFrm2QryIdForm.Value<>IdForm then Break;
      if bFirst then
      begin
        IdFirstQuery      := qFrm2QryIdQuery.Value;
        IdFirstRemoteData := qFrm2QryIdRemoteData.Value;
        bFirst := False;
      end;
      aNode3 := TreeView1.Items.AddChild(aNode2, qFrm2QryName.Value);

      if (not qFrm2QryIdQuery.IsNull) then // SQL query
      begin
        SetTreeItemProp(aNode3, ttSQL, ChainType,
                        qFrm2QryIdQuery.Value, qFrm2QryNumm.Value, SearchId);
        if qFrm2QryIsMaster.Value>0 then // Master - red SQL
        begin
          aNode3.ImageIndex := 28;
          aNode3.SelectedIndex := 28;
        end;
      end
      else if (not qFrm2QryIdRemoteData.IsNull) then // Remote Data
      begin
        SetTreeItemProp(aNode3, ttRemoteData, ChainType,
                        qFrm2QryIdRemoteData.Value, qFrm2QryNumm.Value, SearchId);
        {if qFrm2QryIsMaster.Value then // Master - red SQL
        begin
          aNode3.ImageIndex := 28;
          aNode3.SelectedIndex := 28;
        end;}
      end;

      qFrm2Qry.Next;
    end;

    // 2.   (qFrm2Qry - qParams)
    if IdFirstQuery>0 then
      AddQueryParamItems(aNode1, ChainType, IdFirstQuery, SearchId)
    else if IdFirstRemoteData>0 then
      AddRemoteDataParamItems(aNode1, ChainType, IdFirstRemoteData, SearchId);
  end;
end;

procedure TfrmURepMain.AddQueryParamItems(parentNode: TTreeNode; ChainType: TURepTreeChainType;
                       IdQuery, SearchId: integer);
var
 aNode2, aNode3: TTreeNode;
 bFirst : Boolean;
begin
  with dmURep do
    begin
    bFirst := True; aNode2:= nil;
    //qParam.Filter:='IdQuery = '+ IntToStr(IdQuery);
    //qParam.Filtered := True;
    qQueryParam.First;
    qQueryParam.Locate(fldIdQuery, IdQuery, []);
    while not qQueryParam.EOF do
      begin
      If qQueryParamIdQuery.Value <>IdQuery then Break;
      if bFirst then
        begin
        aNode2 := TreeView1.Items.AddChild(parentNode, cnstParametrs);
        SetTreeItemProp(aNode2, ttGrpParam, ChainType, IdQuery, 0, SearchId);
        bFirst := False;
        end;
      aNode3 := TreeView1.Items.AddChild(aNode2, qQueryParamParLabel.Value);
      SetTreeItemProp(aNode3, ttParam, ChainType, qQueryParamId.Value, qQueryParamNumm.Value, SearchId);
      qQueryParam.Next;
      end;
    end;
end;


procedure TfrmURepMain.AddRemoteDataParamItems(parentNode: TTreeNode; ChainType: TURepTreeChainType;
                       IdRemoteData, SearchId: integer);
var
 aNode2, aNode3: TTreeNode;
 bFirst : Boolean;
begin
  with dmURep do
    begin
    bFirst := True; aNode2:= nil;
    qRemoteDataParam.First;
    qRemoteDataParam.Locate(fldIdRemoteData, IdRemoteData, []);
    while not qRemoteDataParam.EOF do
      begin
      If qRemoteDataParamIdRemoteData.Value <>IdRemoteData then Break;
      if bFirst then
        begin
        aNode2 := TreeView1.Items.AddChild(parentNode, cnstParametrs);
        SetTreeItemProp(aNode2, ttGrpParam, ChainType, IdRemoteData, 0, SearchId);
        bFirst := False;
        end;
      aNode3 := TreeView1.Items.AddChild(aNode2, qRemoteDataParamParLabel.Value);
      SetTreeItemProp(aNode3, ttParam, ChainType, qRemoteDataParamId.Value,
                      qRemoteDataParamNumm.Value, SearchId);
      qRemoteDataParam.Next;
      end;
    end;
end;


procedure TfrmURepMain.PopupMenu1Popup(Sender: TObject);
var
  i : integer;
begin
  // set visible actions
  for i:=0 to PopupMenu1.Items.Count-1 do
    PopupMenu1.Items[i].Visible :=
      PopupMenu1.Items[i].Enabled;
end;

procedure TfrmURepMain.actnRefreshExecute(Sender: TObject);
begin
  RefreshTree(True);
end;

procedure TfrmURepMain.TreeView1Editing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
var
  TreeItemData : TURepTreeItemData;
begin
  AllowEdit := False;
  if not URepIsAdmin then Exit;
  TreeItemData := PURepTreeItemData(Node.Data)^;
  if ((TreeItemData.ChainType=tcGrpForm) and (TreeItemData.ItemType=ttGrpForm)) or
     ((TreeItemData.ChainType=tcAllForm) and (TreeItemData.ItemType=ttForm)) or
     ((TreeItemData.ChainType=tcAllSQL) and (TreeItemData.ItemType=ttSQL)) or
     ((TreeItemData.ChainType=tcAllSQL) and (TreeItemData.ItemType=ttParam)) or
     ((TreeItemData.ChainType=tcAllScript) and (TreeItemData.ItemType=ttScript)) or
     ((TreeItemData.ChainType=tcAllRemoteData) and (TreeItemData.ItemType=ttRemoteData)) then
    AllowEdit := True;
end;

procedure TfrmURepMain.TreeView1Edited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
 TreeItemData : TURepTreeItemData;
 sTblName, sFldName, sSQL : string;
begin
 //if not Confirmation(' ?') then
 //  begin
 //  s:= Node.Text;
 //  Exit;
 //  end;
 sTblName:='';
 TreeItemData := PURepTreeItemData(Node.Data)^;
 if (TreeItemData.ChainType=tcGrpForm) and (TreeItemData.ItemType=ttGrpForm) then
   begin; sTblName:='URepGroup'; sFldName := 'GrpName'; end
 else if (TreeItemData.ChainType=tcAllForm) and (TreeItemData.ItemType=ttForm) then
   begin; sTblName:='URepForm';  sFldName := 'Name'; end
 else if (TreeItemData.ChainType=tcAllSQL) and (TreeItemData.ItemType=ttSQL) then
   begin; sTblName:='URepQuery'; sFldName := 'Name'; end
 else if (TreeItemData.ChainType=tcAllSQL) and (TreeItemData.ItemType=ttParam) then
   begin; sTblName:='URepParam'; sFldName := 'ParLabel'; end
 else if (TreeItemData.ChainType=tcAllScript) and (TreeItemData.ItemType=ttScript) then
   begin; sTblName:='URepScript'; sFldName := 'Name'; end
 else if (TreeItemData.ChainType=tcAllRemoteData) and (TreeItemData.ItemType=ttRemoteData) then
   begin; sTblName:='URepRemoteData'; sFldName := 'Name'; end;
 if sTblName<>'' then
   begin
   sSQL := 'update '+sTblName+' set '+ sFldName+ '='''+
           S+ ''' where Id='+IntToStr(TreeItemData.Id);
   DoSQL(sSQL);
   end;
end;

procedure TfrmURepMain.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  TreeItemData : TURepTreeItemData;
begin
  actnNewGrpFrm.Enabled := False;
  actnEditGrpFrm.Enabled:= False;
  actnDelGrpFrm.Enabled := False;
  actnNewFrm.Enabled    := False;
  actnEditFrm.Enabled   := False;
  actnDelFrm.Enabled    := False;
  actnNewSQL.Enabled    := False;
  actnEditSQL.Enabled   := False;
  actnDelSQL.Enabled    := False;
  actnNewParam.Enabled  := False;
  actnEditParam.Enabled := False;
  actnDelParam.Enabled  := False;
  actnNewScript.Enabled := False;
  actnEditScript.Enabled:= False;
  actnDelScript.Enabled := False;
  actnNewRemoteData.Enabled := False;
  actnEditRemoteData.Enabled:= False;
  actnDelRemoteData.Enabled := False;
  actnEdtRepFrm.Enabled := False;
  actnUsersList.Enabled := False;
  actnExec.Enabled      := True;
  actnExecAsTbl.Enabled := True;

  TreeItemData := PURepTreeItemData(Node.Data)^;
  case TreeItemData.ChainType of
    tcGrpForm:
      begin
      case TreeItemData.ItemType of
        ttGrpForm:
          begin
          actnNewGrpFrm.Enabled := True;
          actnEditGrpFrm.Enabled:= True;
          actnDelGrpFrm.Enabled := True;
          actnNewFrm.Enabled    := True;
          actnUsersList.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttForm:
          begin
          actnEditGrpFrm.Enabled:= True;
          actnNewFrm.Enabled    := True;
          actnEditFrm.Enabled   := True;
          actnDelFrm.Enabled    := True;
          actnNewSQL.Enabled    := True;
          actnNewParam.Enabled  := True;
          actnExec.Enabled      := True;
          actnExecAsTbl.Enabled := True;
          actnEdtRepFrm.Enabled := True;
          actnUsersList.Enabled := True;
          end;
        ttGrpSQL:
          begin
          actnEditFrm.Enabled   := True;
          actnNewSQL.Enabled    := True;
          actnNewParam.Enabled  := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttSQL:
          begin
          actnEditFrm.Enabled   := True;
          actnNewSQL.Enabled    := True;
          actnEditSQL.Enabled   := True;
          end;
        ttRemoteData:
          begin
          actnEditFrm.Enabled   := True;
          actnNewRemoteData.Enabled := True;
          actnEditRemoteData.Enabled:= True;
          end;
        ttGrpParam:
          begin
          actnNewParam.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttParam:
          begin
          actnNewParam.Enabled := True;
          actnEditParam.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttScript:
          begin
          actnEditGrpFrm.Enabled:= True;
          actnEditScript.Enabled:= True;
          actnDelScript.Enabled := True;
          actnExec.Enabled      := True;
          actnExecAsTbl.Enabled := False;
          actnUsersList.Enabled := True;
          end;
        else
          begin
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        end;
      end;
    tcAllForm:
      begin
      actnUsersList.Enabled := True;
      case TreeItemData.ItemType of
        ttGrpForm:
          begin
          actnNewGrpFrm.Enabled := True;
          actnNewFrm.Enabled    := True;
          actnEditFrm.Enabled    := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttForm:
          begin
          actnNewGrpFrm.Enabled := True;
          actnNewFrm.Enabled    := True;
          actnEditFrm.Enabled   := True;
          actnDelFrm.Enabled    := True;
          actnNewSQL.Enabled    := True;
          actnNewParam.Enabled  := True;
          actnExec.Enabled      := True;
          actnExecAsTbl.Enabled := True;
          actnEdtRepFrm.Enabled := True;
          end;
        ttGrpSQL:
          begin
          actnEditFrm.Enabled   := True;
          actnNewSQL.Enabled    := True;
          actnNewParam.Enabled  := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttSQL:
          begin
          actnEditFrm.Enabled   := True;
          actnNewSQL.Enabled    := True;
          actnEditSQL.Enabled   := True;
          actnExecAsTbl.Enabled := True;
          end;
        ttRemoteData:
          begin
          actnEditFrm.Enabled   := True;
          actnNewRemoteData.Enabled    := True;
          actnEditRemoteData.Enabled   := True;
          actnExecAsTbl.Enabled := True;
          end;
        ttGrpParam:
          begin
          actnNewParam.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttParam:
          begin
          actnNewParam.Enabled := True;
          actnEditParam.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        else
          begin
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        end;
      end;
    tcAllSQL:
      begin
      actnUsersList.Enabled := True;
      case TreeItemData.ItemType of
        ttGrpSQL:
          begin
          actnNewGrpFrm.Enabled := True;
          actnNewSQL.Enabled    := True;
          actnEditSQL.Enabled   := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttSQL:
          begin
          actnNewFrm.Enabled    := True;
          actnNewSQL.Enabled    := True;
          actnEditSQL.Enabled   := True;
          actnDelSQL.Enabled    := True;
          actnNewParam.Enabled  := True;
          actnEditParam.Enabled := True;
          actnExec.Enabled      := True;
          actnExecAsTbl.Enabled := True;
          end;
        ttGrpParam:
          begin
          actnNewParam.Enabled  := True;
          actnEditParam.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttParam:
          begin
          actnNewParam.Enabled  := True;
          actnEditParam.Enabled := True;
          actnDelParam.Enabled  := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        end;
      end;
    tcAllRemoteData:
      begin
      actnUsersList.Enabled := True;
      case TreeItemData.ItemType of
        ttGrpRemoteData:
          begin
          actnNewGrpFrm.Enabled := True;
          actnNewRemoteData.Enabled    := True;
          actnEditRemoteData.Enabled   := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttRemoteData:
          begin
          actnNewFrm.Enabled    := True;
          actnNewRemoteData.Enabled    := True;
          actnEditRemoteData.Enabled   := True;
          actnDelRemoteData.Enabled    := True;
          actnNewParam.Enabled  := True;
          actnEditParam.Enabled := True;
          actnExec.Enabled      := True;
          actnExecAsTbl.Enabled := True;
          end;
        ttGrpParam:
          begin
          actnNewParam.Enabled  := True;
          actnEditParam.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttParam:
          begin
          actnNewParam.Enabled  := True;
          actnEditParam.Enabled := True;
          actnDelParam.Enabled  := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        end;
      end;
    tcAllScript:
      begin
      actnUsersList.Enabled := True;
      case TreeItemData.ItemType of
        ttGrpScript:
          begin
          actnNewScript.Enabled  := True;
          actnEditScript.Enabled := True;
          actnExec.Enabled      := False;
          actnExecAsTbl.Enabled := False;
          end;
        ttScript:
          begin
          actnNewGrpFrm.Enabled  := True;
          actnNewScript.Enabled  := True;
          actnEditScript.Enabled := True;
          actnDelScript.Enabled  := True;
          actnExecAsTbl.Enabled := False;
          end;
        end;
      end;
    end;

  if not URepIsAdmin then
    begin
    actnNewGrpFrm.Enabled := False;
    actnEditGrpFrm.Enabled:= False;
    actnDelGrpFrm.Enabled := False;
    actnNewFrm.Enabled    := False;
    actnEditFrm.Enabled   := False;
    actnDelFrm.Enabled    := False;
    actnNewSQL.Enabled    := False;
    actnEditSQL.Enabled   := False;
    actnDelSQL.Enabled    := False;
    actnNewParam.Enabled  := False;
    actnEditParam.Enabled := False;
    actnDelParam.Enabled  := False;
    actnNewScript.Enabled := False;
    actnEditScript.Enabled:= False;
    actnDelScript.Enabled := False;
    actnEdtRepFrm.Enabled := False;
    actnUsersList.Enabled := False;
    end;
end;

function CheckGroupForm(IdGroup, IdForm: integer) : Boolean;
begin
  result := False;
  if DLookup('select count(*) from URepGrpBody where IdGroup='+IntToStr(IdGroup)+
             ' and IdForm='+IntToStr(IdForm))>0 then
    begin
    ErrorMsg('     !');
    result := True;
    end;
end;

function CheckGroupScript(IdGroup, IdScript: integer) : Boolean;
begin
  result := False;
  if DLookup('select count(*) from URepGrpBody where IdGroup='+IntToStr(IdGroup)+
                ' and IdScript='+IntToStr(IdScript))>0 then
    begin
    ErrorMsg('()     !');
    result := True;
    end;
end;


//----------------- GrpForm ----------------------------------------------//
procedure TfrmURepMain.actnNewGrpFrmExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 idNewGrp, idForm, iNumm: integer;
 aNode: TTreeNode;
 result : Boolean;
 frm : TForm;
 cmb : TRxDBLookupCombo;
 sFrmName : string;
 defGrpName: string;
begin
 defGrpName := cnstDefGrpName;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;

 if ((TreeItemData.ChainType = tcAllForm) and
     (TreeItemData.ItemType = ttForm)) or
    ((TreeItemData.ChainType = tcAllScript) and
     (TreeItemData.ItemType = ttScript)) then
    begin
    sFrmName := TreeView1.Selected.Text;
    idForm := TreeItemData.Id;
    iNumm  := TreeItemData.Numm;
    frm := TForm.Create(Application);
    with frm do
      begin
      if TreeItemData.ItemType = ttForm then
        Caption := '   ';
      if TreeItemData.ItemType = ttScript then
        Caption := ' ()  ';
      BorderStyle := bsSizeable;
      Width := 300;
      Height := 100;
      Position := poScreenCenter;
      end;
    with TLabel.Create(frm) do
      begin
      Parent := frm;
      Caption := ' ';
      Top := 8;
      Left := 20;
      end;
    cmb := TRxDBLookupCombo.Create(frm);
    with cmb do
      begin
      Parent := frm;
      Top := 4;
      Left := 120;
      Anchors := [akLeft, akRight];
      LookupSource := dmURep.dsGroup;
      LookupField := fldId;
      LookupDisplay := fldGrpName;
      EscapeClear := False;
      dmURep.qGroup.First;
      Value := dmURep.qGroupId.AsString;
      end;
    with TBitBtn.Create(frm) do //OK
      begin
      Parent := frm;
      Top := 40;
      Left := 65;
      Kind := bkOK;
      end;
    with TBitBtn.Create(frm) do //Cancel
      begin
      Parent := frm;
      Top := 40;
      Left := 155;
      Kind := bkCancel;
      end;
    result := (frm.ShowModal=mrOK);
    idNewGrp := StrToIntDef(cmb.Value, 0);
    frm.Release;
    if result then
      begin
      if TreeItemData.ItemType = ttForm then
        begin
        if CheckGroupForm(idNewGrp, idForm) then Exit;
        DoSQL('insert into URepGrpBody (IdGroup, IdForm, Numm)'+
              'values ('+IntToStr(idNewGrp)+', '+IntToStr(idForm)+', '+IntToStr(iNumm)+')');
        PostMessage(Self.Handle,WM_UREPGrpChange,0,0);
        RefreshTree(True);
        TreeItemData.ChainType :=tcGrpForm;
        TreeItemData.ItemType  := ttForm;
        TreeItemData.Id := IdForm;
        FindNode(TreeItemData, sFrmName);
        end;
      if TreeItemData.ItemType = ttScript then
        begin
        if CheckGroupScript(idNewGrp, idForm) then Exit;
        DoSQL('insert into URepGrpBody (IdGroup, IdScript, Numm)'+
              'values ('+IntToStr(idNewGrp)+', '+IntToStr(idForm)+', '+IntToStr(iNumm)+')');
        PostMessage(Self.Handle,WM_UREPGrpChange,0,0);
        RefreshTree(True);
        TreeItemData.ChainType :=tcGrpForm;
        TreeItemData.ItemType  := ttScript;
        TreeItemData.Id := IdForm;
        FindNode(TreeItemData, sFrmName);
        end;
      end;
    end
 else
   begin
   if not Confirmation('  ?') then Exit;
   defGrpName := GetDefaultName('URepGroup', defGrpName, 'GrpName');
   idNewGrp := URepGroupAdd(defGrpName);
   ReQueryOne(dmURep.qGroup);
   dmURep.qGroup.Locate(fldId, idNewGrp, []);
   PostMessage(Self.Handle,WM_UREPGrpChange,0,0);
   aNode := TreeView1.Items.AddFirst(nil, defGrpName);
   SetTreeItemProp(aNode, ttGrpForm, tcGrpForm, idNewGrp, dmURep.qGroupNumm.Value, idNewGrp);
   TreeView1.Selected := aNode;
   TreeView1.Selected.EditText;
   end;
end;

procedure TfrmURepMain.actnEditGrpFrmExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 IdGroup, IdForm, IdScript : integer;
 frmURepGrpFrm : TfrmURepGrpFrm;
begin
  IdGroup:=0; IdForm:=0; IdScript:=0;
  TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
  if TreeItemData.ChainType = tcGrpForm then
   begin
   if TreeItemData.ItemType=ttGrpForm then
     begin
     IdGroup := TreeItemData.Id;
     end;
   if TreeItemData.ItemType=ttForm then
     begin
     IdGroup := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
     IdForm := TreeItemData.Id;
     end;
   if TreeItemData.ItemType=ttScript then
     begin
     IdGroup := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
     IdScript := TreeItemData.Id;
     end;
   end;
  if TreeItemData.ChainType = tcAllForm then
   begin
   if TreeItemData.ItemType=ttForm then
     begin
     IdForm := TreeItemData.Id;
     end;
   end;

  frmURepGrpFrm := GetOneFormExt(TfrmURepGrpFrm, Self) as TfrmURepGrpFrm;
  frmURepGrpFrm.FindGrpFrm(IdGroup, IdForm, IdScript);
end;

procedure TfrmURepMain.actnDelGrpFrmExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 aNode: TTreeNode;
 sGrpName : string;
begin
  TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
  aNode := TreeView1.Selected.GetPrevSibling;
  if aNode=nil then
    aNode := TreeView1.Selected.Parent;
  if DelObjWithDependList(TreeItemData.Id, otGroup, TreeView1.Selected.Text) then
  begin
    //ReQueryOne(dmURep.qGroup);
    if aNode<>nil then
    begin
      TreeItemData := PURepTreeItemData(aNode.Data)^;
      sGrpName := aNode.Text;
    end;
    RefreshTree(False);
    if aNode<>nil then
      FindNode(TreeItemData, sGrpName);
  end;
end;

//----------------- Form ------------------------------------------------//
procedure TfrmURepMain.actnNewFrmExecute(Sender: TObject);
const
  URepFrm2QryNameStr : array [0..1] of string =  ('', ' ');
  URepFrm2QryTableStr : array [0..1] of string = ('URepQuery', 'URepRemoteData');
  URepFrm2QryFieldStr : array [0..1] of string = ('IdQuery', 'IdRemoteData');
var
 TreeItemData : TURepTreeItemData;
 aParentNode, aNode, aNodeSQLGrp: TTreeNode;
 idNewFrm, IdGrpForm,  IdForm, IdQuery, iNumm, iTyp : integer;
 sIdForm, sFrmName, defNewFrmName : string;
 result : Boolean;
 frm : TForm;
 cmb : TRxDBLookupCombo;
 frmURepGrpFrm : TfrmURepGrpFrm;
begin
 defNewFrmName := cnstDefFrmName;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;

 if TreeItemData.ChainType = tcAllForm then
   begin
   if not Confirmation('  ?') then Exit;
   aParentNode := TreeView1.Selected;
   if PURepTreeItemData(aParentNode.Data)^.ItemType=ttForm then
     aParentNode := aParentNode.Parent;
   defNewFrmName := GetDefaultName('URepForm',defNewFrmName);
   idNewFrm := URepFormAdd(defNewFrmName, 0);
   ReQueryOne(dmURep.qForm);
   dmURep.qForm.Locate('Id', idNewFrm, []);
   aNode := TreeView1.Items.AddChild(aParentNode, defNewFrmName);
   SetTreeItemProp(aNode, ttForm, tcAllForm, idNewFrm, dmURep.qFormNumm.Value, idNewFrm);
   //  
   aNodeSQLGrp := TreeView1.Items.AddChild(aNode, cnstFrmGrpSQLName);
   SetTreeItemProp(aNodeSQLGrp, ttGrpSQL, tcAllForm, 0, 0, idNewFrm);

   TreeView1.Selected := aNode;
   TreeView1.Selected.EditText;
   end;

 if TreeItemData.ChainType = tcGrpForm then
   begin
   IdGrpForm:=0;  IdForm:=0;
   if TreeItemData.ItemType=ttGrpForm then
     begin
     IdGrpForm := TreeItemData.Id;
     IdForm := 0;
     end;
   frmURepGrpFrm := GetOneFormExt(TfrmURepGrpFrm, Self) as TfrmURepGrpFrm;
   frmURepGrpFrm.FindGrpFrm(IdGrpForm,  IdForm, 0);
   end;

 if ((TreeItemData.ChainType = tcAllSQL) and
     (TreeItemData.ItemType = ttSQL)) or
    ((TreeItemData.ChainType = tcAllRemoteData) and
     (TreeItemData.ItemType = ttRemoteData)) then
    begin
    iTyp:=0;
    if TreeItemData.ItemType = ttRemoteData then iTyp:=1;
    IdQuery := TreeItemData.Id;
    frm := TForm.Create(Application);
    with frm do
      begin
      Caption := ' '+URepFrm2QryNameStr[iTyp]+'   (  )';
      BorderStyle := bsSizeable;
      Width := 420;
      Height := 100;
      Position := poScreenCenter;
      end;
    with TLabel.Create(frm) do
      begin
      Parent := frm;
      Caption := '';
      Top := 8;
      Left := 10;
      end;
    cmb := TRxDBLookupCombo.Create(frm);
    with cmb do
      begin
      Parent := frm;
      Top := 4;
      Left := 60;
      Width := 340;
      LookupSource := dmURep.dsForm;
      LookupField := 'Id';
      LookupDisplay := 'Name';
      DisplayEmpty := '< >';
      end;
    with TBitBtn.Create(frm) do //OK
      begin
      Parent := frm;
      Top := 40;
      Left := 125;
      Kind := bkOK;
      end;
    with TBitBtn.Create(frm) do //Cancel
      begin
      Parent := frm;
      Top := 40;
      Left := 215;
      Kind := bkCancel;
      end;
    result := (frm.ShowModal=mrOK);
    sIdForm := cmb.Value;
    sFrmName := cmb.DisplayValue;
    IdForm := StrToIntDef(sIdForm, 0);
    frm.Release;
    if result then
      begin
      if IdForm=0 then
        begin
        sFrmName := Dlookup('select Name from '+URepFrm2QryTableStr[iTyp]+' where Id='+IntToStr(IdQuery));
        sFrmName := GetDefaultName('URepForm', sFrmName);
        IdForm := URepFormAdd(sFrmName, IdQuery);
        end
      else
        begin
        iNumm := URepFrm2QryNumm(IdForm);
        DoSQL('insert into URepFrm2Qry (IdForm, Numm, '+URepFrm2QryFieldStr[iTyp]+', QueryShortName, IsMaster) '+
              'values('+sIdForm+','+IntToStr(iNumm)+','+IntToStr(IdQuery)+','#39'Query'+IntToStr(iNumm)+#39', 0)' );
        end;
      RefreshTree(True);
      TreeItemData.ChainType :=tcAllForm;
      TreeItemData.ItemType  := ttForm;
      TreeItemData.Id := IdForm;
      FindNode(TreeItemData, sFrmName);
      end;
    end;
end;

procedure TfrmURepMain.actnEditFrmExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 IdForm, IdQuery, IdRemoteData : integer;
 frmURepForm : TfrmURepForm;
begin
 IdForm:=0;  IdQuery:=0; IdRemoteData:=0;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if TreeItemData.ChainType in [tcGrpForm, tcAllForm] then
   begin
   if TreeItemData.ItemType=ttForm then
     begin
     IdForm := TreeItemData.Id;
     end;
   if TreeItemData.ItemType=ttGrpSQL then
     begin
     IdForm := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
     end;
   if TreeItemData.ItemType=ttSQL then
     begin
     IdForm := PURepTreeItemData(TreeView1.Selected.Parent.Parent.Data)^.Id;
     IdQuery := TreeItemData.Id;
     end;
   if TreeItemData.ItemType=ttRemoteData then
     begin
     IdForm := PURepTreeItemData(TreeView1.Selected.Parent.Parent.Data)^.Id;
     IdRemoteData := TreeItemData.Id;
     end;
   end;
 frmURepForm := GetOneFormExt(TfrmURepForm, Self) as TfrmURepForm;
 frmURepForm.FindForm(IdForm, IdQuery, IdRemoteData);
end;

procedure TfrmURepMain.actnDelFrmExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 aNode: TTreeNode;
 IdGrpForm,  IdForm : integer;
 sFrmName: string;
begin
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if TreeItemData.ChainType = tcAllForm then
   begin
   aNode := TreeView1.Selected.GetPrevSibling;
   if aNode=nil then
     aNode := TreeView1.Selected.GetPrevVisible;
   if aNode=nil then
     aNode :=TreeView1.Selected.Parent;

   if DelObjWithDependList(TreeItemData.Id, otForm, TreeView1.Selected.Text) then
    begin
     if aNode<>nil then
       begin
       TreeItemData := PURepTreeItemData(aNode.Data)^;
       sFrmName := aNode.Text;
       end;
     RefreshTree(False);
     if aNode<>nil then
       FindNode(TreeItemData, sFrmName);
    end;
   end;
 if TreeItemData.ChainType = tcGrpForm then
   begin
   IdGrpForm:=0;  IdForm:=0;
   if TreeItemData.ItemType=ttForm then
     begin
     IdForm := TreeItemData.Id;
     IdGrpForm := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
     end;
   if not Confirmation('   ?') then Exit;
   DoSQL('delete from URepGrpBody where IdGroup='+
         IntToStr(IdGrpForm)+ ' and IdForm='+IntToStr(IdForm));
   PostMessage(Self.Handle,WM_UREPGrpChange,0,0);
   aNode := TreeView1.Selected.Parent;
   Dispose( TreeView1.Selected.Data);
   TreeView1.Selected.Delete;
   if aNode<>nil then
     TreeView1.Selected := aNode;
   end;
end;

//----------------- SQL ------------------------------------------------//
procedure TfrmURepMain.actnNewSQLExecute(Sender: TObject);
var
 idForm, idNewQuery : integer;
 aParentNode, aNode: TTreeNode;
 TreeItemData: TURepTreeItemData;
 defNewSQLname: string;
begin
 defNewSQLname := '?????';
 idForm := 0;  aParentNode := nil;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;

 if (TreeItemData.ChainType in [tcGrpForm, tcAllForm]) then
   begin
   if not Confirmation('    ?') then Exit;
   if (TreeItemData.ItemType=ttForm ) then
     begin
     aParentNode := TreeView1.Selected.getFirstChild;
     if aParentNode=nil then aParentNode := TreeView1.Selected;
     idForm := TreeItemData.Id;
     defNewSQLname := TreeView1.Selected.Text;
     end;
   if (TreeItemData.ItemType=ttGrpSQL ) then
     begin
     aParentNode := TreeView1.Selected;
     idForm := PURepTreeItemData(aParentNode.Parent.Data)^.Id;
     defNewSQLname := aParentNode.Parent.Text;
     end;
   if (TreeItemData.ItemType=ttSQL ) then
     begin
     aParentNode :=TreeView1.Selected.Parent;
     idForm := PURepTreeItemData(aParentNode.Parent.Data)^.Id;
     defNewSQLname := aParentNode.Parent.Text;
     end;
   end;

 if (TreeItemData.ChainType=tcAllSQL) then
   begin
   if not Confirmation('  ?') then Exit;
   defNewSQLname := cnstDefSQLName;
   if (TreeItemData.ItemType=ttGrpSQL ) then
     aParentNode := TreeView1.Selected;
   if (TreeItemData.ItemType=ttSQL ) then
     aParentNode :=TreeView1.Selected.Parent;
   end;

 defNewSQLname := GetDefaultName('URepQuery', defNewSQLname);
 idNewQuery := URepQueryAdd(defNewSQLname, idForm);
 ReQueryOne(dmURep.qQuery);
 dmURep.qQuery.Locate(fldId, idNewQuery, []);
 aNode := TreeView1.Items.AddChild(aParentNode, defNewSQLname);
 if idForm=0 then idForm := idNewQuery;
 SetTreeItemProp(aNode, ttSQL, TreeItemData.ChainType, idNewQuery, dmURep.qQueryNumm.Value, idForm);
 TreeView1.Selected := aNode;
 TreeView1.Selected.EditText;
end;

procedure TfrmURepMain.actnEditSQLExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 IdQuery : integer;
 frmURepQuery : TfrmURepQuery;
begin
  IdQuery := 0;
  TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
  if TreeItemData.ItemType=ttSQL then
    IdQuery := TreeItemData.Id;

  frmURepQuery := GetOneFormExt(TfrmURepQuery, Self) as TfrmURepQuery;
  frmURepQuery.FindQuery(IdQuery);
end;

procedure TfrmURepMain.actnDelSQLExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 aNode: TTreeNode;
 sName: string;
begin
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if (TreeItemData.ChainType = tcAllSQL) and
    (TreeItemData.ItemType = ttSQL) then
   begin
   aNode := TreeView1.Selected.GetPrevSibling;
   if aNode=nil then
     aNode := TreeView1.Selected.GetPrevVisible;
   if aNode=nil then
     aNode :=TreeView1.Selected.Parent;
   if DelObjWithDependList(TreeItemData.Id, otSQL, TreeView1.Selected.Text) then
     begin
       if aNode<>nil then
         begin
         TreeItemData := PURepTreeItemData(aNode.Data)^;
         sName := aNode.Text;
         end;
       RefreshTree(False);
       if aNode<>nil then
         FindNode(TreeItemData, sName);
     end;
   end;
end;

function GetDefParamName(IdQuery, IdRemoteData : integer): string;
var
 i: integer;
 _defName, sSQL: string;
begin
 i := 1;
 _defName := cnstDefParamName;

 sSQL := 'select count(*) from URepParam where ParName=''%s'' and ';
 if IdRemoteData=0 then sSQL:=sSQL + fldIdQuery+'='+IntToStr(IdQuery)
 else if IdQuery=0 then sSQL:=sSQL + fldIdRemoteData+'='+IntToStr(IdRemoteData);


 while DLookup(Format(sSQL,[_defName]))>0 do
   begin
   _defName := cnstDefParamName +Trim(IntToStr(i));
   Inc(i);
   end;
 result := _defName;
end;


procedure TfrmURepMain.actnNewParamExecute(Sender: TObject);
var
 IdForm, IdParam, IdQuery, IdRemoteData: integer;
 TreeItemData: TURepTreeItemData;
 NewParamName: String;
begin
 IdQuery:=0;  IdRemoteData:=0;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;

 if (TreeItemData.ChainType in [tcGrpForm, tcAllForm]) then
   begin
   IdForm := 0;
   if not Confirmation('    ?') then Exit;
   if (TreeItemData.ItemType =ttForm ) then
     begin
     IdForm := TreeItemData.Id
     end;
   if (TreeItemData.ItemType=ttGrpParam ) then
     begin
     IdForm := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
     end;
   if (TreeItemData.ItemType=ttParam ) then
     begin
     IdForm := PURepTreeItemData(TreeView1.Selected.Parent.Parent.Data)^.Id;
     end;
   URepFormMainObjectID(IdForm, IdQuery, IdRemoteData);
   end
 else
   begin
   if not Confirmation('  ?') then Exit;
   if (TreeItemData.ChainType=tcAllSQL) then
     begin
     if (TreeItemData.ItemType=ttSQL ) then
       begin
       IdQuery := TreeItemData.Id;
       end;
     if (TreeItemData.ItemType=ttGrpParam ) then
       begin
       IdQuery := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
       end;
     if (TreeItemData.ItemType=ttParam ) then
       begin
       IdQuery := PURepTreeItemData(TreeView1.Selected.Parent.Parent.Data)^.Id;
       end;
     end;

   if (TreeItemData.ChainType=tcAllRemoteData) then
     begin
     if (TreeItemData.ItemType=ttRemoteData ) then
       begin
       IdRemoteData := TreeItemData.Id;
       end;
     if (TreeItemData.ItemType=ttGrpParam ) then
       begin
       IdRemoteData := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
       end;
     if (TreeItemData.ItemType=ttParam ) then
       begin
       IdRemoteData := PURepTreeItemData(TreeView1.Selected.Parent.Parent.Data)^.Id;
       end;
     end;
   end;
   
 NewParamName := GetDefParamName(IdQuery, IdRemoteData);
 IdParam := URepParamAdd(NewParamName, IdQuery, IdRemoteData);

 RefreshTree(True);
 TreeItemData.ItemType  := ttParam;
 TreeItemData.Id := IdParam;
 FindNode(TreeItemData, NewParamName);

end;

procedure TfrmURepMain.actnEditParamExecute(Sender: TObject);
var
 TreeItemData, masterTreeItemData: TURepTreeItemData;
 IdQuery, IdParam : integer;
 frmURepParam : TfrmURepParam;
 paramConnectType: TURepParamConnectType;
begin
  IdQuery := 0; IdParam := 0; paramConnectType := paramQuery;
  TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
  if TreeItemData.ItemType=ttSQL then
    begin
    IdQuery := TreeItemData.Id;
    end;
  if TreeItemData.ItemType=ttRemoteData then
    begin
    IdQuery := TreeItemData.Id;
    paramConnectType := paramRemoteData;
    end;
  if TreeItemData.ItemType=ttGrpParam then
    begin
    masterTreeItemData := PURepTreeItemData(TreeView1.Selected.Parent.Data)^;
    IdQuery := masterTreeItemData.Id;
    if masterTreeItemData.ItemType=ttRemoteData then
      paramConnectType := paramRemoteData;
    end;
  if TreeItemData.ItemType=ttParam then
    begin
    IdParam := TreeItemData.Id;
    if TreeItemData.ChainType in [tcGrpForm, tcAllForm] then
      masterTreeItemData :=
        PURepTreeItemData(TreeView1.Selected.Parent.Parent.GetFirstChild.GetFirstChild.Data)^
    else  //tcAllSQL, tcAllRemoteData
      masterTreeItemData :=
        PURepTreeItemData(TreeView1.Selected.Parent.Parent.Data)^;
    IdQuery := masterTreeItemData.Id;

    if masterTreeItemData.ItemType=ttRemoteData then
      paramConnectType := paramRemoteData;
    end;
  frmURepParam := FindForm(TfrmURepParam) as TfrmURepParam;
  if frmURepParam=nil then
    frmURepParam := TfrmURepParam.Create(Self, paramConnectType, IdQuery, IdParam)
  else
    frmURepParam.FindParam(paramConnectType, IdQuery, IdParam);
  frmURepParam.Show;
end;

procedure TfrmURepMain.actnDelParamExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 aNode: TTreeNode;
begin
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if ( (TreeItemData.ChainType=tcAllSQL) or
      (TreeItemData.ChainType=tcAllRemoteData) ) and
    (TreeItemData.ItemType=ttParam) then
   begin
   if not Confirmation(' ?') then Exit;
   aNode := TreeView1.Selected.Parent;
   URepParamDelete(TreeItemData.Id);
   Dispose( TreeView1.Selected.Data);
   TreeView1.Selected.Delete;
   if aNode<>nil then
     TreeView1.Selected := aNode;
   end;
end;

procedure TfrmURepMain.TreeView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  aNode: TTreeNode;
begin
  Accept := False;
  if not URepIsAdmin then Exit;
  if (Sender = TreeView1) and
     (Source = TreeView1) then
    begin
    aNode := TreeView1.GetNodeAt(X, Y);
    if (aNode=nil) or
       (TreeView1.Selected=nil) then Exit;
    if((PURepTreeItemData(TreeView1.Selected.Data)^.ChainType=tcAllForm) and
       (PURepTreeItemData(TreeView1.Selected.Data)^.ItemType=ttForm) and
       (PURepTreeItemData(aNode.Data)^.ChainType=tcGrpForm) and
       (PURepTreeItemData(aNode.Data)^.ItemType=ttGrpForm)) then
      Accept := True;
    if((PURepTreeItemData(TreeView1.Selected.Data)^.ChainType=tcAllScript) and
       (PURepTreeItemData(TreeView1.Selected.Data)^.ItemType=ttScript) and
       (PURepTreeItemData(aNode.Data)^.ChainType=tcGrpForm) and
       (PURepTreeItemData(aNode.Data)^.ItemType=ttGrpForm)) then
      Accept := True;
    end;
end;

procedure TfrmURepMain.TreeView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  aNode: TTreeNode;
  id, idParent, numm: integer;
  sSQL : string;
  ItemType: TURepTreeItemType;
begin
  aNode := TreeView1.GetNodeAt(X, Y);
  if (aNode=nil) or
     (TreeView1.Selected=nil) then Exit;
  idParent := PURepTreeItemData(aNode.Data)^.id;
  id := PURepTreeItemData(TreeView1.Selected.Data)^.id;
  numm := PURepTreeItemData(TreeView1.Selected.Data)^.Numm;
  ItemType := PURepTreeItemData(TreeView1.Selected.Data)^.ItemType;
  if ItemType=ttForm then
    begin
    if CheckGroupForm(idParent, id) then Exit;
    sSQL :='insert into URepGrpBody (IdGroup, IdForm, Numm)'+
           'values ('+IntToStr(idParent)+','+IntToStr(id)+', '+IntToStr(numm)+')';
    DoSQL(sSQL);
    end;
  if ItemType=ttScript then
    begin
    if CheckGroupScript(idParent, id) then Exit;
    sSQL :='insert into URepGrpBody (IdGroup, IdScript, Numm)'+
           'values ('+IntToStr(idParent)+','+IntToStr(id)+', '+IntToStr(numm)+')';
    DoSQL(sSQL);
    end;

  RefreshTree(True);
end;

procedure TfrmURepMain.actnUsersListExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 IdTypObj, IdObj : integer;
 frmURepRights : TfrmURepRights;
begin
  IdTypObj :=0;
  TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
  IdObj := TreeItemData.Id;

  if TreeItemData.ChainType=tcGrpForm then
    begin
    if TreeItemData.ItemType=ttGrpForm then
      IdTypObj := 1;
    if TreeItemData.ItemType=ttForm then
      IdTypObj := 2;
    if TreeItemData.ItemType=ttScript then
      IdTypObj := 5;
    end;

  if TreeItemData.ChainType=tcAllForm then
    if TreeItemData.ItemType=ttForm then
      IdTypObj := 2;

  if TreeItemData.ChainType=tcAllScript then
    if TreeItemData.ItemType=ttScript then
      IdTypObj := 5;

  frmURepRights := GetOneFormExt(TfrmURepRights, Self) as TfrmURepRights;
  frmURepRights.FindObject(IdTypObj, IdObj);
end;

procedure TfrmURepMain.actnExecExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 bRet: Boolean;
begin
 If TreeView1.Selected=nil then Exit;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if TreeItemData.ItemType=ttScript then
   begin
   with dmURep do
     begin
     qScriptBody.Close;
     qScriptBody.ParamByName('Id').asInteger := TreeItemData.Id;
     qScriptBody.Open;
     RunScript(qScriptBodyScrEngName.Value, qScriptBodyScriptText.Value,
               TreeItemData.Id, TreeView1.Selected.Text);
     qScriptBody.Close;
     end;
   end
 else if (TreeItemData.ItemType=ttSQL) or
         (TreeItemData.ItemType=ttRemoteData) then
   actnExecAsTblExecute(nil)
 else
   begin
     repeat
       bRet:=URepActionReport(TreeItemData.Id, TreeView1.Selected.Text,
                    TreeItemData.IdDestination, TreeItemData.IdTypExec);
       If not URepGetReRunReport Then bRet:= False;
     until not bRet;

   end;
end;

procedure TfrmURepMain.actnExecAsTblExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 iCallerItemType : integer;
begin
 If TreeView1.Selected=nil then Exit;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 iCallerItemType := Ord(TreeItemData.ItemType);
 URepExtFormAction(TreeItemData.Id, TreeView1.Selected.Text, nil,
                   factViewAsTbl, '', 0, iCallerItemType);
end;

procedure TfrmURepMain.actnEdtRepFrmExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
begin
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 URepEditRepForm(TreeItemData.Id, TreeView1.Selected.Text);
end;

procedure TfrmURepMain.TreeView1TreeItemDblClick(Sender: TObject;
  Node: TTreeNode);
var
 TreeItemData : TURepTreeItemData;
begin
 TreeItemData := PURepTreeItemData(Node.Data)^;
 if TreeItemData.ItemType=ttForm then
    actnExec.Execute;
 if (TreeItemData.ChainType=tcAllSQL) and
    (TreeItemData.ItemType=ttSQL) then
    actnExecAsTbl.Execute;
 if (TreeItemData.ItemType=ttScript) then
    actnExec.Execute;
end;

//=========================================================================
procedure TfrmURepMain.actnNewScriptExecute(Sender: TObject);
var
 idScript: integer;
 aParentNode, aNode: TTreeNode;
 TreeItemData: TURepTreeItemData;
 defNewScriptname: string;
begin
 defNewScriptname := ' ';
 aParentNode := nil;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if (TreeItemData.ChainType=tcAllScript) then
   begin
   if not Confirmation('  ?') then Exit;
   if (TreeItemData.ItemType=ttGrpScript ) then
     aParentNode := TreeView1.Selected;
   if (TreeItemData.ItemType=ttScript ) then
     aParentNode :=TreeView1.Selected.Parent;
   end;

 defNewScriptname := GetDefaultName('URepScript', defNewScriptname);
 idScript := URepScriptAdd(defNewScriptname);
 ReQueryOne(dmURep.qScript);
 dmURep.qScript.Locate('Id', idScript, []);
 aNode := TreeView1.Items.AddChild(aParentNode, defNewScriptname);
 SetTreeItemProp(aNode, ttScript, tcAllScript, idScript, dmURep.qScriptNumm.Value, idScript);
 TreeView1.Selected := aNode;
 TreeView1.Selected.EditText;
end;

procedure TfrmURepMain.actnEditScriptExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 IdScript : integer;
 frmURepScript : TfrmURepScript;
begin
  IdScript := 0;
  TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
  if TreeItemData.ItemType=ttScript then
    IdScript := TreeItemData.Id;
  frmURepScript := GetOneFormExt(TfrmURepScript, Self) as TfrmURepScript;
  frmURepScript.FindScript(IdScript);
end;

procedure TfrmURepMain.actnDelScriptExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 aNode: TTreeNode;
 IdGroup: integer;
begin
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if (TreeItemData.ChainType = tcAllScript) and
    (TreeItemData.ItemType = ttScript) then
   begin
   if not Confirmation(' ?') then Exit;
   aNode := TreeView1.Selected.Parent;
   URepScriptDelete(TreeItemData.Id);
   Dispose( TreeView1.Selected.Data);
   TreeView1.Selected.Delete;
   if aNode<>nil then
     TreeView1.Selected := aNode;
   end;
 if (TreeItemData.ChainType = tcGrpForm) and
    (TreeItemData.ItemType = ttScript) then
   begin
   IdGroup := PURepTreeItemData(TreeView1.Selected.Parent.Data)^.Id;
   if not Confirmation('   ?') then Exit;
   DoSQL('delete from URepGrpBody where IdGroup='+
         IntToStr(IdGroup)+ ' and IdScript='+IntToStr(TreeItemData.Id));
   PostMessage(Self.Handle,WM_UREPGrpChange,0,0);
   aNode := TreeView1.Selected.Parent;
   Dispose( TreeView1.Selected.Data);
   TreeView1.Selected.Delete;
   if aNode<>nil then
     TreeView1.Selected := aNode;
   end;
end;

procedure TfrmURepMain.mnSortClick(Sender: TObject);
begin
 if Sender=mnSortNum then
   begin
   mnSortNum.Checked := True;
   dmURep.FSortOrder := soNumm;
   RefreshTree(True);
   end
 else if Sender=mnSortName then
   begin
   mnSortName.Checked := True;
   dmURep.FSortOrder := soName;
   RefreshTree(True);
   end
 else if Sender=mnSortId then
   begin
   mnSortId.Checked := True;
   dmURep.FSortOrder := soId;
   RefreshTree(True);
   end;
end;


procedure TfrmURepMain.actnNewRemoteDataExecute(Sender: TObject);
var
  TreeItemData: TURepTreeItemData;
  defNewRemoteDataname: string;
  aParentNode, aNode: TTreeNode;
  idNewRemoteData: integer;
begin
 aParentNode := nil;
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if (TreeItemData.ChainType=tcAllRemoteData) then
 begin
   if not Confirmation('   ?') then Exit;
   defNewRemoteDataname := cnstDefRemoteDataName;
   aParentNode :=TreeView1.Selected.Parent;
   if (TreeItemData.ItemType=ttGrpRemoteData ) then
     aParentNode := TreeView1.Selected;
 end;
 defNewRemoteDataname := GetDefaultName('URepRemoteData', defNewRemoteDataname);
 idNewRemoteData := URepRemoteDataAdd(defNewRemoteDataname);
 aNode := TreeView1.Items.AddChild(aParentNode, defNewRemoteDataname);
 ReQueryOne(dmURep.qRemoteData);
 dmURep.qRemoteData.Locate(fldId, idNewRemoteData, []);
 SetTreeItemProp(aNode, ttRemoteData, TreeItemData.ChainType, idNewRemoteData, dmURep.qRemoteDataNumm.Value, idNewRemoteData);
 TreeView1.Selected := aNode;
 TreeView1.Selected.EditText;
end;

procedure TfrmURepMain.actnEditRemoteDataExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 IdRemoteData : integer;
 frmUrepRemoteData: TfrmUrepRemoteData;
begin
  IdRemoteData := 0;
  TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
  if TreeItemData.ItemType=ttRemoteData then
    IdRemoteData := TreeItemData.Id;
  frmURepRemoteData := GetOneFormExt(TfrmURepRemoteData, Self) as TfrmURepRemoteData;
  frmURepRemoteData.FindRemote(IdRemoteData);
end;

procedure TfrmURepMain.actnDelRemoteDataExecute(Sender: TObject);
var
 TreeItemData : TURepTreeItemData;
 aNode: TTreeNode;
 sName: string;
begin
 TreeItemData := PURepTreeItemData(TreeView1.Selected.Data)^;
 if (TreeItemData.ChainType = tcAllRemoteData) and
    (TreeItemData.ItemType = ttRemoteData) then
   begin
   aNode := TreeView1.Selected.GetPrevSibling;
   if aNode=nil then
     aNode := TreeView1.Selected.GetPrevVisible;
   if aNode=nil then
     aNode :=TreeView1.Selected.Parent;
   if DelObjWithDependList(TreeItemData.Id, otRemoteData, TreeView1.Selected.Text) then
     begin
       if aNode<>nil then
         begin
         TreeItemData := PURepTreeItemData(aNode.Data)^;
         sName := aNode.Text;
         end;
       RefreshTree(False);
       if aNode<>nil then
         FindNode(TreeItemData, sName);
     end;
   end;
end;

procedure TfrmURepMain.ToolButton21Click(Sender: TObject);
begin
  ppmunuSort.Popup(TControl(Sender).ClientOrigin.x,
                   TControl(Sender).ClientOrigin.y+TControl(Sender).Height);
end;

end.




