unit fURepParam;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RxLookup, StdCtrls, DBCtrls, ComCtrls, ToolWin, ExtCtrls, RXSplit, Mask,
  Grids, DBGrids, RXDBCtrl, Db, DBTables, Placemnt, UpdQuery, ScrlQuery, DBUtils,
  ActnList, Menus, mwCustomEdit, DBmwEdit, SmartDBmwEdit;

type
  TURepParamConnectType = (paramQuery, paramRemoteData);

  TfrmURepParam = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    LookupComboMaster: TRxDBLookupCombo;
    Panel3: TPanel;
    Panel4: TPanel;
    RxDBGrid1: TRxDBGrid;
    Panel5: TPanel;
    Label9: TLabel;
    EditNUMM: TDBEdit;
    DBEdit1: TDBEdit;
    Label7: TLabel;
    DBEdit2: TDBEdit;
    Label6: TLabel;
    Label5: TLabel;
    DBEdit3: TDBEdit;
    Label8: TLabel;
    DBEdit4: TDBEdit;
    Label3: TLabel;
    DBEdit5: TDBEdit;
    Label4: TLabel;
    DBEdit6: TDBEdit;
    Label10: TLabel;
    RxSplitter1: TRxSplitter;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Label2: TLabel;
    DBNavigator2: TDBNavigator;
    Panel11: TPanel;
    Label12: TLabel;
    qParam: TScrollQuery;
    qParamId: TAutoIncField;
    qParamIdQuery: TIntegerField;
    qParamNumm: TIntegerField;
    qParamParName: TStringField;
    qParamParLabel: TStringField;
    qParamIdParTyp: TIntegerField;
    qParamSQL: TMemoField;
    qParamWidth: TIntegerField;
    qParamLookupField: TStringField;
    qParamLookupDisplay: TStringField;
    qParamLookupDisplayIndex: TIntegerField;
    qParamIdTypDefVal: TIntegerField;
    qParamDefSQL: TMemoField;
    dsMasterSel: TDataSource;
    qMasterSel: TUpdQuery;
    qMasterSelId: TAutoIncField;
    qMasterSelNumm: TIntegerField;
    qMasterSelName: TStringField;
    dsParam: TDataSource;
    qParTyp: TQuery;
    qTypDefVal: TQuery;
    qParamParTyp: TStringField;
    qParamTypDefVal: TStringField;
    Label11: TLabel;
    FormStorage1: TFormStorage;
    RxDBLookupCombo1: TRxDBLookupCombo;
    RxDBLookupCombo2: TRxDBLookupCombo;
    RxSplitter2: TRxSplitter;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ActionList1: TActionList;
    ActionCopyAll: TAction;
    ActionPasteAll: TAction;
    DBNavigator1: TDBNavigator;
    PopupMenu1: TPopupMenu;
    ActionCopy1: TAction;
    ActionCopy11: TMenuItem;
    DBmwEditSQL: TSmartDBmwEdit;
    DBmwEdit1: TSmartDBmwEdit;
    ComboBoxType: TComboBox;
    qParamIdRemoteData: TIntegerField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LookupComboMasterChange(Sender: TObject);
    procedure qParamBeforeOpen(DataSet: TDataSet);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure qParamNewRecord(DataSet: TDataSet);
    procedure qParamBeforePost(DataSet: TDataSet);
    procedure qParamAfterPost(DataSet: TDataSet);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure qParamAfterDelete(DataSet: TDataSet);
    procedure dsParamDataChange(Sender: TObject; Field: TField);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActionCopyAllExecute(Sender: TObject);
    procedure ActionPasteAllExecute(Sender: TObject);
    procedure ActionCopy1Execute(Sender: TObject);
    procedure ComboBoxTypeDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ComboBoxTypeChange(Sender: TObject);
    procedure qMasterSelBeforeOpen(DataSet: TDataSet);
  private
    { Private declarations }
    WasInsert : Boolean;
    FNameChanged: Boolean;
    FSQLParam: String;
  public
    { Public declarations }
    procedure FindParam(parType: TURepParamConnectType; IdMaster, IdParam: integer);
    constructor Create(AOwner: TComponent; parType: TURepParamConnectType;
                       IdMaster, IdParam: integer); reintroduce;
  end;

Var
  FIdQueryCopy: integer;
  FIdParamCopy: integer;

implementation

{$R *.DFM}

uses dmdURep, URepConstants, Common, CommonVV, QueryEx, ConstEx, LayoutEx;

const
  URepParamTableStr : array [0..1] of string =
    ('URepQuery', 'URepRemoteData');

type
  THackCustomGrid = class(TCustomGrid);


constructor TfrmURepParam.Create(AOwner: TComponent; parType: TURepParamConnectType;
                                 IdMaster, IdParam: integer);
begin
  inherited Create(AOwner);
  FindParam(parType, IdMaster, IdParam);
end;

procedure TfrmURepParam.FormCreate(Sender: TObject);
begin
  FSQLParam := qParam.SQL.Text;
  FNameChanged := False;
  (THackCustomGrid(RxDBGrid1)).ScrollBars := ssNone;

  ReQueryAll(Self);
  //LookupComboMaster.Value := qMasterSelId.asString;
  if (FIdQueryCopy>0) or (FIdParamCopy>0) then
    ActionPasteAll.Enabled := True
  else
    ActionPasteAll.Enabled := False;

  //controls layout
  FitControlLeftToParent(DBNavigator2);
  FitControlWidthToRControl(LookupComboMaster, DBNavigator2);

end;

procedure TfrmURepParam.ComboBoxTypeChange(Sender: TObject);
begin
  ReQueryOne(qMasterSel);
  LookupComboMaster.Value:= qMasterSelId.AsString;
end;

procedure TfrmURepParam.qMasterSelBeforeOpen(DataSet: TDataSet);
begin
  qMasterSel.SQL.Text := 'SELECT Id, Numm, Name FROM ' +
                         URepParamTableStr[ComboBoxType.ItemIndex];
  setOrderBy(qMasterSel, cnstOrderBy+URepTreeSortOrderString[dmURep.FSortOrder]);
end;

procedure TfrmURepParam.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepParam.FindParam(parType: TURepParamConnectType; IdMaster, IdParam: integer);
begin
  ComboBoxType.ItemIndex := Ord(parType);
  ReQueryOne(qMasterSel);;
  if IdMaster<>0 then
    begin
    qMasterSel.Locate(fldId, IdMaster, []);
    LookupComboMaster.Value:= qMasterSelId.AsString;
    end;
  if IdParam<>0 then
    qParam.Locate(fldId, IdParam, []);
end;

procedure TfrmURepParam.LookupComboMasterChange(Sender: TObject);
begin
  ReQueryOne(qParam);
{  qParam.Close;
  qParam.Open;
  qParam.FetchAll;
  qParam.First;}
end;

procedure TfrmURepParam.qParamBeforeOpen(DataSet: TDataSet);
var
  sWhere: String ;
begin
  if ComboBoxType.ItemIndex=0 then sWhere :=' WHERE IdQuery='
  else sWhere :=' WHERE IdRemoteData=';
  qParam.SQL.Text := FSQLParam + sWhere + LookupComboMaster.Value;
  setOrderBy(qParam, cnstOrderBy+fldNumm);
end;

procedure TfrmURepParam.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then begin ReQueryOne(qParam); Abort; end;
   if Button=nbInsert then
     begin
     qParam.Append;
     Abort;
     end;
end;

procedure TfrmURepParam.qParamNewRecord(DataSet: TDataSet);
var
  params : TParams;
begin
  qParamIdParTyp.Value := 0;
  qParamIdTypDefVal.Value := 0;

  if ComboBoxType.ItemIndex=0 then
  begin
    qParamIdQuery.Value := StrToIntDef(LookupComboMaster.Value, 0);
    qParamIdRemoteData.Clear;
  end
  else begin
    qParamIdQuery.Clear;
    qParamIdRemoteData.Value := StrToIntDef(LookupComboMaster.Value, 0);
  end;

  params := TParams.Create;
  try
    params.CreateParam(ftInteger, prmPrefix+fldIdQuery, ptInput);
    params.CreateParam(ftInteger, prmPrefix+fldIdRemoteData, ptInput);
    params.CreateParam(ftInteger, prmPrefix+fldNumm, ptOutput);
    params.ParamValues[prmPrefix+fldIdQuery] := qParamIdQuery.Value;
    params.ParamValues[prmPrefix+fldIdRemoteData] := qParamIdRemoteData.Value;
    ExecSP('spURepParamNumm', params);
    qParamNumm.Value := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;
end;

procedure TfrmURepParam.qParamBeforePost(DataSet: TDataSet);
begin
  WasInsert:=(qParam.State=dsInsert);
end;

procedure TfrmURepParam.qParamAfterPost(DataSet: TDataSet);
begin
  if WasInsert then ReQueryOne(qParam);
  if WasInsert or FNameChanged then
    GoMessage(WM_UREPTBLCHANGE);
  FNameChanged := False;
end;

procedure TfrmURepParam.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  LookupComboMaster.Value := qMasterSelId.asString;
end;

procedure TfrmURepParam.qParamAfterDelete(DataSet: TDataSet);
begin
  GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmURepParam.dsParamDataChange(Sender: TObject; Field: TField);
begin
  if Field=nil then Exit;
  if (Field=qParamParLabel) or
     (Field=qParamNumm) then
    FNameChanged := True;
end;

procedure TfrmURepParam.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  ConfirmDataSetCancel(qParam);
end;

procedure TfrmURepParam.ActionCopyAllExecute(Sender: TObject);
begin
  if qParam.RecordCount>0 then
  begin
    FIdParamCopy := 0;
    FIdQueryCopy := StrToIntDef(LookupComboMaster.Value, 0);
    if FIdQueryCopy>0 then
      ActionPasteAll.Enabled := True;
  end;
end;



procedure URepParamsCopy(OldIdQuery, OldIdParam, NewIdQuery: integer);
var
 params : TParams;
begin
 params := TParams.Create;
 try
   params.CreateParam(ftInteger, prmPrefix+'OldIdQuery', ptInput);
   params.CreateParam(ftInteger, prmPrefix+'OldIdParam', ptInput);
   params.CreateParam(ftInteger, prmPrefix+'NewIdQuery', ptInput);
   params.ParamValues[prmPrefix+'OldIdQuery'] := OldIdQuery;
   params.ParamValues[prmPrefix+'OldIdParam'] := OldIdParam;
   params.ParamValues[prmPrefix+'NewIdQuery'] := NewIdQuery;
   ExecSP('spURepParamsCopy', params);
 finally
   params.Free;
 end;
end;


procedure TfrmURepParam.ActionPasteAllExecute(Sender: TObject);
begin
  if not Confirmation(' ?') then Exit;
  try
    URepParamsCopy(FIdQueryCopy, FIdParamCopy, StrToInt(LookupComboMaster.Value))
  finally
    ReQueryOne(qParam);
  end;
  GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmURepParam.ActionCopy1Execute(Sender: TObject);
begin
  if qParam.RecordCount>0 then
  begin
    FIdQueryCopy := 0;
    FIdParamCopy := qParamId.Value;
    if FIdParamCopy>0 then
      ActionPasteAll.Enabled := True;
  end;
end;

procedure TfrmURepParam.ComboBoxTypeDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  aBitmap : TBitmap;
  TxtRect: TRect;
  imgIndex: integer;
begin
  TxtRect := Rect;
  case Index of
     0 : imgIndex := 3;
     1 : imgIndex := 40;
     else imgIndex := -1;
  end;

  aBitmap := TBitmap.Create;
  try
    dmURep.imgLstURep.GetBitmap(imgIndex, aBitmap);
    ComboBoxType.Canvas.FillRect(Rect);
    ComboBoxType.Canvas.Draw(Rect.Left+2,
                          (Rect.Top+Rect.Bottom-aBitmap.Height) div 2,
                          aBitmap);
    TxtRect.Left := Rect.Left+2+aBitmap.Width+2;
    ComboBoxType.Canvas.TextRect(TxtRect, Rect.Left+2+aBitmap.Width+2,
                              Rect.Top, //(Rect.Top+ Rect.Bottom) div 2,
                              ComboBoxType.Items[Index]);
  finally
    aBitmap.Free;
  end;
end;

initialization
  FIdQueryCopy := -1;
  FIdParamCopy := -1;

end.
