unit fURepQry;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, DBCtrls, ComCtrls, ToolWin, Mask, RxLookup, ActnList,
  Db, DBTables, Placemnt, UpdQuery, Grids, DBGrids, RXDBCtrl, fURepFunc1,
  ScrlQuery, DBUtils, mwCustomEdit, DBmwEdit, StrUtils, SmartDBmwEdit;

type
  TfrmURepQuery = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    LookupComboQuery: TRxDBLookupCombo;
    Panel3: TPanel;
    ActionList1: TActionList;
    ActionExec: TAction;
    qQrySel: TUpdQuery;
    qQrySelId: TAutoIncField;
    qQrySelNumm: TIntegerField;
    qQrySelName: TStringField;
    q1Query: TQuery;
    dsQrySel: TDataSource;
    ds1Query: TDataSource;
    q1QueryId: TAutoIncField;
    q1QueryNumm: TIntegerField;
    q1QueryName: TStringField;
    q1QuerySQLtext: TMemoField;
    ActionLoad: TAction;
    ActionSave: TAction;
    ActionEdtParam: TAction;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    DBNavigator1: TDBNavigator;
    ToolButton5: TToolButton;
    FormStorage1: TFormStorage;
    DBNavigator2: TDBNavigator;
    q1QueryDescription: TStringField;
    PageControl1: TPageControl;
    TabSheetSQL: TTabSheet;
    TabSheetForms: TTabSheet;
    RxDBGrid2: TRxDBGrid;
    Panel5: TPanel;
    qQryFrm: TUpdQuery;
    dsQryFrm: TDataSource;
    qQryFrmId: TAutoIncField;
    qQryFrmName: TStringField;
    ActionEdtForm: TAction;
    TabSheetProp: TTabSheet;
    Panel2: TPanel;
    LabelNumm: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    LabelId: TLabel;
    DBEditNumm: TDBEdit;
    DBEditName: TDBEdit;
    DBEditDescr: TDBEdit;
    DBEditId: TDBEdit;
    StatusBarSQL: TStatusBar;
    DBmwEditSQL: TSmartDBmwEdit;
    CoolBar2: TCoolBar;
    ToolBar2: TToolBar;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    DBNavigator4: TDBNavigator;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure q1QueryAfterPost(DataSet: TDataSet);
    procedure q1QueryAfterDelete(DataSet: TDataSet);
    procedure LookupComboQueryChange(Sender: TObject);
    procedure q1QueryBeforeOpen(DataSet: TDataSet);
    procedure ActionLoadExecute(Sender: TObject);
    procedure ActionSaveExecute(Sender: TObject);
    procedure ActionEdtParamExecute(Sender: TObject);
    procedure ActionExecExecute(Sender: TObject);
    procedure q1QueryBeforePost(DataSet: TDataSet);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure q1QueryNewRecord(DataSet: TDataSet);
    procedure qQryFrmBeforeOpen(DataSet: TDataSet);
    procedure ActionEdtFormExecute(Sender: TObject);
    procedure ds1QueryDataChange(Sender: TObject; Field: TField);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DBmwEditSQLLoadData(Sender: TObject);
    procedure DBmwEditSQLStatusChange(Sender: TObject;
      Changes: TmwStatusChanges);
  private
    { Private declarations }
    WasInsert : Boolean;
    FNameChanged: Boolean;
    procedure SQLUpdateInfo;
  public
    { Public declarations }
    procedure FindQuery(IdQuery: integer);
  end;


implementation

{$R *.DFM}

uses Common, CommonVV, QueryEx, LayoutEx, ConstEx, AppUtils,
     dmdURep, fURepParam, URepTypes, fURepFrm, URepConstants;


procedure TfrmURepQuery.FormCreate(Sender: TObject);
begin
  FNameChanged := False;
  ReQueryAll(Self);
  PageControl1.ActivePage := TabSheetSQL;
  LookupComboQuery.Value:= qQrySelId.AsString;

  //controls layout
  FitControlLeftToParent(DBNavigator2);
  FitControlWidthToRControl(LookupComboQuery, DBNavigator2);

  FitControlLeftToParent(DBEditNumm);
  FitControlLeftToRControl(LabelNumm, DBEditNumm);
  FitControlWidthToRControl(DBEditName, LabelNumm);

  FitControlLeftToParent(DBEditID);
  FitControlLeftToRControl(LabelID, DBEditID);
  FitControlWidthToRControl(DBEditDescr, LabelNumm);

end;

procedure TfrmURepQuery.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepQuery.LookupComboQueryChange(Sender: TObject);
begin
  ReQueryOne(q1Query);
  ReQueryOne(qQryFrm);
end;

procedure TfrmURepQuery.q1QueryBeforeOpen(DataSet: TDataSet);
begin
  q1Query.ParamByName(fldId).asInteger := StrToIntDef(LookupComboQuery.Value, 0);
end;

procedure TfrmURepQuery.qQryFrmBeforeOpen(DataSet: TDataSet);
begin
  qQryFrm.ParamByName(fldId).asInteger := StrToIntDef(LookupComboQuery.Value, 0);
end;

procedure TfrmURepQuery.FindQuery(IdQuery: integer);
begin
  if IdQuery<>0 then
    begin
    qQrySel.Locate(fldId, IdQuery, []);
    LookupComboQuery.Value:= qQrySelId.AsString;
    PageControl1.ActivePage := TabSheetSQL;
    end;
end;

procedure TfrmURepQuery.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then begin ReQueryOne(q1Query); Abort; end;
   if Button=nbInsert then
     begin
     q1Query.Append;
     Abort;
     end;
end;

procedure TfrmURepQuery.q1QueryBeforePost(DataSet: TDataSet);
begin
  WasInsert:=(q1Query.State=dsInsert);
end;

procedure TfrmURepQuery.q1QueryAfterPost(DataSet: TDataSet);
var
  maxId : integer;
begin
   ReQueryOne(qQrySel); //!
   if WasInsert then
     begin
     maxId :=DLookup('select max(Id) from URepQuery');
     qQrySel.Locate(fldId, maxId, []);
     end;
   LookupComboQuery.Value:= qQrySelId.AsString;//!
   if WasInsert or FNameChanged then
     GoMessage(WM_UREPTBLCHANGE);
   FNameChanged := False;
end;

procedure TfrmURepQuery.q1QueryAfterDelete(DataSet: TDataSet);
begin
   ReQueryOne(qQrySel); //!
   LookupComboQuery.Value:= qQrySelId.AsString;//!
   GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmURepQuery.ActionLoadExecute(Sender: TObject);
var
  OpenDialog: TOpenDialog;
begin
  OpenDialog:= TOpenDialog.Create(Self);
  OpenDialog.DefaultExt := 'sql';
  OpenDialog.Filter :='SQL script files (*.sql)|*.sql|All files (*.*)|*.*';
  try
    If OpenDialog.Execute then
      DBmwEditSQL.Lines.LoadFromFile(OpenDialog.FileName);
  finally
    OpenDialog.Free;
  end;
end;

procedure TfrmURepQuery.ActionSaveExecute(Sender: TObject);
var
  SaveDialog: TSaveDialog;
begin
  SaveDialog:= TSaveDialog.Create(Self);
  SaveDialog.DefaultExt := 'sql';
  SaveDialog.Filter :='SQL script files (*.sql)|*.sql|All files (*.*)|*.*';
  try
    If SaveDialog.Execute then
      DBmwEditSQL.Lines.SaveToFile(SaveDialog.FileName);
  finally
    SaveDialog.Free;
  end;
end;

procedure TfrmURepQuery.ActionEdtParamExecute(Sender: TObject);
var
  frmURepParam : TfrmURepParam;
begin
  frmURepParam := FindForm(TfrmURepParam) as TfrmURepParam;
  if frmURepParam=nil then
    frmURepParam := TfrmURepParam.Create(Self, paramQuery, qQrySelId.Value, 0)
  else
    frmURepParam.FindParam(paramQuery, qQrySelId.Value, 0);
  frmURepParam.Show;
end;

procedure TfrmURepQuery.ActionExecExecute(Sender: TObject);
begin
  URepExtFormAction(q1QueryId.AsInteger, q1QueryName.AsString, nil,
                    factViewAsTbl, EmptyStr, 0, Ord(ttSQL));
end;

procedure TfrmURepQuery.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  LookupComboQuery.Value := qQrySelId.asString;
end;

procedure TfrmURepQuery.q1QueryNewRecord(DataSet: TDataSet);
var
  params: TParams;
begin
  PageControl1.ActivePage := TabSheetProp;

  params := TParams.Create;
  try
    params.CreateParam(ftInteger, prmPrefix+fldNumm, ptOutput);
    ExecSP('spURepQueryNumm', params);
    q1QueryNumm.Value := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;
end;

procedure TfrmURepQuery.ActionEdtFormExecute(Sender: TObject);
var
  frmURepForm : TfrmURepForm;
begin
  if qQrySel.RecordCount=0 then Exit;
  if qQryFrm.RecordCount=0 then Exit;

  frmURepForm := GetOneFormExt(TfrmURepForm, URepGetMainForm) as TfrmURepForm;
  frmURepForm.FindForm(qQryFrmId.Value, qQrySelId.Value, 0);
end;

procedure TfrmURepQuery.ds1QueryDataChange(Sender: TObject; Field: TField);
begin
  if Field=nil then Exit;
  if (Field=q1QueryName) then
    FNameChanged := True;
end;

procedure TfrmURepQuery.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  ConfirmDataSetCancel(q1Query);
end;

procedure TfrmURepQuery.SQLUpdateInfo;
begin
  if not assigned(StatusBarSQL) then Exit;
  StatusBarSQL.Panels[0].Text :=
    RightStr(IntToStr(DBmwEditSQL.CaretX),4)+':'+
    RightStr(IntToStr(DBmwEditSQL.CaretY),4);

  if DBmwEditSQL.InsertMode Then
    StatusBarSQL.Panels[1].Text := insmodeInsret
  else
    StatusBarSQL.Panels[1].Text := insmodeOverwrite;
end;

procedure TfrmURepQuery.DBmwEditSQLLoadData(Sender: TObject);
begin
  SQLUpdateInfo;
end;

procedure TfrmURepQuery.DBmwEditSQLStatusChange(Sender: TObject;
  Changes: TmwStatusChanges);
begin
  SQLUpdateInfo;
end;

end.
 