unit fURepQryBro;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, ExtCtrls, ActnList, DBCtrls, DBGrids, Grids,
  DB, DBTables, Math, URepTypes, RXSplit, RXDBCtrl, GridEx, AskMe;

type
  TfrmURepQueryBro = class(TForm)
    Panel1: TPanel;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ActionList1: TActionList;
    ActnToText: TAction;
    ActnToExcel: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Panel2: TPanel;
    grid1: TStringGrid;
    ActnReopen: TAction;
    ToolButton4: TToolButton;
    RxSplitter1: TRxSplitter;
    PageControl1: TPageControl;
    DBNavigator1: TDBNavigator;
    procedure ActnToExcelExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActnToTextExecute(Sender: TObject);
    procedure ActnReopenExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure PageControl1Change(Sender: TObject);
    procedure RxDBGrid1ShowEditor(Sender: TObject; Field: TField;
      var AllowEdit: Boolean);
  private
    { private declarations }
   FIdCaller : integer;
   FItemType: TURepTreeItemType;
   FParAskList: TParamAskMeList;
   FQueryList : TQueryList;
   function getCurrentDataSource : TDataSource;
   procedure reopenQuery;
  public
    constructor CreateFrm(AOwner: TComponent; name : string;
                       IdCaller : integer; ItemType: TURepTreeItemType;
                       aParAskList: TParamAskMeList; aQueryList : TQueryList);
  end;

function getFrmQryBro(IdCaller: integer; ItemType: TURepTreeItemType; name: string;
                      aParAskList: TParamAskMeList; aQueryList : TQueryList) : TfrmURepQueryBro;
function getFrmQryBroParam(IdCaller: integer; ItemType: TURepTreeItemType; name: string;
                           aParAskList: TParamAskMeList; aQueryList: TQueryList) : TfrmURepQueryBro;

implementation

{$R *.DFM}

uses dmdURep, Common, CommonVV, fURepFunc1,
    fURepBLOB1, fURepBLOB2, ExcelEx;//;, DataSet2Excel;


function getFrmQryBro(IdCaller: integer; ItemType: TURepTreeItemType; name: string;
                      aParAskList: TParamAskMeList; aQueryList : TQueryList) : TfrmURepQueryBro;
var
  i : integer;
  frmURepQueryBro : TfrmURepQueryBro;
begin
  result := nil;
  for i:=0 to (Application.MainForm.MDIChildCount-1) do
  if (Application.MainForm.MDIChildren[i] is TfrmURepQueryBro) then
    begin
    frmURepQueryBro := Application.MainForm.MDIChildren[i] as TfrmURepQueryBro;
    if (frmURepQueryBro.FIdCaller=IdCaller) and (frmURepQueryBro.FItemType=ItemType) then
      result:=frmURepQueryBro;
    break;
    end;
  if result = nil then
    result :=
      TfrmURepQueryBro.CreateFrm(Application, name, IdCaller, ItemType, aParAskList, aQueryList);
  result.Show;
end;


function getFrmQryBroParam(IdCaller: integer; ItemType: TURepTreeItemType; name: string;
                           aParAskList: TParamAskMeList; aQueryList: TQueryList) : TfrmURepQueryBro;
var
  i : integer;
  frmURepQueryBro : TfrmURepQueryBro;
begin
  result := nil;
  for i:=0 to (Application.MainForm.MDIChildCount-1) do
  if (Application.MainForm.MDIChildren[i] is TfrmURepQueryBro) then
    begin
    frmURepQueryBro := Application.MainForm.MDIChildren[i] as TfrmURepQueryBro;
    if (frmURepQueryBro.FIdCaller=IdCaller) and
       (frmURepQueryBro.FItemType=ItemType) and
       (cmpParList(frmURepQueryBro.FParAskList, aParAskList)) then
      result:=frmURepQueryBro;
    break;
    end;
  if result = nil then
    result :=
      TfrmURepQueryBro.CreateFrm(Application, name, IdCaller, ItemType, aParAskList, aQueryList);
  result.Show;
end;


constructor TfrmURepQueryBro.CreateFrm(AOwner: TComponent; name : string;
                       IdCaller : integer; ItemType: TURepTreeItemType;
                       aParAskList: TParamAskMeList; aQueryList : TQueryList);
var
  i, j : integer;
  aParamAskMe : TParamAskMe;
  queryListItem : TQueryListItem;
  DBGrid: TRxDBGrid;
  TabSheet: TTabSheet;
  dataSet: TDataSet;
  ds: TDataSource;
begin
  inherited Create(AOwner);
  FIdCaller := IdCaller;
  FItemType := ItemType;
  FParAskList := aParAskList;
  FQueryList := aQueryList;

  Caption := Caption + ' "'+name+'"';

  if URepIsAdmin
   then Panel2.Visible:=true
   else Panel2.Visible:=false;

  if aParAskList.Count>0 then
  begin
    grid1.RowCount:=aParAskList.Count+1;
    grid1.Cells[0,0] := '';
    grid1.Cells[1,0] := '';
    j :=1;
    for i:=0 to aParAskList.Count-1 do
    begin
      aParamAskMe := aParAskList.Items[i];
      grid1.Cells[0,j] := aParamAskMe.slabel ;
      grid1.Cells[1,j] := aParamAskMe.ValueAsString ;
      if aParamAskMe.inpTyp in [prmDBLookup, prmDBMultiSelect] then
      begin
        Inc(j);
        grid1.RowCount := grid1.RowCount +1;
        grid1.Cells[0,j] := '' ;
        grid1.Cells[1,j] := aParamAskMe.DBLookupAskMe.DisplayValue;
      end;
      Inc(j);
    end;
    Panel2.Height := (grid1.DefaultRowHeight * Min(grid1.RowCount, 5))+12;
  end
  else
  begin
    grid1.Visible := False;
    Panel2.Visible:= False;
  end;


  for i:=0 to (FQueryList.Count-1) do
  begin
    queryListItem := FQueryList.Items[i];

    TabSheet := TTabSheet.Create(Self);
    TabSheet.Caption := queryListItem.name ;
    TabSheet.PageControl := PageControl1;

    DBGrid := TRxDBGrid.Create(Self);
    DBGrid.Parent := TabSheet;
    DBGrid.Name := 'DBgrid_'+ queryListItem.QueryShortName;
    DBGrid.Align := alClient;
    DBGrid.OnCellClick := DBGrid1CellClick;
    DBGrid.OnDrawColumnCell := DBGrid1DrawColumnCell;
    DBGrid.OnShowEditor := RxDBGrid1ShowEditor;
  end;

  Application.ProcessMessages;
  reopenQuery;

  for i:=0 to (aQueryList.Count-1) do
  begin
    queryListItem := FQueryList.Items[i];
    dataSet := queryListItem.FindDataSet(Self);
    ds := URepFindDatasource4Dataset(dataSet);
    DBGrid := TRxDBGrid(Self.FindComponent('DBgrid_'+ queryListItem.QueryShortName));

    DataSet.DisableControls;
    try
      DBGrid.DataSource := ds;
      for j:=0 to DBGrid.Columns.Count-1 do
        if DBGrid.Columns[j].Width>100 then DBGrid.Columns[j].Width:=100;
    finally
      DataSet.EnableControls;
    end;
  end;

  PageControl1Change(nil);
end;

procedure TfrmURepQueryBro.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action :=caFree;
end;


function TfrmURepQueryBro.getCurrentDataSource : TDataSource;
var
  queryListItem : TQueryListItem;
begin
  queryListItem := FQueryList.Items[PageControl1.ActivePageIndex];
  result := URepFindDatasource4Dataset(queryListItem.FindDataSet(Self));
end;


procedure TfrmURepQueryBro.reopenQuery;
begin
  URepCreateDataSets(Self,  FParAskList, FQueryList, False);
end;

procedure TfrmURepQueryBro.ActnToExcelExecute(Sender: TObject);
begin
  FormToExcel(Self);
end;


procedure WritelnWin(var F: File; ss: string);
var
  AmtTransferred: Integer;
begin
  ss := ss + Chr( 13 ) + Chr( 10 );
  //if SavAsTyp=SavAsDOSText then
  //  CharToOem(PChar(ss), PChar(ss));
  BlockWrite(F, ss[1], length(ss), AmtTransferred);
end;

procedure TfrmURepQueryBro.ActnToTextExecute(Sender: TObject);
var
  F : File;
  fName, ss, s1, ss2 : string;
  i, sz : integer;
  aParamAskMe : TParamAskMe;
  arLen: Variant;
  bkmark :TBookmarkStr;
  dataSet: TDataSet;
  SaveDialog1: TSaveDialog;
  bDone : Boolean;
begin

  SaveDialog1 := TSaveDialog.Create(Application);
  SaveDialog1.Filter :='. |*.txt| |*.*';
  SaveDialog1.DefaultExt := 'txt';
  try
    bDone := SaveDialog1.Execute;
    if bDone then
      fName := SaveDialog1.FileName;
  finally
    SaveDialog1.Free;
  end;
  if not bDone then Exit;

  dataSet := getCurrentDataSource.DataSet;
  AssignFile(F, fName);
  ReWrite( F, 1);
  dataSet.DisableControls;
  bkmark := dataSet.Bookmark;

  //progressBar.Min := 0;
  //progressBar.Max := aQuery.RecordCount;
  //progressBar.Position := 0;
  try
    if FParAskList.Count>0 then
      begin
      ss := Format('%15s %15s', ['','']);
      WriteLnWin(F, ss);
      WriteLnWin(F,ReplicateChr('-',15)+' '+ReplicateChr('-',15));
      for i:=0 to FParAskList.Count-1 do
        begin
        aParamAskMe := FParAskList.Items[i];
        s1 := aParamAskMe.ValueAsString;
        if (aParamAskMe.inpTyp in [prmDBLookup, prmDBMultiSelect]) and
           (trim(aParamAskMe.DBLookupAskMe.LookupField)<>
            trim(aParamAskMe.DBLookupAskMe.LookupDisplay)) then
          begin
          s1 := s1+' ('+aParamAskMe.DBLookupAskMe.DisplayValue+')';
          end;
        ss := Format('%15s %15s', [aParamAskMe.slabel, s1]);
        WriteLnWin(F, ss);
        end;
      WriteLnWin(F, '');
      end;

    arLen := VarArrayCreate([0, dataSet.FieldCount-1], varInteger);
    ss := '';
    ss2 := '';
    for i:= 0 to dataSet.FieldCount-1 do
      begin
      sz := 20;
      case dataSet.Fields[i].DataType of
        ftString:
          sz := dataSet.Fields[i].DataSize;
        ftSmallint:
          sz := 6;
        ftInteger, ftAutoInc :
          sz := 11;
        ftFloat:
          sz := 18;
        ftCurrency:
          sz := 20;
        ftDate, ftDateTime:
          sz := 19;
        end;
      if length(dataSet.Fields[i].DisplayLabel)>sz then
        sz := length(dataSet.Fields[i].DisplayLabel);
      arLen[i] := sz;
      s1 := Padr(dataSet.Fields[i].DisplayLabel, sz);
      ss := ss + s1;
      ss2:= ss2+ ReplicateChr('-', sz);
        if i<>(dataSet.FieldCount-1) then
        begin
        ss := ss + ' ';
        ss2:= ss2+ ' ';
        end;
      end;
    WriteLnWin(F, ss);
    WriteLnWin(F, ss2);

    dataSet.First;
    while not dataSet.EOF do
      begin
      ss := '';
      for i:= 0 to dataSet.FieldCount-1 do
        begin
        //   s1 := Padr(dataSet.Fields[i].AsString, arLen[i]);
        case dataSet.Fields[i].DataType of
          ftString, ftDate, ftDateTime:
            s1 := Padr(dataSet.Fields[i].AsString, arLen[i]);
          ftSmallint, ftInteger, ftAutoInc :
            s1 := Padl(Trim(dataSet.Fields[i].AsString), arLen[i]);
          ftFloat:
            s1 := Padl(Trim(dataSet.Fields[i].AsString), arLen[i]);
          ftCurrency:
            s1 := Padl(FormatFloat(frmtCurr, dataSet.Fields[i].AsFloat), arLen[i]);
          end;

        ss := ss + s1;
        if i<>(dataSet.FieldCount-1) then
          ss := ss + ' ';
        end;

      WriteLnWin(F, ss);
      dataSet.Next;
      //progressBar.StepIt;
      end;

    ss := '  :'+IntToStr(dataSet.RecordCount);
    WriteLnWin(F, ss);
  finally
    CloseFile(F);
    dataSet.Bookmark := bkmark;
    dataSet.EnableControls;
  end;
end;

procedure TfrmURepQueryBro.ActnReopenExecute(Sender: TObject);
begin
  reopenQuery;
end;

procedure TfrmURepQueryBro.FormDestroy(Sender: TObject);
begin
  FParAskList.Free;
  FQueryList.Free;
end;

procedure TfrmURepQueryBro.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
  BoolRXDBGridDrawColumnCell(Rect, DataCol, Column, State);
end;

procedure TfrmURepQueryBro.DBGrid1CellClick(Column: TColumn);
begin
  if Column.Field.DataType=ftMemo then
    URepShowFrmBLOBtxt(Self, Column.Field.FieldName,
                       getCurrentDataSource);
  if Column.Field.DataType in [ftBlob, ftGraphic] then
    URepShowFrmBLOBimage(Self, Column.Field.FieldName,
                         getCurrentDataSource);
end;

procedure TfrmURepQueryBro.PageControl1Change(Sender: TObject);
begin
  DBNavigator1.DataSource := getCurrentDataSource;
end;

procedure TfrmURepQueryBro.RxDBGrid1ShowEditor(Sender: TObject;
  Field: TField; var AllowEdit: Boolean);
begin
  AllowEdit := not ((Field.DataType=ftBoolean) or (Field.IsBlob));
end;

end.
