unit fURepRemt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RxLookup, StdCtrls, DBCtrls, ComCtrls, ToolWin, ExtCtrls, Grids, DBGrids,
  RXDBCtrl, mwCustomEdit, DBmwEdit, Mask, Db, DBTables, UpdQuery, DBUtils,
  ActnList, Placemnt;

type
  TfrmUrepRemoteData = class(TForm)
    Panel3: TPanel;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    DBNavigator1: TDBNavigator;
    Panel1: TPanel;
    Label1: TLabel;
    LookupComboRemote: TRxDBLookupCombo;
    DBNavigator2: TDBNavigator;
    PageControl1: TPageControl;
    TabSheetProp: TTabSheet;
    TabSheetForms: TTabSheet;
    RxDBGrid2: TRxDBGrid;
    Panel5: TPanel;
    dsRemoteSel: TDataSource;
    qRemoteSel: TUpdQuery;
    qRemoteSelId: TAutoIncField;
    qRemoteSelNumm: TIntegerField;
    qRemoteSelName: TStringField;
    ds1Remote: TDataSource;
    q1Remote: TQuery;
    q1RemoteId: TAutoIncField;
    q1RemoteNumm: TIntegerField;
    q1RemoteName: TStringField;
    q1RemoteDescription: TStringField;
    dsServerType: TDataSource;
    qServerType: TQuery;
    qServerTypeIval: TIntegerField;
    qServerTypeItem: TStringField;
    q1RemoteIdRemtServerType: TIntegerField;
    q1RemoteServerName: TStringField;
    q1RemoteServerGUID: TStringField;
    q1RemoteComputerName: TStringField;
    q1RemoteIdRemtProtocol: TIntegerField;
    q1RemotePort: TIntegerField;
    qProtocolType: TQuery;
    dsProtocolType: TDataSource;
    ActionList1: TActionList;
    ActionEdtParam: TAction;
    ActionExec: TAction;
    ActionEdtForm: TAction;
    qRDataFrm: TUpdQuery;
    qRDataFrmId: TAutoIncField;
    qRDataFrmName: TStringField;
    dsRDataFrm: TDataSource;
    FormStorage1: TFormStorage;
    Panel2: TPanel;
    LabelNumm: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    LabelId: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    DBEditNumm: TDBEdit;
    DBEditName: TDBEdit;
    DBEditDescr: TDBEdit;
    DBEditId: TDBEdit;
    DBLookupComboBox1: TDBLookupComboBox;
    DBLookupComboBox2: TDBLookupComboBox;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit7: TDBEdit;
    Label11: TLabel;
    CoolBar2: TCoolBar;
    ToolBar2: TToolBar;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    DBNavigator4: TDBNavigator;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure LookupComboRemoteChange(Sender: TObject);
    procedure q1RemoteBeforeOpen(DataSet: TDataSet);
    procedure q1RemoteBeforePost(DataSet: TDataSet);
    procedure q1RemoteAfterPost(DataSet: TDataSet);
    procedure q1RemoteAfterDelete(DataSet: TDataSet);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure q1RemoteNewRecord(DataSet: TDataSet);
    procedure ds1RemoteDataChange(Sender: TObject; Field: TField);
    procedure ActionEdtParamExecute(Sender: TObject);
    procedure ActionExecExecute(Sender: TObject);
    procedure ActionEdtFormExecute(Sender: TObject);
    procedure qRDataFrmBeforeOpen(DataSet: TDataSet);
  private
    { Private declarations }
    WasInsert : Boolean;
    FNameChanged: Boolean;
  public
    { Public declarations }
    procedure FindRemote(IdRemote: integer);
  end;

implementation

{$R *.DFM}

uses dmdURep, fURepParam, fURepFrm, URepConstants, fURepFunc1, URepTypes,
     QueryEx, ConstEx, LayoutEx, Common, CommonVV, AppUtils;

procedure TfrmUrepRemoteData.FormCreate(Sender: TObject);
begin
  ReQueryAll(Self);
  LookupComboRemote.Value:= qRemoteSelId.AsString;
  if qRemoteSel.RecordCount=0 then
  begin
    ReQueryOne(q1Remote);
  end;
  PageControl1.ActivePage := TabSheetProp;

  //controls layout
  FitControlLeftToParent(DBNavigator2);
  FitControlWidthToRControl(LookupComboRemote, DBNavigator2);

  FitControlLeftToParent(DBEditNumm);
  FitControlLeftToRControl(LabelNumm, DBEditNumm);
  FitControlWidthToRControl(DBEditName, LabelNumm);

  FitControlLeftToParent(DBEditID);
  FitControlLeftToRControl(LabelID, DBEditID);
  FitControlWidthToRControl(DBEditDescr, LabelNumm);
end;

procedure TfrmUrepRemoteData.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmUrepRemoteData.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  ConfirmDataSetCancel(q1Remote);
end;

procedure TfrmUrepRemoteData.LookupComboRemoteChange(Sender: TObject);
begin
  RequeryOne(q1Remote);
  RequeryOne(qRDataFrm);
end;

procedure TfrmUrepRemoteData.q1RemoteBeforeOpen(DataSet: TDataSet);
begin
  q1Remote.ParamByName(fldId).asInteger := StrToIntDef(LookupComboRemote.Value, 0);
end;

procedure TfrmUrepRemoteData.FindRemote(IdRemote: integer);
begin
  if IdRemote<>0 then
    begin
    qRemoteSel.Locate(fldId, IdRemote, []);
    Forms.Application.ProcessMessages;
    LookupComboRemote.Value:= qRemoteSelId.AsString;
    end;
end;

procedure TfrmUrepRemoteData.q1RemoteBeforePost(DataSet: TDataSet);
begin
  WasInsert:=(q1Remote.State=dsInsert);
end;

procedure TfrmUrepRemoteData.q1RemoteAfterPost(DataSet: TDataSet);
var
  maxId : integer;
begin
   ReQueryOne(qRemoteSel); //!
   if WasInsert then
     begin
     maxId :=DLookup('select max(Id) from URepRemoteData');
     qRemoteSel.Locate(fldId, maxId, []);
     end;
   LookupComboRemote.Value:= qRemoteSelId.AsString;//!
   if WasInsert or FNameChanged then
     GoMessage(WM_UREPTBLCHANGE);
   FNameChanged := False;
end;

procedure TfrmUrepRemoteData.q1RemoteNewRecord(DataSet: TDataSet);
var
  params : TParams;
begin
  params := TParams.Create;
  try
    params.CreateParam(DB.ftInteger, prmPrefix+fldNumm, ptOutput);
    ExecSP('spURepRemoteDataNumm', params);
    q1RemoteNumm.Value := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;
end;

procedure TfrmUrepRemoteData.q1RemoteAfterDelete(DataSet: TDataSet);
begin
   ReQueryOne(qRemoteSel);
   LookupComboRemote.Value:= qRemoteSelId.AsString;
   GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmUrepRemoteData.ds1RemoteDataChange(Sender: TObject;
  Field: TField);
begin
  if (Field=q1RemoteName) then
    FNameChanged := True;
end;

procedure TfrmUrepRemoteData.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then
   begin
     RequeryOne(q1Remote);
     Abort;
   end;
   if Button=nbInsert then
   begin
     q1Remote.Append;
     Abort;
   end;
end;

procedure TfrmUrepRemoteData.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  LookupComboRemote.Value := qRemoteSelId.asString;
end;

procedure TfrmUrepRemoteData.qRDataFrmBeforeOpen(DataSet: TDataSet);
begin
  qRDataFrm.ParamByName(fldId).asInteger := StrToIntDef(LookupComboRemote.Value, 0);
end;

procedure TfrmUrepRemoteData.ActionEdtParamExecute(Sender: TObject);
var
  frmURepParam: TfrmURepParam;
begin
  frmURepParam := FindForm(TfrmURepParam) as TfrmURepParam;
  if frmURepParam=nil then
    frmURepParam := TfrmURepParam.Create(Self, paramRemoteData, q1RemoteId.Value, 0)
  else
    frmURepParam.FindParam(paramRemoteData, q1RemoteId.Value, 0);
  frmURepParam.Show;
end;

procedure TfrmUrepRemoteData.ActionExecExecute(Sender: TObject);
begin
  URepExtFormAction(q1RemoteId.Value, q1RemoteName.Value, nil,
                   factViewAsTbl, '', 0, Ord(ttRemoteData));
end;

procedure TfrmUrepRemoteData.ActionEdtFormExecute(Sender: TObject);
var
  frmURepForm : TfrmURepForm;
begin
  if qRemoteSel.RecordCount=0 then Exit;
  if qRDataFrm.RecordCount=0 then Exit;

  frmURepForm := GetOneFormExt(TfrmURepForm, URepGetMainForm) as TfrmURepForm;
  frmURepForm.FindForm(qRDataFrmId.Value, 0, qRemoteSelId.Value);
end;

end.

