unit fURepRights;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Db, DBTables, StdCtrls, RxLookup, ExtCtrls, UpdQuery, FieldVals,
  Grids, DBGrids, RXDBCtrl, DBCtrls, GridEx, Placemnt, ActnList, Buttons;

type
  TfrmURepRights = class(TForm)
    PageControl1: TPageControl;
    TabSheetByObject: TTabSheet;
    TabSheetByUser: TTabSheet;
    Panel1: TPanel;
    LookupComboTyp: TRxDBLookupCombo;
    Label1: TLabel;
    LookupComboObj: TRxDBLookupCombo;
    Label2: TLabel;
    qTypObj: TQuery;
    dsTypObj: TDataSource;
    qObj: TQuery;
    dsObj: TDataSource;
    Panel2: TPanel;
    dsRightByObject: TDataSource;
    qRightByObject: TUpdQuery;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    RxDBGrid1: TRxDBGrid;
    qRightByObjectId: TAutoIncField;
    qRightByObjectLoginName: TStringField;
    qryLogins: TQuery;
    qTypObjIval: TIntegerField;
    qTypObjItem: TStringField;
    Panel4: TPanel;
    RxDBGrid2: TRxDBGrid;
    Label3: TLabel;
    DBComboUser: TRxDBLookupCombo;
    dsLogins: TDataSource;
    qRightByUser: TUpdQuery;
    dsRightByUser: TDataSource;
    Panel5: TPanel;
    DBNavigator2: TDBNavigator;
    qRightByUserId: TIntegerField;
    qRightByUserIdRight: TIntegerField;
    qRightByUserIdTypObj: TIntegerField;
    qRightByUserIdObj: TIntegerField;
    qRightByUserObjName: TStringField;
    qRightByUserTypObjName: TStringField;
    FormStorage1: TFormStorage;
    qryLoginsLoginName: TStringField;
    qryLoginsFullName: TStringField;
    qRightByObjectLoginNameLookup: TStringField;
    qRightByObjectFullNameLookup: TStringField;
    qObjIdObj: TIntegerField;
    qObjObjName: TStringField;
    qRightByUserEnabled: TBooleanField;
    qLogins2: TQuery;
    StringField1: TStringField;
    qRightByObjectIsRole: TIntegerField;
    qryLoginsIsRole: TIntegerField;
    qLogins2IsRole: TIntegerField;
    ActionList1: TActionList;
    actnEditLogin: TAction;
    SpeedButtonEditLogins1: TSpeedButton;
    SpeedButtonEditLogins2: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LookupComboTypChange(Sender: TObject);
    procedure LookupComboObjChange(Sender: TObject);
    procedure qRightByObjectBeforeOpen(DataSet: TDataSet);
    procedure LookupComboTypGetImage(Sender: TObject; IsEmpty: Boolean;
      var Graphic: TGraphic; var TextMargin: Integer);
    procedure DBComboUserChange(Sender: TObject);
    procedure qRightByUserBeforeOpen(DataSet: TDataSet);
    procedure RxDBGrid2CellClick(Column: TColumn);
    procedure RxDBGrid2KeyPress(Sender: TObject; var Key: Char);
    procedure RxDBGrid2DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure RxDBGrid2ShowEditor(Sender: TObject; Field: TField;
      var AllowEdit: Boolean);
    procedure qRightByUserNewRecord(DataSet: TDataSet);
    procedure qRightByUserAfterPost(DataSet: TDataSet);
    procedure qRightByObjectAfterPost(DataSet: TDataSet);
    procedure qRightByObjectAfterDelete(DataSet: TDataSet);
    procedure qRightByUserCalcFields(DataSet: TDataSet);
    procedure RxDBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure RxDBGrid1ShowEditor(Sender: TObject; Field: TField;
      var AllowEdit: Boolean);
    procedure qRightByObjectLoginNameChange(Sender: TField);
    procedure actnEditLoginExecute(Sender: TObject);
    procedure qRightByUserBeforeEdit(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FindObject(IdTypObj, IdObj: integer);
  end;


implementation

{$R *.DFM}

uses dmdURep, fURepFunc1, Common, QueryEx, LayoutEx, CommonVV,
     fURepLogins;

const
  URepRightsSortOrderStr1 : array [TURepTreeSortOrder] of string =
    ('Numm', 'ObjName', 'Id');

  URepRightsSortOrderStr2 : array [TURepTreeSortOrder] of string =
    ('IdTypObj, Numm', 'IdTypObj, ObjName', 'IdTypObj, Id');


procedure TfrmURepRights.FormCreate(Sender: TObject);
begin
  setOrderBy(qObj, cnstOrderBy + URepRightsSortOrderStr1[dmURep.FSortOrder]);
  setOrderBy(qRightByUser, cnstOrderBy + URepRightsSortOrderStr2[dmURep.FSortOrder]);

  //controls layout
  FitControlWidthToParent(LookupComboObj);
  FitControlLeftToParent(SpeedButtonEditLogins1);
  FitControlWidthToRControl(DBComboUser, SpeedButtonEditLogins1);
  FitControlLeftToRControl(SpeedButtonEditLogins2, DBNavigator1);

  ReQueryAll(Self);

  PageControl1.ActivePage := TabSheetByObject;
  LookupComboTyp.Value := qTypObjIval.asString;
  qryLogins.First;
  DBComboUser.Value := qryLoginsLoginName.asString;

  PageControl1.ActivePage := TabSheetByObject;

end;

procedure TfrmURepRights.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepRights.FindObject(IdTypObj, IdObj: integer);
begin
  if IdTypObj<>0 then
    begin
    PageControl1.ActivePage := TabSheetByObject;
    qTypObj.Locate('Ival', IdTypObj, []);
    LookupComboTyp.Value:= qTypObjIval.asString;
    end;

  if IdObj<>0 then
    begin
    qObj.Locate('IdObj', IdObj, []);
    LookupComboObj.Value:= qObjIdObj.asString;
    end;
end;

procedure TfrmURepRights.LookupComboTypChange(Sender: TObject);
begin
  qObj.Close;
  qObj.ParamByName('IdTypObj').asInteger := StrToIntDef(LookupComboTyp.Value, 0);
  qObj.Open;

  LookupComboObj.Value := qObjIdObj.asString;
  ReQueryOne(qRightByObject);
end;

procedure TfrmURepRights.LookupComboObjChange(Sender: TObject);
begin
  ReQueryOne(qRightByObject);
end;

procedure TfrmURepRights.qRightByObjectBeforeOpen(DataSet: TDataSet);
begin
  qRightByObject.ParamByName('IdTypObj').asInteger := StrToIntDef(LookupComboTyp.Value, 0);
  qRightByObject.ParamByName('IdObj').asInteger := StrToIntDef(LookupComboObj.Value, 0);
end;


procedure TfrmURepRights.LookupComboTypGetImage(Sender: TObject;
  IsEmpty: Boolean; var Graphic: TGraphic; var TextMargin: Integer);
var
 aBitmap: TBitmap;
begin
 aBitmap:= TBitmap.Create;
 dmURep.imgLstURep.GetBitmap(URepImageIndexFromIdTypObj(qTypObjIval.Value), aBitmap);
 Graphic := aBitmap;
 TextMargin := 20;
end;

procedure TfrmURepRights.DBComboUserChange(Sender: TObject);
begin
  ReQueryOne(qRightByUser);
end;

procedure TfrmURepRights.qRightByUserBeforeOpen(DataSet: TDataSet);
begin
 qRightByUser.ParamByName('LoginName').asString := DBComboUser.Value;
end;

procedure TfrmURepRights.RxDBGrid2CellClick(Column: TColumn);
begin
  BoolRXDBGridCellClick(Column);
end;

procedure TfrmURepRights.RxDBGrid2KeyPress(Sender: TObject; var Key: Char);
begin
  BoolRXDBGridKeyPress(RxDBGrid2, Key);
end;

procedure TfrmURepRights.RxDBGrid2DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
 aBitmap: TBitmap;
 TxtRect: TRect;
begin
  if (Column.Field=qRightByUserTypObjName) and
     (Column.Field.IsNull=False) then
    begin
    aBitmap := TBitmap.Create;
    dmURep.imgLstURep.GetBitmap(URepImageIndexFromIdTypObj(qRightByUserIdTypObj.Value), aBitmap);
    RxDBGrid2.Canvas.FillRect(Rect);
    RxDBGrid2.Canvas.Draw(Rect.Left+10,
                          (Rect.Top+Rect.Bottom-aBitmap.Height) div 2,
                          aBitmap);

    TxtRect := Rect;
    TxtRect.Left := Rect.Left+10+aBitmap.Width+5;
    RxDBGrid2.Canvas.TextRect(TxtRect, Rect.Left+10+aBitmap.Width+10,
                             Rect.Top, //(Rect.Top+ Rect.Bottom) div 2,
                             Column.Field.AsString);
    aBitmap.Free;
    end
  else
    BoolRXDBGridDrawColumnCell(Rect, DataCol, Column, State);
end;

procedure TfrmURepRights.RxDBGrid2ShowEditor(Sender: TObject;
  Field: TField; var AllowEdit: Boolean);
begin
  AllowEdit := False;
end;

procedure TfrmURepRights.qRightByUserNewRecord(DataSet: TDataSet);
begin
  Abort;
end;

procedure TfrmURepRights.qRightByUserAfterPost(DataSet: TDataSet);
begin
  RequeryOne(qRightByObject);
end;

procedure TfrmURepRights.qRightByObjectAfterPost(DataSet: TDataSet);
begin
  RequeryOne(qRightByUser);
end;

procedure TfrmURepRights.qRightByObjectAfterDelete(DataSet: TDataSet);
begin
  RequeryOne(qRightByUser);
end;

procedure TfrmURepRights.qRightByUserCalcFields(DataSet: TDataSet);
begin
  qRightByUserEnabled.Value := qRightByUserIdRight.Value > 0;
end;

procedure TfrmURepRights.RxDBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
 iIndex: integer;
 aBitmap: TBitmap;
begin
  if (Column.Field=qRightByObjectIsRole) and
     (Column.Field.IsNull=False) then
    begin
    iIndex := qRightByObjectIsRole.Value + 48;
    aBitmap := TBitmap.Create;
    dmURep.imgLstURep.GetBitmap(iIndex, aBitmap);
    RxDBGrid1.Canvas.FillRect(Rect);
    RxDBGrid1.Canvas.Draw(Rect.Left+10,
                          (Rect.Top+Rect.Bottom-aBitmap.Height) div 2,
                          aBitmap);
    aBitmap.Free;
    end
  else
    BoolRXDBGridDrawColumnCell(Rect, DataCol, Column, State);
end;

procedure TfrmURepRights.RxDBGrid1ShowEditor(Sender: TObject;
  Field: TField; var AllowEdit: Boolean);
begin
  if (Field=qRightByObjectIsRole) then
    AllowEdit := False;
end;

procedure TfrmURepRights.qRightByObjectLoginNameChange(Sender: TField);
var
  IsRole: integer;
begin
  qryLogins.Locate('LoginName', qRightByObjectLoginName.Value,[]);
  IsRole := qryLoginsIsRole.Value;
  qRightByObjectIsRole.Value := IsRole;
end;

procedure TfrmURepRights.actnEditLoginExecute(Sender: TObject);
begin
  GetOneFormExt(TfrmURepLogins, Self);
end;

procedure TfrmURepRights.qRightByUserBeforeEdit(DataSet: TDataSet);
begin

if qRightByUserIdRight.Value > 0 then
  qRightByUser.ModifySQL.Text := 'delete from URepUsers where Id=:IdRight'
else
  qRightByUser.ModifySQL.Text := 'insert into URepUsers (IdTypObj, IdObj, LoginName) values (:IdTypObj, :IdObj, :LoginName)';
end;

end.
