unit fURepScr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, ToolWin, Mask, ActnList,
  Db, DBTables, Placemnt, DBGrids, RxDBComb, UpdQuery,
  ScrlQuery, DBUtils, mwCustomEdit, DBmwEdit, mwHighlighter, StrUtils,
  DBCtrls, RxLookup, SmartDBmwEdit, AppUtils, Grids, RXDBCtrl;

type
  TfrmURepScript = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    LookupComboQuery: TRxDBLookupCombo;
    Panel3: TPanel;
    ActionList1: TActionList;
    ActionExec: TAction;
    qScrSel: TUpdQuery;
    qScrSelId: TAutoIncField;
    qScrSelNumm: TIntegerField;
    qScrSelName: TStringField;
    q1Script: TQuery;
    dsScrSel: TDataSource;
    ds1Script: TDataSource;
    q1ScriptId: TAutoIncField;
    q1ScriptNumm: TIntegerField;
    q1ScriptName: TStringField;
    ActionLoad: TAction;
    ActionSave: TAction;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    DBNavigator1: TDBNavigator;
    ToolButton5: TToolButton;
    FormStorage1: TFormStorage;
    DBNavigator2: TDBNavigator;
    PageControl1: TPageControl;
    TabSheetScr: TTabSheet;
    q1ScriptDescription: TStringField;
    q1ScriptIdScrEng: TIntegerField;
    q1ScriptScriptText: TMemoField;
    ToolButton3: TToolButton;
    DBmwEdit1: TSmartDBmwEdit;
    TabSheetProp: TTabSheet;
    Panel2: TPanel;
    LabelNumm: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    LabelID: TLabel;
    Label6: TLabel;
    DBEditNumm: TDBEdit;
    DBEditName: TDBEdit;
    DBEditDescr: TDBEdit;
    DBEditId: TDBEdit;
    StatusBar1: TStatusBar;
    DBLookupComboBox1: TDBLookupComboBox;
    dsScrEng: TDataSource;
    q1ScriptScrEngName: TStringField;
    ToolButton6: TToolButton;
    ActionBrows: TAction;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ActionReferenses: TAction;
    TabSheetGrpScr: TTabSheet;
    CoolBar3: TCoolBar;
    ToolBar3: TToolBar;
    DBNavigator4: TDBNavigator;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    RxDBGrid2: TRxDBGrid;
    ActionEditGrp: TAction;
    qGrpScr: TUpdQuery;
    qGrpScrId: TAutoIncField;
    qGrpScrGrpName: TStringField;
    dsGrpScr: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure q1ScriptAfterPost(DataSet: TDataSet);
    procedure q1ScriptAfterDelete(DataSet: TDataSet);
    procedure LookupComboQueryChange(Sender: TObject);
    procedure q1ScriptBeforeOpen(DataSet: TDataSet);
    procedure ActionLoadExecute(Sender: TObject);
    procedure ActionSaveExecute(Sender: TObject);
    procedure ActionExecExecute(Sender: TObject);
    procedure q1ScriptBeforePost(DataSet: TDataSet);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure q1ScriptNewRecord(DataSet: TDataSet);
    procedure ds1ScriptDataChange(Sender: TObject; Field: TField);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DBmwEdit1LoadData(Sender: TObject);
    procedure ActionBrowsExecute(Sender: TObject);
    procedure DBmwEdit1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DBmwEdit1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure DBmwEdit1StatusChange(Sender: TObject;
      Changes: TmwStatusChanges);
    procedure ActionReferensesExecute(Sender: TObject);
    procedure ActionEditGrpExecute(Sender: TObject);
    procedure qGrpScrBeforeOpen(DataSet: TDataSet);
  private
    { Private declarations }
    WasInsert : Boolean;
    FNameChanged: Boolean;
    procedure ScrTextInfoUpdate;
  public
    { Public declarations }
    procedure FindScript(IdScript: integer);
  end;

implementation

{$R *.DFM}

uses dmdURep, Common, fUrepActScpSite, QueryEx, LayoutEx, ConstEx,
     URepGen_TLB, fURepBrowser, unAxBowser, fURepMain, CommonVV,
     fURepReferences, fURepGrp, fURepFunc1, URepConstants;

procedure TfrmURepScript.FormCreate(Sender: TObject);
begin
  If not dmURep.qScript.Active then dmURep.qScript.Open;
  FNameChanged := False;
  //PageControl1.ActivePage := TabSheetProp;
  ReQueryAll(Self);
  LookupComboQuery.Value:= qScrSelId.AsString;
  if qScrSel.RecordCount=0 then
  begin
    RequeryOne(q1Script);
  end;

  //controls layout
  FitControlLeftToParent(DBNavigator2);
  FitControlWidthToRControl(LookupComboQuery, DBNavigator2);

  FitControlLeftToParent(DBEditNumm);
  FitControlLeftToRControl(LabelNumm, DBEditNumm);
  FitControlWidthToRControl(DBEditName, LabelNumm);

  FitControlLeftToParent(DBEditID);
  FitControlLeftToRControl(LabelID, DBEditID);
  FitControlWidthToRControl(DBEditDescr, LabelNumm);
end;

procedure TfrmURepScript.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmURepScript.LookupComboQueryChange(Sender: TObject);
begin
  RequeryOne(q1Script);
  ReQueryOne(qGrpScr);
end;

procedure TfrmURepScript.q1ScriptBeforeOpen(DataSet: TDataSet);
begin
  q1Script.ParamByName(fldId).asInteger := StrToIntDef(LookupComboQuery.Value, 0);
end;

procedure TfrmURepScript.FindScript(IdScript: integer);
begin
  if IdScript<>0 then
    begin
    qScrSel.Locate(fldId, IdScript, []);
    Forms.Application.ProcessMessages;
    LookupComboQuery.Value:= qScrSelId.AsString;
    end;
end;

procedure TfrmURepScript.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
begin
   if Button=nbRefresh then
   begin
     RequeryOne(q1Script);
     Abort;
   end;
   if Button=nbInsert then
   begin
     q1Script.Append;
     Abort;
   end;
end;

procedure TfrmURepScript.q1ScriptBeforePost(DataSet: TDataSet);
begin
  WasInsert:=(q1Script.State=dsInsert);
end;

procedure TfrmURepScript.q1ScriptAfterPost(DataSet: TDataSet);
var
  maxId : integer;
begin
   ReQueryOne(qScrSel); //!
   if WasInsert then
     begin
     maxId :=DLookup('select max(Id) from URepScript');
     qScrSel.Locate('Id', maxId, []);
     end;
   LookupComboQuery.Value:= qScrSelId.AsString;//!
   if WasInsert or FNameChanged then
     GoMessage(WM_UREPTBLCHANGE);
   FNameChanged := False;
end;

procedure TfrmURepScript.q1ScriptAfterDelete(DataSet: TDataSet);
begin
   ReQueryOne(qScrSel);
   LookupComboQuery.Value:= qScrSelId.AsString;
   GoMessage(WM_UREPTBLCHANGE);
end;

procedure TfrmURepScript.ActionLoadExecute(Sender: TObject);
var
  OpenDialog: TOpenDialog;
begin
  OpenDialog:= TOpenDialog.Create(Self);
  OpenDialog.DefaultExt := 'scr';
  OpenDialog.Filter :='Script files (*.scr)|*.scr|All files (*.*)|*.*';
  try
    If OpenDialog.Execute then
      DBmwEdit1.Lines.LoadFromFile(OpenDialog.FileName);
  finally
    OpenDialog.Free;
  end;
end;

procedure TfrmURepScript.ActionSaveExecute(Sender: TObject);
var
  SaveDialog: TSaveDialog;
begin
  SaveDialog:= TSaveDialog.Create(Self);
  SaveDialog.DefaultExt := 'scr';
  SaveDialog.Filter :='Script files (*.scr)|*.scr|All files (*.*)|*.*';
  try
    If SaveDialog.Execute then
      DBmwEdit1.Lines.SaveToFile(SaveDialog.FileName);
  finally
    SaveDialog.Free;
  end;
end;

procedure TfrmURepScript.ActionExecExecute(Sender: TObject);
begin
//  
  RunScript(q1ScriptScrEngName.Value, DBmwEdit1.Text,
            q1ScriptId.Value, q1ScriptName.Value, DBmwEdit1);
end;

procedure TfrmURepScript.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
  LookupComboQuery.Value := qScrSelId.asString;
end;

procedure TfrmURepScript.q1ScriptNewRecord(DataSet: TDataSet);
var
  params : TParams;
begin
  params := TParams.Create;
  try
    params.CreateParam(DB.ftInteger, prmPrefix+fldNumm, ptOutput);
    ExecSP('spURepScriptNumm', params);
    q1ScriptNumm.Value := params.ParamValues[prmPrefix+fldNumm];
  finally
    params.Free;
  end;
end;


procedure TfrmURepScript.ds1ScriptDataChange(Sender: TObject; Field: TField);
begin
  if (Field=nil) or (Field=q1ScriptIdScrEng) then
  begin
    if AnsiUpperCase(q1ScriptScrEngName.Value)='VBSCRIPT' then
    begin
      if DBmwEdit1.HighLighter <> dmURep.VBSsyntax then
        DBmwEdit1.HighLighter := dmURep.VBSsyntax;
    end
    Else if AnsiUpperCase(q1ScriptScrEngName.Value)='JSCRIPT' then
    begin
      if DBmwEdit1.HighLighter <> dmURep.JScriptSyntax then
        DBmwEdit1.HighLighter := dmURep.JScriptSyntax;
    end
    Else if Pos('PERL', AnsiUpperCase(q1ScriptScrEngName.Value))>0 then
    begin
      if DBmwEdit1.HighLighter <> dmURep.PerlSyntax then
        DBmwEdit1.HighLighter := dmURep.PerlSyntax;
    end
    else
    begin
      if DBmwEdit1.HighLighter <> nil then
        DBmwEdit1.HighLighter := nil;
    end
  end
  else if (Field=q1ScriptName) then
    FNameChanged := True;
end;

procedure TfrmURepScript.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  ConfirmDataSetCancel(q1Script);
end;

procedure TfrmURepScript.DBmwEdit1LoadData(Sender: TObject);
begin
  ScrTextInfoUpdate;
end;

procedure TfrmURepScript.ScrTextInfoUpdate;
begin
  if not assigned(StatusBar1) then Exit;
  StatusBar1.Panels[0].Text :=
    RightStr(IntToStr(DBmwEdit1.CaretY),4)+':'+
    RightStr(IntToStr(DBmwEdit1.CaretX),4);

  if DBmwEdit1.InsertMode Then
    StatusBar1.Panels[1].Text := insmodeInsret
  else
    StatusBar1.Panels[1].Text := insmodeOverwrite;
end;

procedure TfrmURepScript.ActionBrowsExecute(Sender: TObject);
var
  frmURepBrowser: TfrmURepBrowser;
begin
  frmURepBrowser := FindForm(TfrmURepBrowser) as TfrmURepBrowser;
  If frmURepBrowser=nil Then
    frmURepBrowser := TfrmURepBrowser.Create(Self,
                        GlObjURepMainName, URepGen_TLB.IID_URepMain, q1Script);
  frmURepBrowser.Show;
end;

procedure TfrmURepScript.DBmwEdit1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if (Sender = DBmwEdit1) and
     (Source.ClassName = 'TTreeView') and
     (TComponent(Source).Name='tvAxBrowser') then
    begin
    Accept := True;
    end
end;

procedure TfrmURepScript.DBmwEdit1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  pItemData: PTTLItemData;
begin
  if (Sender = DBmwEdit1) and
     (Source.ClassName = 'TTreeView') and
     (TComponent(Source).Name='tvAxBrowser') then
    begin
    DBmwEdit1.ComputeCaret(x,y);
    pItemData := (TTreeView(Source)).Selected.Data;
    DBmwEdit1.SelText :=
      GetEnterStr(pItemData, q1ScriptIdScrEng.Value, DBmwEdit1.Lines, DBmwEdit1.CaretXY);
    end;
end;

procedure TfrmURepScript.DBmwEdit1StatusChange(Sender: TObject;
  Changes: TmwStatusChanges);
begin
  If (mwscCaretX in Changes) or
     (mwscCaretY in Changes) or
     (mwscInsertMode in Changes) Then
    ScrTextInfoUpdate;
end;

procedure TfrmURepScript.ActionReferensesExecute(Sender: TObject);
var
  frmURepReferences: TfrmURepReferences;
begin
  frmURepReferences := TfrmURepReferences.Create(Forms.Application, q1Script);
  frmURepReferences.ShowModal;
  frmURepReferences.Release;
end;

procedure TfrmURepScript.ActionEditGrpExecute(Sender: TObject);
var
  frmURepGrpFrm : TfrmURepGrpFrm;
begin
  frmURepGrpFrm := GetOneFormExt(TfrmURepGrpFrm ,URepGetMainForm) as  TfrmURepGrpFrm;
  frmURepGrpFrm.FindGrpFrm(qGrpScrId.Value, 0, qScrSelId.Value);
end;

procedure TfrmURepScript.qGrpScrBeforeOpen(DataSet: TDataSet);
begin
  qGrpScr.ParamByName(fldId).asInteger := qScrSelId.Value;
end;

end.
