unit unThrdSender;

interface

uses Windows, Messages, SysUtils, Classes, Dialogs;

type
  TAddr=record
    comp:string;
    slot:string;
  end;

type
  TAddrs=array of TAddr;

Type
  TThreadSender=class(TThread)
  private
    Fsrv:TStringList;
    Fslt:TStringList;
    Fmsg:TStringList;
    procedure BeginCreate;
    procedure EndCreate;
  public
    procedure Execute; override;
    destructor Destroy; override;
    constructor CreateEx(const servers:TStringList; const slot, msg:string); overload;
    constructor CreateEx(const addrs:TAddrs; const msg:string); overload;
  end;

implementation

uses mdMailSlot;

procedure TThreadSender.BeginCreate;
begin
  Create(true);
  Fsrv:=TStringList.Create;
  Fslt:=TStringList.Create;
  Fmsg:=TStringList.Create;
  FreeOnTerminate:=true;
  Priority:=tpIdle;
end;

constructor TThreadSender.CreateEx(const addrs:TAddrs; const msg:string);
var i:integer;
begin
  BeginCreate;
  for i:=0 to Length(addrs)-1 do
  begin
    Fsrv.Add(addrs[i].comp);
    Fslt.Add(addrs[i].slot);
    Fmsg.Add(msg);
  end;
  EndCreate;
end;

constructor TThreadSender.CreateEx(const servers: TStringList; const slot, msg: string);
var i:integer;
begin
  BeginCreate;
  Fsrv.Assign(servers);
  for i:=1 to Fsrv.Count do
  begin
    Fslt.Add(slot);
    Fmsg.Add(msg);
  end;
  EndCreate;
end;

destructor TThreadSender.Destroy;
begin
  Fsrv.Free;
  Fslt.Free;
  Fmsg.Free;
  inherited;
end;

procedure TThreadSender.EndCreate;
var i:integer;
   procedure ErrRaise;
   begin
     raise Exception.Create('  ');
   end;
begin
  if (Fsrv.Count<>Fslt.Count) or (Fsrv.Count<>Fmsg.Count) or (Fsrv.Count=0)
     then ErrRaise;
  for i:=0 to Fsrv.Count-1 do
   if (trim(Fsrv[i])='') or (trim(Fslt[i])='') or (trim(Fmsg[i])='')
     then ErrRaise;
  Resume;
end;

procedure TThreadSender.Execute;
var i:integer;
begin
  try
    for i:=0 to Fsrv.Count-1 do
      SendToMailSlot(Fsrv[i],Fslt[i],Fmsg[i]);
  except on e:Exception do
    MessageDlg(e.Message,mtError,[mbAbort],0);
  end;
end;

end.
