unit Impl_Application;

interface

uses
  ComObj, ActiveX, URepGenApp_TLB, URepGen_TLB, Impl_URepMain, StdVcl;

type
  TApplication = class(TAutoObject, IApplication)
  private
    FURepMain : URepMain;
  protected
    procedure Connect(const ConnectionName, Login, Password: WideString);
      safecall;
    function Get_IsConnected: WordBool; safecall;
    procedure Quit; safecall;
    function Get_URepMain: IDispatch; safecall;
    function Get_ConnectionName: WideString; safecall;
    { Protected declarations }
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses
  ComServ, Windows, Messages, Forms, frURepGenAppMDIMain, fLoginDB,
  Impl_URepObjectFactory;

procedure TApplication.Initialize;
begin
  inherited Initialize;
  FURepMain := TURepMain.Create(GetURepTypeLib, URepMainDisp);
end;

destructor TApplication.Destroy;
begin
  FURepMain := nil;
  inherited Destroy;
end;

procedure TApplication.Connect(const ConnectionName, Login,
  Password: WideString);
begin
  if (frmURepGenAppMDImain.Database1.Connected = False) then
    ConnectSlient(frmURepGenAppMDImain.Database1, ConnectionName, Login, Password);
end;

function TApplication.Get_IsConnected: WordBool;
begin
  result := frmURepGenAppMDImain.Database1.Connected;
end;

procedure TApplication.Quit;
begin
//  PostThreadMessage(MainThreadID, WM_QUIT, 0, 0);
//  Forms.Application.Terminate;
 frmURepGenAppMDImain.FShutdownOnLastRelease := True;
end;


function TApplication.Get_URepMain: IDispatch;
begin
  result := FURepMain as URepMain;
end;

function TApplication.Get_ConnectionName: WideString;
begin
  result := frmURepGenAppMDImain.ConnectionName;
end;

initialization
  TURepAutoObjectFactory.Create(ComServer, TApplication, Class_Application,
    ciMultiInstance, tmApartment);
end.
