unit SendMsg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, DBCtrls, Buttons, RXCtrls, mdMailSlot, Animate,
  GIFCtrl, RXSplit, ExtCtrls, RxLookup, StrUtils, AskMe;

type
  TfmSendMessage = class(TForm)
    dsUsers: TDataSource;
    qUsers: TQuery;
    Panel1: TPanel;
    lbAdressee: TRxDBLookupList;
    RxLabel2: TRxLabel;
    RxSplitter1: TRxSplitter;
    Panel2: TPanel;
    Memo: TMemo;
    RxLabel1: TRxLabel;
    btSend: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure MemoChange(Sender: TObject);
    procedure btSendClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RxGIFAnimator1DblClick(Sender: TObject);
    procedure MemoKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation

{$R *.DFM}

uses Common, AppInfo, UserInfo, unThrdSender;

procedure TfmSendMessage.FormCreate(Sender: TObject);
begin
   qUsers.DatabaseName:=glDatabaseName;
   qUsers.Open;
   qUsers.FetchAll;
end;

procedure TfmSendMessage.MemoChange(Sender: TObject);
begin
  if Length(Trim(Memo.Text))>0
    then btSend.Enabled:=true
    else btSend.Enabled:=false;
  if Length(Memo.Text)>400 then
  begin
    ErrorMsg('   400 ');
    Memo.Text:=copy(Memo.Text,1,400);
  end;
end;

procedure TfmSendMessage.btSendClick(Sender: TObject);
var
  srv,msg:string;
  lst:TStringList;
begin
  //IdMsg:=0;
  srv:=lbAdressee.Value;
  msg:='  '+GetLoginName+':'#10#13#10#13;
  msg:=msg+Memo.Text;

  lst:=TStringList.Create;
  try
   if (srv<>'All')
    then lst.Add(srv)
    else
       with qUsers do
       begin
         First;
         DisableControls;
         try
           while not EOF do
           begin
             if (qUsers.FieldByName('Host').asString<>'All') then lst.Add(qUsers.FieldByName('Host').asString);
             Next;
           end;
           First;
         finally
           EnableControls;
         end;
       end;
    TThreadSender.CreateEx(lst,GetProgName,msg);
  finally
    lst.Free;
  end;
  ShowMessage(' ');
end;

procedure TfmSendMessage.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=VK_ESCAPE then Close;
end;

procedure TfmSendMessage.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfmSendMessage.RxGIFAnimator1DblClick(Sender: TObject);
//var srv,cmd:string;
begin
{  srv:=qUsersServer.AsString;
  cmd:=SYS_COMMAND_ATTR+' '+Memo.Text;
  if (srv<>'All') and (srv<>ADMIN_SLOT) then
     SendToMailSlot(srv,ExeFileName,cmd);
  if (srv=ADMIN_SLOT) then
     SendToMailSlot(ADMIN_HOST,ExeFileName,cmd);}
end;

procedure TfmSendMessage.MemoKeyPress(Sender: TObject; var Key: Char);
begin
  if Length(Memo.Text)>=400 then
  begin
    ErrorMsg('   400 ');
    Key:=#0
  end;
end;

end.
