unit frURepGenAppMDIMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ImgList, Placemnt, DBTables, SoBckgrd, AppUtils, DateUtil,
  ConstEx, registry, Db, ComCtrls, SBctrl, ExtCtrls;

const
  WM_GET_REPORTS = BASE_MESSAGE + 1;
  WM_VIEW_HELPKEY = BASE_MESSAGE + 2;

type
  TfrmURepGenAppMDImain = class(TForm)
    MainMenu: TMainMenu;
    EmptyMenu: TMainMenu;
    mnuExit2: TMenuItem;
    mnuFile: TMenuItem;
    mnuOpenDB: TMenuItem;
    mnuCloseDB: TMenuItem;
    mnuExit: TMenuItem;
    ImageList1: TImageList;
    mnuWindow: TMenuItem;
    mnuWinCask: TMenuItem;
    mnuWinTile: TMenuItem;
    mnuWinArrangeIcons: TMenuItem;
    Database1: TDatabase;
    mnuURepMainWin: TMenuItem;
    mnuN1: TMenuItem;
    sohoBackground1: TsohoBackground;
    N1: TMenuItem;
    mnuAbout: TMenuItem;
    mnQuery: TMenuItem;
    mnFind: TMenuItem;
    mnSortOrder: TMenuItem;
    mnFilter: TMenuItem;
    mnRefreshAll: TMenuItem;
    mnSumGridCol: TMenuItem;
    mnInfo: TMenuItem;
    N17: TMenuItem;
    mnToExcel: TMenuItem;
    mnDeleteINI: TMenuItem;
    mnDeleINIAfterClose: TMenuItem;
    mnuSendSlot1: TMenuItem;
    mnuImpSet: TMenuItem;
    mnuImpRun: TMenuItem;
    N4: TMenuItem;
    StatusBar: TStatusBar;
    Timer1: TTimer;
    N5: TMenuItem;
    N6: TMenuItem;
    procedure mnuWinCaskClick(Sender: TObject);
    procedure mnuWinTileClick(Sender: TObject);
    procedure mnuWinArrangeIconsClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuOpenDBClick(Sender: TObject);
    procedure mnuCloseDBClick(Sender: TObject);
    procedure mnuExit2Click(Sender: TObject);
    procedure mnuURepMainWinClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnFindClick(Sender: TObject);
    procedure mnSortOrderClick(Sender: TObject);
    procedure mnFilterClick(Sender: TObject);
    procedure mnRefreshAllClick(Sender: TObject);
    procedure mnSumGridColClick(Sender: TObject);
    procedure mnInfoClick(Sender: TObject);
    procedure mnToExcelClick(Sender: TObject);
    procedure mnDeleteINIClick(Sender: TObject);
    procedure mnDeleINIAfterCloseClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuSendSlot1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuImpSetClick(Sender: TObject);
    procedure mnuImpRunClick(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure Timer1Timer(Sender: TObject);
    procedure Database1AfterConnect(Sender: TObject);
  private
    { Private declarations }
    FSBctrl:TSBctrl;
    FCaption, FConnectionName: String;
    procedure OLEServerLastReleaseEvent(var Shutdown: Boolean);
    procedure GetReports(var Msg:TMessage); message WM_GET_REPORTS;
    procedure ViewHelpKey(var Msg:TMessage); message WM_VIEW_HELPKEY;
  public
    { Public declarations }
    FShutdownOnLastRelease: Boolean;
    property ConnectionName: string read FConnectionName;

    procedure Loaded; override;
    procedure AfterOpenDB;
  end;

var
  frmURepGenAppMDImain: TfrmURepGenAppMDImain;

implementation

{$R *.DFM}

uses SendMsg, ComServ, FileUtil,fLoginDB, CommonVV, fURepMain, fURepFunc1, frAboutMe,
  dbgrids, fImport, fImpRun, Common, Slot, CmdPrms, AppInfo, QueryEx, GridEx,
  ExcelEx, UserInfo, URepCmndLine;


procedure TfrmURepGenAppMDImain.Loaded;
var
  connectionname, user, psw: string;
begin
  FCaption := Caption;
  Database1.LoginPrompt := False;

  FSBctrl:=TSBctrl.Create(StatusBar);
  StatusBar.Visible:=true;
  SetURepScrollBarControl(FSBctrl);

  if ComServer.StartMode=smAutomation then
    begin
    Menu := EmptyMenu;
    WindowState := wsMinimized;
    Application.Minimize;
    Application.ProcessMessages;
    Database1.Connected := False;
    ComServer.OnLastRelease := OLEServerLastReleaseEvent;
    end
  else
    begin
    if ParamCount>0 then
      begin
      if (GetCmdParam('h')<>'') or
         (GetCmdParam('?')<>'') then
        begin
        PostMessage(self.Handle,WM_VIEW_HELPKEY,0,0);
        Exit;
        end;

      connectionname:=GetCmdParam('cn');
      user:=GetCmdParam('u');
      if user='' then user:=GetCmdParam('l');
      psw := GetCmdParam('p');

      if (connectionname<>'') and (connectionname<>'ON') and
         (user<>'') and (user<>'ON') and
         (psw<>'') and (psw<>'ON') then
        begin
        ConnectSlient(Database1, connectionname, user, psw);
        if Database1.Connected then FConnectionName:= connectionname;
        CmndLineRunScriptOrImport;
        end
      else
        begin
        FConnectionName:=OnLoadedFormLoginDB(Database1, False);
        end;
      end
    else
      begin
      FConnectionName:=OnLoadedFormLoginDB(Database1, False);
      end;

    MailSlotCreate;
    if Database1.Connected then AfterOpenDB;
    end;

  inherited Loaded;
end;


procedure TfrmURepGenAppMDImain.FormCreate(Sender: TObject);
begin
  FShutdownOnLastRelease := False;
  DateUtil.FourDigitYear := True;
end;


procedure TfrmURepGenAppMDImain.Database1AfterConnect(Sender: TObject);
var
  Fserver, Fdatabase: string;
begin
  Fserver := Database1.Params.Values[cnstDBparamServerName];
  Fdatabase := Database1.Params.Values[cnstDBparamDatabaseName];
  SmartStatusBarPanelText(StatusBar, 0, GetLoginName);
  SmartStatusBarPanelText(StatusBar, 1, ': '+Fserver);
  SmartStatusBarPanelText(StatusBar, 2, ': '+Fdatabase);
  Refresh;
  mnuCloseDB.Enabled := True;
  mnuURepMainWin.Enabled := True;
  mnuImpRun.Enabled := True;
  mnuImpSet.Enabled := True;
  mnuSendSlot1.Enabled := True;
  mnuOpenDB.Enabled := False;
  URepGetParamPrefix;
  if URepIsAdmin(True) then
    mnuImpSet.Enabled := True
  else
    mnuImpSet.Enabled := False;
end;

procedure TfrmURepGenAppMDImain.AfterOpenDB;
begin
  Caption := FCaption+' /'+FConnectionName+'/';
  if ComServer.StartMode=smStandalone then
    PostMessage(self.Handle,WM_GET_REPORTS,0,0);
end;

procedure TfrmURepGenAppMDImain.mnuWinCaskClick(Sender: TObject);
begin
  Cascade;
end;

procedure TfrmURepGenAppMDImain.mnuWinTileClick(Sender: TObject);
begin
  Tile;
end;

procedure TfrmURepGenAppMDImain.mnuWinArrangeIconsClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TfrmURepGenAppMDImain.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmURepGenAppMDImain.mnuOpenDBClick(Sender: TObject);
begin
  FConnectionName:=OnLoadedFormLoginDB(Database1, False);
  if Database1.Connected then
    AfterOpenDB;
end;

procedure TfrmURepGenAppMDImain.mnuCloseDBClick(Sender: TObject);
var
  i: integer;
begin
  if Database1.Connected then
    begin
    Database1.Close;
    Caption := FCaption;
    SmartStatusBarPanelText(StatusBar, 0, '');
    SmartStatusBarPanelText(StatusBar, 1, '');
    SmartStatusBarPanelText(StatusBar, 2, '');
    Perform(WM_PAINT,0,0);
    Application.ProcessMessages;
    ClearFullLoginName;
    mnuCloseDB.Enabled := False;
    mnuURepMainWin.Enabled := False;
    mnuImpRun.Enabled := False;
    mnuImpSet.Enabled := False;
    mnuSendSlot1.Enabled := False;
    mnuOpenDB.Enabled := True;
    for i:=0 to Forms.Application.MainForm.MDIChildCount-1 do
      if (Forms.Application.MainForm.MDIChildren[i] is TForm) then
        PostMessage((Forms.Application.MainForm.MDIChildren[i] as TForm).Handle,WM_CLOSE,0,0);
    end;
end;

procedure TfrmURepGenAppMDImain.mnuExit2Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmURepGenAppMDImain.mnuURepMainWinClick(Sender: TObject);
begin
  GetOneForm(TfrmURepMain);
end;


procedure TfrmURepGenAppMDImain.mnuAboutClick(Sender: TObject);
var
  dlgAbout: TdlgAbout;
begin
  dlgAbout:= TdlgAbout.Create(Self);
  dlgAbout.ShowModal;
  dlgAbout.Release;
end;

procedure TfrmURepGenAppMDImain.mnFindClick(Sender: TObject);
begin
  FindRecord(Screen.ActiveControl);
end;

procedure TfrmURepGenAppMDImain.mnSortOrderClick(Sender: TObject);
begin
  SortQuery(Screen.ActiveControl);
end;

procedure TfrmURepGenAppMDImain.mnFilterClick(Sender: TObject);
begin
  if Screen.ActiveControl is TDBGrid then
    FilterDataSet(Screen.ActiveControl as TDBGrid);
end;

procedure TfrmURepGenAppMDImain.mnRefreshAllClick(Sender: TObject);
var
  i:integer;
  aDataSet: TDataSet;
begin
  for i:=0 to Screen.ActiveForm.ComponentCount-1 do
   if Screen.ActiveForm.Components[i] is TDataSet then
    begin
    aDataSet := TDataSet(Screen.ActiveForm.Components[i]);
    if aDataSet.Active then
      begin
      ReQueryOne(aDataSet);
      end;
    end;
end;

procedure TfrmURepGenAppMDImain.mnSumGridColClick(Sender: TObject);
begin
  if Screen.ActiveControl is TDBGrid then
    ShowSummGridColumn(Screen.ActiveControl as TDBGrid);
end;

procedure TfrmURepGenAppMDImain.mnInfoClick(Sender: TObject);
begin
//
end;

procedure TfrmURepGenAppMDImain.mnToExcelClick(Sender: TObject);
begin
  FormToExcel(Screen.ActiveForm);
end;

procedure TfrmURepGenAppMDImain.mnDeleteINIClick(Sender: TObject);
var
   regIniFile : TRegIniFile;
begin
  DeleteFile(GetWindowsDir+'\'+GetDefaultIniName);

  regIniFile := TRegIniFile.Create(GetDefaultIniRegKey);
  try
    regIniFile.EraseSection('');
  finally
    regIniFile.Free;
  end;
end;

procedure TfrmURepGenAppMDImain.mnDeleINIAfterCloseClick(Sender: TObject);
begin
   if mnDeleINIAfterClose.Checked
     then mnDeleINIAfterClose.Checked:=false
     else mnDeleINIAfterClose.Checked:=true;
end;

procedure TfrmURepGenAppMDImain.FormDestroy(Sender: TObject);
begin
  if mnDeleINIAfterClose.Checked then mnDeleteINIClick(nil);
end;

procedure TfrmURepGenAppMDImain.mnuSendSlot1Click(Sender: TObject);
begin
  GetOneForm(TfmSendMessage);
end;

procedure TfrmURepGenAppMDImain.GetReports(var Msg:TMessage);
begin
  GetOneForm(TfrmURepMain);
end;

procedure TfrmURepGenAppMDImain.OLEServerLastReleaseEvent(var Shutdown: Boolean);
begin
  Shutdown := FShutdownOnLastRelease;
end;

procedure TfrmURepGenAppMDImain.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  mnuCloseDBClick(nil);
  CanClose := True;
end;

procedure TfrmURepGenAppMDImain.ViewHelpKey(var Msg:TMessage);
begin
  WarningMsg('    :'#13#10+
             '  URepGenApp /s:<server> /db:<database> /l:<login> /p:<password>'#13#10+
             '    (  l    u)');
end;

procedure TfrmURepGenAppMDImain.mnuImpSetClick(Sender: TObject);
begin
  GetOneForm(TfrmImportSet);
end;

procedure TfrmURepGenAppMDImain.mnuImpRunClick(Sender: TObject);
begin
  GetOneForm(TfrmImportRun);
end;

procedure TfrmURepGenAppMDImain.N4Click(Sender: TObject);
begin
  ChangePasswordDlg(True, True, Database1);
end;

procedure TfrmURepGenAppMDImain.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  if FSBctrl<>nil then FSBctrl.DrawStatus(Rect);
end;

procedure TfrmURepGenAppMDImain.Timer1Timer(Sender: TObject);
begin
  FSBctrl.Text:= IntToStr(System.AllocMemSize);
  FSBctrl.Repaint;
end;


end.
